/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 27 "./yacc.y"


#ifdef HAVE_CONFIG_H
#include "cocom-config.h"
#else /* In this case we are oriented to ANSI C */
#ifndef HAVE_ASSERT_H
#define HAVE_ASSERT_H
#endif
#ifndef HAVE_LIMITS_H
#define HAVE_LIMITS_H
#endif
#endif /* #ifdef HAVE_CONFIG_H */


#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "position.h"
#include "errors.h"
#include "ird.h"
#include "common.h"
#include "tab.h"
#include "yacc.h"

#ifdef HAVE_ASSERT_H
#include <assert.h>
#else
#ifndef assert
#define assert(code) do { if (code == 0) abort ();} while (0)
#endif
#endif

#ifdef HAVE_LIMITS_H
#include <limits.h>
#else
#ifndef CHAR_BIT
#define CHAR_BIT 8
#endif
#ifndef UCHAR_MAX
#define UCHAR_MAX 255
#endif
#ifndef SCHAR_MAX
#define SCHAR_MAX 127
#endif
#ifndef SCHAR_MIN
#define SCHAR_MIN (-128)
#endif
#ifndef USHRT_MAX
#define USHRT_MAX 65535
#endif
#ifndef SHRT_MAX
#define SHRT_MAX 32767
#endif  
#ifndef SHRT_MIN
#define SHRT_MIN (-32768)
#endif
#ifndef UINT_MAX
#define UINT_MAX (INT_MAX * 2U + 1)
#endif
#ifndef INT_MAX
#define INT_MAX 2147483647
#endif  
#ifndef INT_MIN
#define INT_MIN (-INT_MAX-1)
#endif
#endif


/* The following variables and forward definitions of functions are
   used in actions of YACC grammar. */

/* The following variable value is begin position of the last lexema returned
   by the function `yylex'. */

static position_t current_lexema_position;

static IR_node_t form_new_sequence (IR_node_t cyclic_sequence,
                                    IR_node_t last_code_insertion_atom);

static void syntax_error (const char *s);


#line 155 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    IDENTIFIER_OR_LITERAL = 258,   /* IDENTIFIER_OR_LITERAL  */
    C_IDENTIFIER = 259,            /* C_IDENTIFIER  */
    NUMBER = 260,                  /* NUMBER  */
    STRING = 261,                  /* STRING  */
    CODE_INSERTION = 262,          /* CODE_INSERTION  */
    YACC_CODE_INSERTION = 263,     /* YACC_CODE_INSERTION  */
    ADDITIONAL_C_CODE = 264,       /* ADDITIONAL_C_CODE  */
    LEFT = 265,                    /* LEFT  */
    RIGHT = 266,                   /* RIGHT  */
    NONASSOC = 267,                /* NONASSOC  */
    TOKEN = 268,                   /* TOKEN  */
    PREC = 269,                    /* PREC  */
    TYPE = 270,                    /* TYPE  */
    START = 271,                   /* START  */
    UNION = 272,                   /* UNION  */
    LOCAL = 273,                   /* LOCAL  */
    IMPORT = 274,                  /* IMPORT  */
    EXPORT = 275,                  /* EXPORT  */
    SCANNER = 276,                 /* SCANNER  */
    EXPECT = 277,                  /* EXPECT  */
    CP = 278,                      /* CP  */
    LA = 279,                      /* LA  */
    PERCENTS = 280,                /* PERCENTS  */
    SEMICOLON = 281,               /* SEMICOLON  */
    BAR = 282,                     /* BAR  */
    SLASH = 283,                   /* SLASH  */
    STAR = 284,                    /* STAR  */
    PLUS = 285,                    /* PLUS  */
    LESS = 286,                    /* LESS  */
    GREATER = 287,                 /* GREATER  */
    LEFT_PARENTHESIS = 288,        /* LEFT_PARENTHESIS  */
    RIGHT_PARENTHESIS = 289,       /* RIGHT_PARENTHESIS  */
    LEFT_SQUARE_BRACKET = 290,     /* LEFT_SQUARE_BRACKET  */
    RIGHT_SQUARE_BRACKET = 291,    /* RIGHT_SQUARE_BRACKET  */
    AT = 292,                      /* AT  */
    RANGE = 293,                   /* RANGE  */
    RANGE_NO_LEFT_BOUND = 294,     /* RANGE_NO_LEFT_BOUND  */
    RANGE_NO_RIGHT_BOUND = 295,    /* RANGE_NO_RIGHT_BOUND  */
    RANGE_NO_LEFT_RIGHT_BOUNDS = 296 /* RANGE_NO_LEFT_RIGHT_BOUNDS  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define IDENTIFIER_OR_LITERAL 258
#define C_IDENTIFIER 259
#define NUMBER 260
#define STRING 261
#define CODE_INSERTION 262
#define YACC_CODE_INSERTION 263
#define ADDITIONAL_C_CODE 264
#define LEFT 265
#define RIGHT 266
#define NONASSOC 267
#define TOKEN 268
#define PREC 269
#define TYPE 270
#define START 271
#define UNION 272
#define LOCAL 273
#define IMPORT 274
#define EXPORT 275
#define SCANNER 276
#define EXPECT 277
#define CP 278
#define LA 279
#define PERCENTS 280
#define SEMICOLON 281
#define BAR 282
#define SLASH 283
#define STAR 284
#define PLUS 285
#define LESS 286
#define GREATER 287
#define LEFT_PARENTHESIS 288
#define RIGHT_PARENTHESIS 289
#define LEFT_SQUARE_BRACKET 290
#define RIGHT_SQUARE_BRACKET 291
#define AT 292
#define RANGE 293
#define RANGE_NO_LEFT_BOUND 294
#define RANGE_NO_RIGHT_BOUND 295
#define RANGE_NO_LEFT_RIGHT_BOUNDS 296

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 116 "./yacc.y"

  IR_node_t node;
  position_t position;
  struct
    {
      IR_node_t code_insertion;
      IR_node_t precedence_identifier_or_literal;
      IR_node_t look_ahead_number; 
    } precedence_and_code_insertion_and_la;

#line 298 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_IDENTIFIER_OR_LITERAL = 3,      /* IDENTIFIER_OR_LITERAL  */
  YYSYMBOL_C_IDENTIFIER = 4,               /* C_IDENTIFIER  */
  YYSYMBOL_NUMBER = 5,                     /* NUMBER  */
  YYSYMBOL_STRING = 6,                     /* STRING  */
  YYSYMBOL_CODE_INSERTION = 7,             /* CODE_INSERTION  */
  YYSYMBOL_YACC_CODE_INSERTION = 8,        /* YACC_CODE_INSERTION  */
  YYSYMBOL_ADDITIONAL_C_CODE = 9,          /* ADDITIONAL_C_CODE  */
  YYSYMBOL_LEFT = 10,                      /* LEFT  */
  YYSYMBOL_RIGHT = 11,                     /* RIGHT  */
  YYSYMBOL_NONASSOC = 12,                  /* NONASSOC  */
  YYSYMBOL_TOKEN = 13,                     /* TOKEN  */
  YYSYMBOL_PREC = 14,                      /* PREC  */
  YYSYMBOL_TYPE = 15,                      /* TYPE  */
  YYSYMBOL_START = 16,                     /* START  */
  YYSYMBOL_UNION = 17,                     /* UNION  */
  YYSYMBOL_LOCAL = 18,                     /* LOCAL  */
  YYSYMBOL_IMPORT = 19,                    /* IMPORT  */
  YYSYMBOL_EXPORT = 20,                    /* EXPORT  */
  YYSYMBOL_SCANNER = 21,                   /* SCANNER  */
  YYSYMBOL_EXPECT = 22,                    /* EXPECT  */
  YYSYMBOL_CP = 23,                        /* CP  */
  YYSYMBOL_LA = 24,                        /* LA  */
  YYSYMBOL_PERCENTS = 25,                  /* PERCENTS  */
  YYSYMBOL_SEMICOLON = 26,                 /* SEMICOLON  */
  YYSYMBOL_BAR = 27,                       /* BAR  */
  YYSYMBOL_SLASH = 28,                     /* SLASH  */
  YYSYMBOL_STAR = 29,                      /* STAR  */
  YYSYMBOL_PLUS = 30,                      /* PLUS  */
  YYSYMBOL_LESS = 31,                      /* LESS  */
  YYSYMBOL_GREATER = 32,                   /* GREATER  */
  YYSYMBOL_LEFT_PARENTHESIS = 33,          /* LEFT_PARENTHESIS  */
  YYSYMBOL_RIGHT_PARENTHESIS = 34,         /* RIGHT_PARENTHESIS  */
  YYSYMBOL_LEFT_SQUARE_BRACKET = 35,       /* LEFT_SQUARE_BRACKET  */
  YYSYMBOL_RIGHT_SQUARE_BRACKET = 36,      /* RIGHT_SQUARE_BRACKET  */
  YYSYMBOL_AT = 37,                        /* AT  */
  YYSYMBOL_RANGE = 38,                     /* RANGE  */
  YYSYMBOL_RANGE_NO_LEFT_BOUND = 39,       /* RANGE_NO_LEFT_BOUND  */
  YYSYMBOL_RANGE_NO_RIGHT_BOUND = 40,      /* RANGE_NO_RIGHT_BOUND  */
  YYSYMBOL_RANGE_NO_LEFT_RIGHT_BOUNDS = 41, /* RANGE_NO_LEFT_RIGHT_BOUNDS  */
  YYSYMBOL_YYACCEPT = 42,                  /* $accept  */
  YYSYMBOL_description = 43,               /* description  */
  YYSYMBOL_tail = 44,                      /* tail  */
  YYSYMBOL_definitions = 45,               /* definitions  */
  YYSYMBOL_definition_tail = 46,           /* definition_tail  */
  YYSYMBOL_definition_semicolon_list = 47, /* definition_semicolon_list  */
  YYSYMBOL_definition = 48,                /* definition  */
  YYSYMBOL_49_1 = 49,                      /* @1  */
  YYSYMBOL_50_2 = 50,                      /* @2  */
  YYSYMBOL_51_3 = 51,                      /* @3  */
  YYSYMBOL_52_4 = 52,                      /* @4  */
  YYSYMBOL_53_5 = 53,                      /* @5  */
  YYSYMBOL_54_6 = 54,                      /* @6  */
  YYSYMBOL_symbol_list_start = 55,         /* symbol_list_start  */
  YYSYMBOL_tag = 56,                       /* tag  */
  YYSYMBOL_symbol_list = 57,               /* symbol_list  */
  YYSYMBOL_symbol = 58,                    /* symbol  */
  YYSYMBOL_rules = 59,                     /* rules  */
  YYSYMBOL_rule = 60,                      /* rule  */
  YYSYMBOL_61_7 = 61,                      /* @7  */
  YYSYMBOL_pattern = 62,                   /* pattern  */
  YYSYMBOL_alternatives = 63,              /* alternatives  */
  YYSYMBOL_alternative = 64,               /* alternative  */
  YYSYMBOL_65_8 = 65,                      /* @8  */
  YYSYMBOL_fix_position = 66,              /* fix_position  */
  YYSYMBOL_sequence = 67,                  /* sequence  */
  YYSYMBOL_sequence_element = 68,          /* sequence_element  */
  YYSYMBOL_nonamed_sequence_element = 69,  /* nonamed_sequence_element  */
  YYSYMBOL_70_9 = 70,                      /* @9  */
  YYSYMBOL_code_insertion_tail = 71,       /* code_insertion_tail  */
  YYSYMBOL_code_insertion_semicolon_list = 72, /* code_insertion_semicolon_list  */
  YYSYMBOL_unit = 73,                      /* unit  */
  YYSYMBOL_74_10 = 74,                     /* @10  */
  YYSYMBOL_75_11 = 75,                     /* @11  */
  YYSYMBOL_76_12 = 76,                     /* @12  */
  YYSYMBOL_77_13 = 77,                     /* @13  */
  YYSYMBOL_78_14 = 78,                     /* @14  */
  YYSYMBOL_prec_la = 79,                   /* prec_la  */
  YYSYMBOL_semicolons = 80                 /* semicolons  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   88

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  42
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  39
/* YYNRULES -- Number of rules.  */
#define YYNRULES  87
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  120

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   296


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   182,   182,   208,   209,   212,   213,   226,   233,   234,
     238,   251,   255,   254,   262,   262,   266,   270,   270,   274,
     274,   278,   278,   282,   287,   287,   291,   308,   313,   318,
     323,   329,   336,   337,   340,   346,   355,   359,   367,   374,
     394,   394,   398,   405,   418,   425,   433,   442,   441,   459,
     462,   463,   479,   484,   485,   494,   493,   502,   508,   514,
     520,   524,   525,   543,   544,   548,   547,   555,   560,   565,
     564,   573,   572,   582,   581,   591,   590,   602,   607,   613,
     620,   628,   636,   644,   653,   663,   675,   676
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"",
  "IDENTIFIER_OR_LITERAL", "C_IDENTIFIER", "NUMBER", "STRING",
  "CODE_INSERTION", "YACC_CODE_INSERTION", "ADDITIONAL_C_CODE", "LEFT",
  "RIGHT", "NONASSOC", "TOKEN", "PREC", "TYPE", "START", "UNION", "LOCAL",
  "IMPORT", "EXPORT", "SCANNER", "EXPECT", "CP", "LA", "PERCENTS",
  "SEMICOLON", "BAR", "SLASH", "STAR", "PLUS", "LESS", "GREATER",
  "LEFT_PARENTHESIS", "RIGHT_PARENTHESIS", "LEFT_SQUARE_BRACKET",
  "RIGHT_SQUARE_BRACKET", "AT", "RANGE", "RANGE_NO_LEFT_BOUND",
  "RANGE_NO_RIGHT_BOUND", "RANGE_NO_LEFT_RIGHT_BOUNDS", "$accept",
  "description", "tail", "definitions", "definition_tail",
  "definition_semicolon_list", "definition", "@1", "@2", "@3", "@4", "@5",
  "@6", "symbol_list_start", "tag", "symbol_list", "symbol", "rules",
  "rule", "@7", "pattern", "alternatives", "alternative", "@8",
  "fix_position", "sequence", "sequence_element",
  "nonamed_sequence_element", "@9", "code_insertion_tail",
  "code_insertion_semicolon_list", "unit", "@10", "@11", "@12", "@13",
  "@14", "prec_la", "semicolons", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-91)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-4)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -91,     5,    23,   -91,   -91,   -91,   -91,   -91,   -91,   -91,
     -91,   -91,   -91,   -91,   -91,   -91,   -91,   -91,     6,    -7,
     -19,    20,    22,    30,    39,    40,    48,   -91,   -91,    13,
     -91,   -91,   -91,    28,    52,    53,   -91,   -91,   -91,   -91,
     -91,   -91,   -91,   -91,   -91,   -91,    31,   -91,    26,    54,
      53,   -91,   -91,    33,   -91,   -91,    31,   -91,   -91,   -91,
     -91,   -91,    -3,   -91,    11,   -91,    35,    59,   -91,    58,
     -91,   -91,   -91,    27,   -14,    37,   -91,   -91,   -91,   -91,
     -91,   -91,    41,    -6,    -5,   -91,   -91,    63,   -91,   -91,
     -91,    65,    66,    67,    68,   -91,    35,    69,    35,    70,
      38,    42,   -91,   -91,   -91,   -91,   -91,   -91,   -91,    72,
     -91,    73,   -91,   -91,    -3,    35,    35,   -91,   -91,   -91
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       5,     0,     0,     1,     7,    16,    28,    29,    30,    27,
      31,    12,    14,    17,    19,    21,    23,    24,     0,     8,
      32,     0,     0,     0,     0,     0,     0,    42,    40,     0,
      86,    10,     6,     9,     0,     0,    13,    15,    18,    20,
      22,    25,    49,     4,     2,    86,    38,    11,     0,    36,
      26,    34,    41,    43,    45,    50,    39,    87,    33,    37,
      35,    49,    77,    44,    67,    68,    61,     0,    52,     0,
      65,    55,    51,    53,    60,    46,    69,    71,    73,    75,
      63,    59,    62,    78,    80,    49,    49,     0,    57,    58,
      47,     0,     0,     0,     0,    64,    61,     0,    61,     0,
       0,     0,    54,    50,    70,    72,    74,    76,    79,    81,
      83,    82,    66,    56,    77,    61,    61,    48,    84,    85
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -91,   -91,   -91,   -91,   -91,   -91,   -91,   -91,   -91,   -91,
     -91,   -91,   -91,   -91,   -91,   -91,    25,   -91,    47,   -91,
     -58,   -91,    16,   -91,   -91,   -22,   -91,   -91,   -91,   -90,
     -91,   -91,   -91,   -91,   -91,   -91,   -91,   -32,    43
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     1,    44,     2,    32,    33,    19,    21,    22,    23,
      24,    25,    26,    20,    35,    50,    51,    29,    30,    42,
      52,    53,    54,   103,    55,    62,    72,    73,    86,    81,
      82,    74,    85,    91,    92,    93,    94,    75,    46
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      64,    96,    98,    65,    66,     3,   108,    27,   110,    99,
      28,    67,    34,    -3,    27,    88,    89,    28,    97,    31,
      68,    69,    43,    36,     4,   118,   119,   100,   101,    37,
      70,     5,    71,     6,     7,     8,     9,    38,    10,    11,
      12,    13,    14,    15,    16,    17,    39,    40,    18,    76,
      77,    78,    79,    41,    47,    48,    49,    57,    58,    59,
      61,    80,    83,    84,    87,    90,   102,    95,   104,   105,
     106,   107,   112,   111,   109,    60,    45,    63,   113,   115,
     116,   114,   117,     0,     0,     0,     0,     0,    56
};

static const yytype_int8 yycheck[] =
{
       3,     7,     7,     6,     7,     0,    96,     1,    98,    14,
       4,    14,    31,     0,     1,    29,    30,     4,    24,    26,
      23,    24,     9,     3,     1,   115,   116,    85,    86,     7,
      33,     8,    35,    10,    11,    12,    13,     7,    15,    16,
      17,    18,    19,    20,    21,    22,     7,     7,    25,    38,
      39,    40,    41,     5,    26,     3,     3,    26,    32,     5,
      27,    26,     3,     5,    37,    28,     3,    26,     3,     3,
       3,     3,    34,     3,     5,    50,    29,    61,    36,     7,
       7,   103,   114,    -1,    -1,    -1,    -1,    -1,    45
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    43,    45,     0,     1,     8,    10,    11,    12,    13,
      15,    16,    17,    18,    19,    20,    21,    22,    25,    48,
      55,    49,    50,    51,    52,    53,    54,     1,     4,    59,
      60,    26,    46,    47,    31,    56,     3,     7,     7,     7,
       7,     5,    61,     9,    44,    60,    80,    26,     3,     3,
      57,    58,    62,    63,    64,    66,    80,    26,    32,     5,
      58,    27,    67,    64,     3,     6,     7,    14,    23,    24,
      33,    35,    68,    69,    73,    79,    38,    39,    40,    41,
      26,    71,    72,     3,     5,    74,    70,    37,    29,    30,
      28,    75,    76,    77,    78,    26,     7,    24,     7,    14,
      62,    62,     3,    65,     3,     3,     3,     3,    71,     5,
      71,     3,    34,    36,    67,     7,     7,    79,    71,    71
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    42,    43,    44,    44,    45,    45,    45,    46,    46,
      47,    47,    49,    48,    50,    48,    48,    51,    48,    52,
      48,    53,    48,    48,    54,    48,    48,    55,    55,    55,
      55,    55,    56,    56,    57,    57,    58,    58,    59,    59,
      61,    60,    60,    62,    63,    63,    64,    65,    64,    66,
      67,    67,    68,    68,    68,    70,    69,    69,    69,    69,
      69,    71,    71,    72,    72,    74,    73,    73,    73,    75,
      73,    76,    73,    77,    73,    78,    73,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    80,    80
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     4,     0,     1,     0,     3,     2,     0,     1,
       1,     2,     0,     3,     0,     3,     1,     0,     3,     0,
       3,     0,     3,     1,     0,     3,     3,     1,     1,     1,
       1,     1,     0,     3,     1,     2,     1,     2,     2,     3,
       0,     3,     1,     1,     3,     1,     3,     0,     7,     0,
       0,     2,     1,     1,     3,     0,     4,     2,     2,     2,
       1,     0,     1,     1,     2,     0,     4,     1,     1,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     2,     4,
       2,     4,     4,     4,     6,     6,     0,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* description: definitions PERCENTS rules tail  */
#line 183 "./yacc.y"
                 {
                   IR_node_t first_definition;
                   IR_node_t first_rule;
                   position_t position;

                   /* Transform cyclic definition list to usual list. */
                   if ((yyvsp[-3].node) != NULL)
                     {
                       first_definition = IR_next_definition ((yyvsp[-3].node));
                       IR_set_next_definition ((yyvsp[-3].node), NULL);
                       (yyvsp[-3].node) = first_definition;
                     }
                   /* Transform cyclic rule list to usual list. */
                   if ((yyvsp[-1].node) != NULL)
                     {
                       first_rule = IR_next_rule ((yyvsp[-1].node));
                       IR_set_next_rule ((yyvsp[-1].node), NULL);
                       (yyvsp[-1].node) = first_rule;
                     }
                   position.column_number = 1;
                   position.line_number = 1;
                   description = IR_new_description (position, (yyvsp[-3].node), (yyvsp[-1].node), (yyvsp[0].node));
                 }
#line 1463 "y.tab.c"
    break;

  case 3: /* tail: %empty  */
#line 208 "./yacc.y"
                             {(yyval.node) = NULL;}
#line 1469 "y.tab.c"
    break;

  case 4: /* tail: ADDITIONAL_C_CODE  */
#line 209 "./yacc.y"
                             {(yyval.node) = (yyvsp[0].node);}
#line 1475 "y.tab.c"
    break;

  case 5: /* definitions: %empty  */
#line 212 "./yacc.y"
                             {(yyval.node) = NULL;}
#line 1481 "y.tab.c"
    break;

  case 6: /* definitions: definitions definition definition_tail  */
#line 214 "./yacc.y"
                 {
                   if ((yyvsp[-2].node) == NULL)
                     /* Make cycle. */
                     IR_set_next_definition ((yyvsp[-1].node), (yyvsp[-1].node));
                   else
                     {
                       /* Add element to cyclic list */
                       IR_set_next_definition ((yyvsp[-1].node), IR_next_definition ((yyvsp[-2].node)));
                       IR_set_next_definition ((yyvsp[-2].node), (yyvsp[-1].node));
                     }
                   (yyval.node) = (yyvsp[-1].node);
                 }
#line 1498 "y.tab.c"
    break;

  case 7: /* definitions: definitions error  */
#line 227 "./yacc.y"
                 {
                   syntax_error ("syntax error in declaration");
                   (yyval.node) = (yyvsp[-1].node);  /* Ignore error declaration. */
                 }
#line 1507 "y.tab.c"
    break;

  case 10: /* definition_semicolon_list: SEMICOLON  */
#line 239 "./yacc.y"
    {
      if (yacc_input_flag)
        {
          if (strict_flag)
            error (FALSE, current_lexema_position,
                   "POSIX YACC prohibits ';' after a definition");
          else if (!w_flag)
            warning
              (current_lexema_position,
               "warning: POSIX YACC prohibits ';' after a definition");
        }
    }
#line 1524 "y.tab.c"
    break;

  case 12: /* @1: %empty  */
#line 255 "./yacc.y"
                 {
                   (yyval.position) = current_lexema_position;
                 }
#line 1532 "y.tab.c"
    break;

  case 13: /* definition: START @1 IDENTIFIER_OR_LITERAL  */
#line 259 "./yacc.y"
                 {
                   (yyval.node) = IR_new_start_definition ((yyvsp[-1].position), NULL, (yyvsp[0].node));
                 }
#line 1540 "y.tab.c"
    break;

  case 14: /* @2: %empty  */
#line 262 "./yacc.y"
                      {(yyval.position) = current_lexema_position;}
#line 1546 "y.tab.c"
    break;

  case 15: /* definition: UNION @2 CODE_INSERTION  */
#line 263 "./yacc.y"
                 {
                   (yyval.node) = IR_new_union_code ((yyvsp[-1].position), NULL, (yyvsp[0].node));
                 }
#line 1554 "y.tab.c"
    break;

  case 16: /* definition: YACC_CODE_INSERTION  */
#line 267 "./yacc.y"
                 {
                   (yyval.node) = IR_new_yacc_code (current_lexema_position, NULL, (yyvsp[0].node));
                 }
#line 1562 "y.tab.c"
    break;

  case 17: /* @3: %empty  */
#line 270 "./yacc.y"
                      {(yyval.position) = current_lexema_position;}
#line 1568 "y.tab.c"
    break;

  case 18: /* definition: LOCAL @3 CODE_INSERTION  */
#line 271 "./yacc.y"
                 {
                   (yyval.node) = IR_new_local_code ((yyvsp[-1].position), NULL, (yyvsp[0].node));
                 }
#line 1576 "y.tab.c"
    break;

  case 19: /* @4: %empty  */
#line 274 "./yacc.y"
                      {(yyval.position) = current_lexema_position;}
#line 1582 "y.tab.c"
    break;

  case 20: /* definition: IMPORT @4 CODE_INSERTION  */
#line 275 "./yacc.y"
                 {
                   (yyval.node) = IR_new_import_code ((yyvsp[-1].position), NULL, (yyvsp[0].node));
                 }
#line 1590 "y.tab.c"
    break;

  case 21: /* @5: %empty  */
#line 278 "./yacc.y"
                      {(yyval.position) = current_lexema_position;}
#line 1596 "y.tab.c"
    break;

  case 22: /* definition: EXPORT @5 CODE_INSERTION  */
#line 279 "./yacc.y"
                 {
                   (yyval.node) = IR_new_export_code ((yyvsp[-1].position), NULL, (yyvsp[0].node));
                 }
#line 1604 "y.tab.c"
    break;

  case 23: /* definition: SCANNER  */
#line 283 "./yacc.y"
                 {
                   (yyval.node) = IR_new_scanner_definition
                          (current_lexema_position, NULL);
                 }
#line 1613 "y.tab.c"
    break;

  case 24: /* @6: %empty  */
#line 287 "./yacc.y"
                      {(yyval.position) = current_lexema_position;}
#line 1619 "y.tab.c"
    break;

  case 25: /* definition: EXPECT @6 NUMBER  */
#line 288 "./yacc.y"
                 {
                   (yyval.node) = IR_new_expect_definition ((yyvsp[-1].position), NULL, (yyvsp[0].node));
                 }
#line 1627 "y.tab.c"
    break;

  case 26: /* definition: symbol_list_start tag symbol_list  */
#line 292 "./yacc.y"
                 {
                   IR_node_t first_symbol;

                   /* Transform cyclic symbol list to usual list. */
                   if ((yyvsp[0].node) != NULL)
                     {
                       first_symbol = IR_next_symbol ((yyvsp[0].node));
                       IR_set_next_symbol ((yyvsp[0].node), NULL);
                       (yyvsp[0].node) = first_symbol;
                     }
                   IR_set_symbol_list ((yyvsp[-2].node), (yyvsp[0].node));
                   IR_set_tag ((yyvsp[-2].node), (yyvsp[-1].node));
                   (yyval.node) = (yyvsp[-2].node);
                 }
#line 1646 "y.tab.c"
    break;

  case 27: /* symbol_list_start: TOKEN  */
#line 309 "./yacc.y"
                      {
                        (yyval.node) = IR_new_token_definition (current_lexema_position,
                                                      NULL, NULL, NULL);
                      }
#line 1655 "y.tab.c"
    break;

  case 28: /* symbol_list_start: LEFT  */
#line 314 "./yacc.y"
                      {
                        (yyval.node) = IR_new_left_definition (current_lexema_position,
                                                     NULL, NULL, NULL);
                      }
#line 1664 "y.tab.c"
    break;

  case 29: /* symbol_list_start: RIGHT  */
#line 319 "./yacc.y"
                      {
                        (yyval.node) = IR_new_right_definition (current_lexema_position,
                                                      NULL, NULL, NULL);
                      }
#line 1673 "y.tab.c"
    break;

  case 30: /* symbol_list_start: NONASSOC  */
#line 324 "./yacc.y"
                      {
                        (yyval.node)
                          = IR_new_nonassoc_definition
                            (current_lexema_position, NULL, NULL, NULL);
                      }
#line 1683 "y.tab.c"
    break;

  case 31: /* symbol_list_start: TYPE  */
#line 330 "./yacc.y"
                      {
                        (yyval.node) = IR_new_type_definition (current_lexema_position,
                                                     NULL, NULL, NULL);
                      }
#line 1692 "y.tab.c"
    break;

  case 32: /* tag: %empty  */
#line 336 "./yacc.y"
                                            {(yyval.node) = NULL;}
#line 1698 "y.tab.c"
    break;

  case 33: /* tag: LESS IDENTIFIER_OR_LITERAL GREATER  */
#line 337 "./yacc.y"
                                            {(yyval.node) = (yyvsp[-1].node);}
#line 1704 "y.tab.c"
    break;

  case 34: /* symbol_list: symbol  */
#line 341 "./yacc.y"
                {
                  /* Make cycle. */
                  IR_set_next_symbol ((yyvsp[0].node), (yyvsp[0].node));
                  (yyval.node) = (yyvsp[0].node);
                }
#line 1714 "y.tab.c"
    break;

  case 35: /* symbol_list: symbol_list symbol  */
#line 347 "./yacc.y"
                {
                  /* Add element to cyclic list */
                  IR_set_next_symbol ((yyvsp[0].node), IR_next_symbol ((yyvsp[-1].node)));
                  IR_set_next_symbol ((yyvsp[-1].node), (yyvsp[0].node));
                  (yyval.node) = (yyvsp[0].node);
                }
#line 1725 "y.tab.c"
    break;

  case 36: /* symbol: IDENTIFIER_OR_LITERAL  */
#line 356 "./yacc.y"
            {
              (yyval.node) = IR_new_symbol (IR_position ((yyvsp[0].node)), (yyvsp[0].node), NULL, NULL);
            }
#line 1733 "y.tab.c"
    break;

  case 37: /* symbol: IDENTIFIER_OR_LITERAL NUMBER  */
#line 360 "./yacc.y"
            {
              (yyval.node) = IR_new_symbol (IR_position ((yyvsp[-1].node)), (yyvsp[-1].node), (yyvsp[0].node), NULL);
            }
#line 1741 "y.tab.c"
    break;

  case 38: /* rules: rule semicolons  */
#line 368 "./yacc.y"
          {
            if ((yyvsp[-1].node) != NULL)
              /* NULL is possible because of syntax errors -- Make cycle. */
              IR_set_next_rule ((yyvsp[-1].node), (yyvsp[-1].node));
            (yyval.node) = (yyvsp[-1].node);
          }
#line 1752 "y.tab.c"
    break;

  case 39: /* rules: rules rule semicolons  */
#line 375 "./yacc.y"
          {
            if ((yyvsp[-1].node) == NULL)
              (yyval.node) = (yyvsp[-2].node);
            else
              {
                if ((yyvsp[-2].node) == NULL)
                  /* It is possible because of syntax errors -- Make cycle. */
                  IR_set_next_rule ((yyvsp[-1].node), (yyvsp[-1].node));
                else
                  {
                    /* Add element to cyclic list */
                    IR_set_next_rule ((yyvsp[-1].node), IR_next_rule ((yyvsp[-2].node)));
                    IR_set_next_rule ((yyvsp[-2].node), (yyvsp[-1].node));
                  }
                (yyval.node) = (yyvsp[-1].node);
              }
          }
#line 1774 "y.tab.c"
    break;

  case 40: /* @7: %empty  */
#line 394 "./yacc.y"
                    {(yyval.position) = current_lexema_position;}
#line 1780 "y.tab.c"
    break;

  case 41: /* rule: C_IDENTIFIER @7 pattern  */
#line 395 "./yacc.y"
         {
           (yyval.node) = IR_new_rule ((yyvsp[-1].position), (yyvsp[-2].node), (yyvsp[0].node), NULL);
         }
#line 1788 "y.tab.c"
    break;

  case 42: /* rule: error  */
#line 399 "./yacc.y"
         {
           syntax_error ("syntax error in rule");
           (yyval.node) = NULL;  /* Ignore error rule. */
         }
#line 1797 "y.tab.c"
    break;

  case 43: /* pattern: alternatives  */
#line 406 "./yacc.y"
            {
              IR_node_t first_alternative;
  
              /* Transform cyclic alternative list to usual list. */
              assert ((yyvsp[0].node) != NULL);
              first_alternative = IR_next_alternative ((yyvsp[0].node));
              IR_set_next_alternative ((yyvsp[0].node), NULL);
              (yyvsp[0].node) = first_alternative;
              (yyval.node) = IR_new_pattern (IR_position ((yyvsp[0].node)), (yyvsp[0].node));
            }
#line 1812 "y.tab.c"
    break;

  case 44: /* alternatives: alternatives BAR alternative  */
#line 419 "./yacc.y"
                 {
                   /* Add element to cyclic list */
                   (yyval.node) = (yyvsp[0].node);
                   IR_set_next_alternative ((yyval.node), IR_next_alternative ((yyvsp[-2].node)));
                   IR_set_next_alternative ((yyvsp[-2].node), (yyval.node));
                 }
#line 1823 "y.tab.c"
    break;

  case 45: /* alternatives: alternative  */
#line 426 "./yacc.y"
                 {
                   /* Make cyclic list. */
                   (yyval.node) = (yyvsp[0].node);
                   IR_set_next_alternative ((yyval.node), (yyval.node));
                 }
#line 1833 "y.tab.c"
    break;

  case 46: /* alternative: fix_position sequence prec_la  */
#line 434 "./yacc.y"
                {
                  (yyval.node) = IR_new_sequence ((yyvsp[-2].position), NULL,
                                        form_new_sequence ((yyvsp[-1].node),
                                                           (yyvsp[0].precedence_and_code_insertion_and_la).code_insertion),
                                        (yyvsp[0].precedence_and_code_insertion_and_la).precedence_identifier_or_literal,
					(yyvsp[0].precedence_and_code_insertion_and_la).look_ahead_number);
                }
#line 1845 "y.tab.c"
    break;

  case 47: /* @8: %empty  */
#line 442 "./yacc.y"
                {
                  (yyval.position) = current_lexema_position;
                }
#line 1853 "y.tab.c"
    break;

  case 48: /* alternative: fix_position sequence prec_la SLASH @8 sequence prec_la  */
#line 446 "./yacc.y"
                {
                  (yyval.node)
                    = IR_new_separator_iteration
                      ((yyvsp[-2].position), NULL,
                       form_new_sequence ((yyvsp[-5].node), (yyvsp[-4].precedence_and_code_insertion_and_la).code_insertion),
                       (yyvsp[-4].precedence_and_code_insertion_and_la).precedence_identifier_or_literal,
		       (yyvsp[-4].precedence_and_code_insertion_and_la).look_ahead_number,
                       form_new_sequence ((yyvsp[-1].node), (yyvsp[0].precedence_and_code_insertion_and_la).code_insertion),
                       (yyvsp[0].precedence_and_code_insertion_and_la).precedence_identifier_or_literal,
		       (yyvsp[0].precedence_and_code_insertion_and_la).look_ahead_number);
                }
#line 1869 "y.tab.c"
    break;

  case 49: /* fix_position: %empty  */
#line 459 "./yacc.y"
               {(yyval.position) = current_lexema_position;}
#line 1875 "y.tab.c"
    break;

  case 50: /* sequence: %empty  */
#line 462 "./yacc.y"
                                           {(yyval.node) = NULL;}
#line 1881 "y.tab.c"
    break;

  case 51: /* sequence: sequence sequence_element  */
#line 464 "./yacc.y"
             {
               if ((yyvsp[-1].node) == NULL)
                 /* It is possible because of syntax errors -- Make cycle. */
                 IR_set_next_sequence_element ((yyvsp[0].node), (yyvsp[0].node));
               else
                 {
                   /* Add element to cyclic list */
                   IR_set_next_sequence_element
                     ((yyvsp[0].node), IR_next_sequence_element ((yyvsp[-1].node)));
                   IR_set_next_sequence_element ((yyvsp[-1].node), (yyvsp[0].node));
                 }
               (yyval.node) = (yyvsp[0].node);
             }
#line 1899 "y.tab.c"
    break;

  case 52: /* sequence_element: CP  */
#line 480 "./yacc.y"
                      {
                        (yyval.node) = IR_new_control_point (current_lexema_position,
                                                   NULL, NULL);
                      }
#line 1908 "y.tab.c"
    break;

  case 53: /* sequence_element: nonamed_sequence_element  */
#line 484 "./yacc.y"
                                                                     {(yyval.node) = (yyvsp[0].node);}
#line 1914 "y.tab.c"
    break;

  case 54: /* sequence_element: nonamed_sequence_element AT IDENTIFIER_OR_LITERAL  */
#line 486 "./yacc.y"
                      {
                        IR_set_sequence_element_identifier ((yyvsp[-2].node), (yyvsp[0].node));
                        (yyval.node) = (yyvsp[-2].node);
                      }
#line 1923 "y.tab.c"
    break;

  case 55: /* @9: %empty  */
#line 494 "./yacc.y"
       {
         (yyval.position) = current_lexema_position;
       }
#line 1931 "y.tab.c"
    break;

  case 56: /* nonamed_sequence_element: LEFT_SQUARE_BRACKET @9 pattern RIGHT_SQUARE_BRACKET  */
#line 498 "./yacc.y"
       {
         (yyval.node) = IR_new_default ((yyvsp[-2].position), NULL,
                              NULL, (yyvsp[-1].node));
       }
#line 1940 "y.tab.c"
    break;

  case 57: /* nonamed_sequence_element: unit STAR  */
#line 503 "./yacc.y"
       {
         (yyval.node)
           = IR_new_star_iteration
             (current_lexema_position, NULL, NULL, (yyvsp[-1].node));
       }
#line 1950 "y.tab.c"
    break;

  case 58: /* nonamed_sequence_element: unit PLUS  */
#line 509 "./yacc.y"
       {
         (yyval.node)
           = IR_new_plus_iteration
             (current_lexema_position, NULL, NULL, (yyvsp[-1].node));
       }
#line 1960 "y.tab.c"
    break;

  case 59: /* nonamed_sequence_element: CODE_INSERTION code_insertion_tail  */
#line 515 "./yacc.y"
       {
         (yyval.node)
           = IR_new_code_insertion_atom
             (IR_position ((yyvsp[-1].node)), NULL, NULL, (yyvsp[-1].node));
       }
#line 1970 "y.tab.c"
    break;

  case 60: /* nonamed_sequence_element: unit  */
#line 520 "./yacc.y"
           {(yyval.node) = (yyvsp[0].node);}
#line 1976 "y.tab.c"
    break;

  case 62: /* code_insertion_tail: code_insertion_semicolon_list  */
#line 526 "./yacc.y"
       {
         if (yychar != C_IDENTIFIER
             && yychar != ADDITIONAL_C_CODE
             && yychar != 0 && yacc_input_flag)
           {
             if (strict_flag)
               error (FALSE, (yyvsp[0].position),
                      "POSIX YACC prohibits ';' after a code insertion");
             else if (!w_flag)
               warning
                 ((yyvsp[0].position),
                  "warning: POSIX YACC prohibits ';' after a code insertion");
           }
       }
#line 1995 "y.tab.c"
    break;

  case 63: /* code_insertion_semicolon_list: SEMICOLON  */
#line 543 "./yacc.y"
                                            {(yyval.position) = current_lexema_position;}
#line 2001 "y.tab.c"
    break;

  case 64: /* code_insertion_semicolon_list: code_insertion_semicolon_list SEMICOLON  */
#line 544 "./yacc.y"
                                            {(yyval.position) = (yyvsp[-1].position);}
#line 2007 "y.tab.c"
    break;

  case 65: /* @10: %empty  */
#line 548 "./yacc.y"
         {
           (yyval.position) = current_lexema_position;
         }
#line 2015 "y.tab.c"
    break;

  case 66: /* unit: LEFT_PARENTHESIS @10 pattern RIGHT_PARENTHESIS  */
#line 552 "./yacc.y"
         {
           (yyval.node) = IR_new_group ((yyvsp[-2].position), NULL, NULL, (yyvsp[-1].node));
         }
#line 2023 "y.tab.c"
    break;

  case 67: /* unit: IDENTIFIER_OR_LITERAL  */
#line 556 "./yacc.y"
         {
           (yyval.node) = IR_new_identifier_or_literal_atom (IR_position ((yyvsp[0].node)),
                                                   NULL, NULL, (yyvsp[0].node));
         }
#line 2032 "y.tab.c"
    break;

  case 68: /* unit: STRING  */
#line 561 "./yacc.y"
         {
           (yyval.node) = IR_new_string_atom (IR_position ((yyvsp[0].node)), NULL, NULL, (yyvsp[0].node));
         }
#line 2040 "y.tab.c"
    break;

  case 69: /* @11: %empty  */
#line 565 "./yacc.y"
         {
           (yyval.position) = current_lexema_position;
         }
#line 2048 "y.tab.c"
    break;

  case 70: /* unit: IDENTIFIER_OR_LITERAL RANGE @11 IDENTIFIER_OR_LITERAL  */
#line 569 "./yacc.y"
         {
           (yyval.node) = IR_new_range_atom ((yyvsp[-1].position), NULL, NULL, (yyvsp[-3].node), (yyvsp[0].node));
         }
#line 2056 "y.tab.c"
    break;

  case 71: /* @12: %empty  */
#line 573 "./yacc.y"
         {
           (yyval.position) = current_lexema_position;
         }
#line 2064 "y.tab.c"
    break;

  case 72: /* unit: IDENTIFIER_OR_LITERAL RANGE_NO_LEFT_BOUND @12 IDENTIFIER_OR_LITERAL  */
#line 577 "./yacc.y"
         {
           (yyval.node) = IR_new_range_no_left_bound_atom
                ((yyvsp[-1].position), NULL, NULL, (yyvsp[-3].node), (yyvsp[0].node));
         }
#line 2073 "y.tab.c"
    break;

  case 73: /* @13: %empty  */
#line 582 "./yacc.y"
         {
           (yyval.position) = current_lexema_position;
         }
#line 2081 "y.tab.c"
    break;

  case 74: /* unit: IDENTIFIER_OR_LITERAL RANGE_NO_RIGHT_BOUND @13 IDENTIFIER_OR_LITERAL  */
#line 586 "./yacc.y"
         {
           (yyval.node) = IR_new_range_no_right_bound_atom
                ((yyvsp[-1].position), NULL, NULL, (yyvsp[-3].node), (yyvsp[0].node));
         }
#line 2090 "y.tab.c"
    break;

  case 75: /* @14: %empty  */
#line 591 "./yacc.y"
         {
           (yyval.position) = current_lexema_position;
         }
#line 2098 "y.tab.c"
    break;

  case 76: /* unit: IDENTIFIER_OR_LITERAL RANGE_NO_LEFT_RIGHT_BOUNDS @14 IDENTIFIER_OR_LITERAL  */
#line 595 "./yacc.y"
         {
           (yyval.node) = IR_new_range_no_left_right_bounds_atom
                ((yyvsp[-1].position), NULL, NULL, (yyvsp[-3].node), (yyvsp[0].node));
         }
#line 2107 "y.tab.c"
    break;

  case 77: /* prec_la: %empty  */
#line 602 "./yacc.y"
            {
              (yyval.precedence_and_code_insertion_and_la).code_insertion = NULL;
              (yyval.precedence_and_code_insertion_and_la).precedence_identifier_or_literal = NULL;
              (yyval.precedence_and_code_insertion_and_la).look_ahead_number = NULL;
            }
#line 2117 "y.tab.c"
    break;

  case 78: /* prec_la: PREC IDENTIFIER_OR_LITERAL  */
#line 608 "./yacc.y"
            {
              (yyval.precedence_and_code_insertion_and_la).code_insertion = NULL;
              (yyval.precedence_and_code_insertion_and_la).precedence_identifier_or_literal = (yyvsp[0].node);
              (yyval.precedence_and_code_insertion_and_la).look_ahead_number = NULL;
            }
#line 2127 "y.tab.c"
    break;

  case 79: /* prec_la: PREC IDENTIFIER_OR_LITERAL CODE_INSERTION code_insertion_tail  */
#line 614 "./yacc.y"
            {
              (yyval.precedence_and_code_insertion_and_la).code_insertion = IR_new_code_insertion_atom (IR_position ((yyvsp[-1].node)),
                                                              NULL, NULL, (yyvsp[-1].node));
              (yyval.precedence_and_code_insertion_and_la).precedence_identifier_or_literal = (yyvsp[-2].node);
              (yyval.precedence_and_code_insertion_and_la).look_ahead_number = NULL;
            }
#line 2138 "y.tab.c"
    break;

  case 80: /* prec_la: LA NUMBER  */
#line 621 "./yacc.y"
            {
              (yyval.precedence_and_code_insertion_and_la).code_insertion = NULL;
              (yyval.precedence_and_code_insertion_and_la).precedence_identifier_or_literal = NULL;
              (yyval.precedence_and_code_insertion_and_la).look_ahead_number = (yyvsp[0].node);
	      if (max_look_ahead_number < IR_number_value ((yyvsp[0].node)))
		max_look_ahead_number = IR_number_value ((yyvsp[0].node));
            }
#line 2150 "y.tab.c"
    break;

  case 81: /* prec_la: PREC IDENTIFIER_OR_LITERAL LA NUMBER  */
#line 629 "./yacc.y"
            {
              (yyval.precedence_and_code_insertion_and_la).code_insertion = NULL;
              (yyval.precedence_and_code_insertion_and_la).precedence_identifier_or_literal = (yyvsp[-2].node);
              (yyval.precedence_and_code_insertion_and_la).look_ahead_number = (yyvsp[0].node);
	      if (max_look_ahead_number < IR_number_value ((yyvsp[0].node)))
		max_look_ahead_number = IR_number_value ((yyvsp[0].node));
            }
#line 2162 "y.tab.c"
    break;

  case 82: /* prec_la: LA NUMBER PREC IDENTIFIER_OR_LITERAL  */
#line 637 "./yacc.y"
            {
              (yyval.precedence_and_code_insertion_and_la).code_insertion = NULL;
              (yyval.precedence_and_code_insertion_and_la).precedence_identifier_or_literal = (yyvsp[0].node);
              (yyval.precedence_and_code_insertion_and_la).look_ahead_number = (yyvsp[-2].node);
	      if (max_look_ahead_number < IR_number_value ((yyvsp[-2].node)))
		max_look_ahead_number = IR_number_value ((yyvsp[-2].node));
            }
#line 2174 "y.tab.c"
    break;

  case 83: /* prec_la: LA NUMBER CODE_INSERTION code_insertion_tail  */
#line 645 "./yacc.y"
            {
              (yyval.precedence_and_code_insertion_and_la).code_insertion = IR_new_code_insertion_atom (IR_position ((yyvsp[-1].node)),
                                                              NULL, NULL, (yyvsp[-1].node));
              (yyval.precedence_and_code_insertion_and_la).precedence_identifier_or_literal = NULL;
              (yyval.precedence_and_code_insertion_and_la).look_ahead_number = (yyvsp[-2].node);
	      if (max_look_ahead_number < IR_number_value ((yyvsp[-2].node)))
		max_look_ahead_number = IR_number_value ((yyvsp[-2].node));
            }
#line 2187 "y.tab.c"
    break;

  case 84: /* prec_la: PREC IDENTIFIER_OR_LITERAL LA NUMBER CODE_INSERTION code_insertion_tail  */
#line 655 "./yacc.y"
            {
              (yyval.precedence_and_code_insertion_and_la).code_insertion = IR_new_code_insertion_atom (IR_position ((yyvsp[-1].node)),
                                                              NULL, NULL, (yyvsp[-1].node));
              (yyval.precedence_and_code_insertion_and_la).precedence_identifier_or_literal = (yyvsp[-4].node);
              (yyval.precedence_and_code_insertion_and_la).look_ahead_number = (yyvsp[-2].node);
	      if (max_look_ahead_number < IR_number_value ((yyvsp[-2].node)))
		max_look_ahead_number = IR_number_value ((yyvsp[-2].node));
            }
#line 2200 "y.tab.c"
    break;

  case 85: /* prec_la: LA NUMBER PREC IDENTIFIER_OR_LITERAL CODE_INSERTION code_insertion_tail  */
#line 665 "./yacc.y"
            {
              (yyval.precedence_and_code_insertion_and_la).code_insertion = IR_new_code_insertion_atom (IR_position ((yyvsp[-1].node)),
                                                              NULL, NULL, (yyvsp[-1].node));
              (yyval.precedence_and_code_insertion_and_la).precedence_identifier_or_literal = (yyvsp[-2].node);
              (yyval.precedence_and_code_insertion_and_la).look_ahead_number = (yyvsp[-4].node);
	      if (max_look_ahead_number < IR_number_value ((yyvsp[-4].node)))
		max_look_ahead_number = IR_number_value ((yyvsp[-4].node));
            }
#line 2213 "y.tab.c"
    break;


#line 2217 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 680 "./yacc.y"


static IR_node_t
form_new_sequence (IR_node_t cyclic_sequence,
                   IR_node_t last_code_insertion_atom)
{
  IR_node_t first_sequence_element;

  if (last_code_insertion_atom != NULL)
    {
      if (cyclic_sequence == NULL)
        /* It is possible because of syntax errors -- Make cycle. */
        IR_set_next_sequence_element (last_code_insertion_atom,
                                      last_code_insertion_atom);
      else
        {
          /* Add element to cyclic sequence */
          IR_set_next_sequence_element
            (last_code_insertion_atom,
             IR_next_sequence_element (cyclic_sequence));
          IR_set_next_sequence_element (cyclic_sequence,
                                        last_code_insertion_atom);
        }
      cyclic_sequence = last_code_insertion_atom;
    }
  /* Transform cyclic sequence to usual list. */
  if (cyclic_sequence != NULL)
    {
      first_sequence_element = IR_next_sequence_element (cyclic_sequence);
      IR_set_next_sequence_element (cyclic_sequence, NULL);
      cyclic_sequence = first_sequence_element;
    }
  return cyclic_sequence;
}



/*   This page contains abstract data `scanner'.  This abstract data
   divides input stream characters on tokens (lexemas). */

/* The following structure describes current input stream and scanner
   state. */

struct input_stream_state
{
  FILE *input_file;
  /* The following member is TRUE if the first `%%' in given input stream
     was already processed or FALSE otherwise. */
  int it_is_first_percents;
  /* The following member is TRUE if the ADDITIONAL_CODE lexema was already
     returned by the scanner or FALSE otherwise. */
  int additional_c_code_was_returned;
};

/* The following structure contains current input stream and
   scanner state.  If the member `input_file' value is NULL
   then input stream is not defined. */

static struct input_stream_state current_input_stream_state;

static int
find_keyword (const char *str, int length)
{
  switch (length)
    {
    case 2:
      if (*str == 'c')
        return (strcmp (str, "cp") == 0 ? CP : 0);
      else
        return (strcmp (str, "la") == 0 ? LA : 0);
    case 4:
      switch (*str)
        {
        case 'l':
          return (strcmp (str, "left") == 0 ? LEFT : 0);
        case 'p':
          return (strcmp (str, "prec") == 0 ? PREC : 0);
        case 't':
          return (strcmp (str, "type") == 0 ? TYPE : 0);
        default:
          return 0;
        }
    case 5:
      switch (*str)
        {
        case 'r':
          return (strcmp (str, "right") == 0 ? RIGHT : 0);
        case 't':
          return (strcmp (str, "token") == 0 ? TOKEN : 0);
        case 's':
          return (strcmp (str, "start") == 0 ? START : 0);
        case 'u':
          return (strcmp (str, "union") == 0 ? UNION : 0);
        case 'l':
          return (strcmp (str, "local") == 0 ? LOCAL : 0);
        default:
          return 0;
        }
    case 6:
      switch (*str)
        {
        case 'i':
          return (strcmp (str, "import") == 0 ? IMPORT : 0);
        case 'e':
          if (str [3] == 'o')
            return (strcmp (str, "export") == 0 ? EXPORT : 0);
          else
            return (strcmp (str, "expect") == 0 ? EXPECT : 0);
        default:
          return 0;
        }
    case 7:
      return (strcmp (str, "scanner") == 0 ? SCANNER : 0);
    case 8:
      return (strcmp (str, "nonassoc") == 0 ? NONASSOC : 0);
    default:
      return 0;
    }
}

/* The following value is used if previous_char does not contain an
   input char */

#define EMPTY_PREVIOUS_CHAR (-2000)

/* The following variable is used for storing '\r'. */

static int previous_char;

/* The following two functions for replacing "\r\n" onto "\n". */

static int
getch (FILE *f)
{
  int c;

  if (previous_char != '\r')
    c = getc (f);
  else
    {
      c = previous_char;
      previous_char = EMPTY_PREVIOUS_CHAR;
    }
  if (c == '\r')
    {
      c = getc (f);
      if (c != '\n')
        {
          ungetc (c, f);
          c = '\r';
        }
    }
  return c;
}

static void
ungetch (int c, FILE *f)
{
  if (c != '\r')
    ungetc (c, f);
  else
    previous_char = c;
}

static int
skip_commentary (int store_flag)
{
  int input_char;
  
  current_position.column_number++;
  if (store_flag)
    IR_TOP_ADD_BYTE ('*');
  for (;;)
    {
      input_char = getch (current_input_stream_state.input_file);
      /* Here `current_position' corresponds to `input_char'. */
      if (input_char == '*')
        {
          if (store_flag)
            IR_TOP_ADD_BYTE (input_char);
          input_char = getch (current_input_stream_state.input_file);
          current_position.column_number++;
          /* Here `current_position' corresponds to `input_char'. */
          if (input_char == '/')
            {
              if (store_flag)
                IR_TOP_ADD_BYTE (input_char);
              current_position.column_number++;
              return TRUE;
            }
          else
            {
              ungetch (input_char, current_input_stream_state.input_file);
              continue;
            }
        }
      else if (input_char == EOF)
        {
          ungetch (input_char, current_input_stream_state.input_file);
          return FALSE;
        }
      if (input_char == '\n')
        {
          current_position.column_number = 1;
          current_position.line_number++;
        }
      else if (input_char == '\t')
        current_position.column_number
          = ((current_position.column_number - 1) / TAB_STOP + 1)
            * TAB_STOP + 1;
      else
        current_position.column_number++;
      if (store_flag)
        IR_TOP_ADD_BYTE (input_char);
    }
}

static int
skip_string_code (int input_char, int *correct_new_line)
{
  if (input_char == EOF || input_char == '\n')
    {
      ungetch (input_char, current_input_stream_state.input_file);
      return FALSE;
    }
  *correct_new_line = FALSE;
  IR_TOP_ADD_BYTE (input_char);
  if (input_char == '\\')
    {
      current_position.column_number++;
      input_char = getch (current_input_stream_state.input_file);
      IR_TOP_ADD_BYTE (input_char);
      if (input_char == 'n' || input_char == 't' || input_char == 'v'
          || input_char == 'b' || input_char == 'r' || input_char == 'f'
          || input_char == '\\' || input_char == '\'' || input_char == '\"')
        current_position.column_number++;
      else if (input_char == '\n')
        {
          current_position.column_number = 1;
          current_position.line_number++;
          *correct_new_line = TRUE;
        }
      else if (isdigit (input_char) && input_char != '8'
               && input_char != '9')
        {
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (!isdigit (input_char) || input_char == '8'
              || input_char == '9')
            ungetch (input_char, current_input_stream_state.input_file);
          else
            {
              current_position.column_number++;
              IR_TOP_ADD_BYTE (input_char);
              input_char = getch (current_input_stream_state.input_file);
              if (!isdigit (input_char) || input_char == '8'
                  || input_char == '9')
                ungetch (input_char, current_input_stream_state.input_file);
              else
                {
                  current_position.column_number++;
                  IR_TOP_ADD_BYTE (input_char);
                }
            }
        }
      else
        current_position.column_number++;
    }
  else if (input_char == '\t')
    current_position.column_number
      = ((current_position.column_number - 1) / TAB_STOP + 1) * TAB_STOP + 1;
  else
    current_position.column_number++;
  return TRUE;
}

static const char *
get_string_code (const char *code_representation,
                 int *character_code, int *correct_new_line)
{
  *correct_new_line = FALSE;
  *character_code = *code_representation;
  if (*code_representation == '\\')
    {
      code_representation++;
      if (*code_representation == 'n' || *code_representation == 't'
          || *code_representation == 'v' || *code_representation == 'b'
          || *code_representation == 'r' || *code_representation == 'f'
          || *code_representation == '\\' || *code_representation == '\''
          || *code_representation == '\"')
        {
            if (*code_representation == 'n')
              *character_code = '\n';
            else if (*code_representation == 't')
              *character_code = '\t';
            else if (*code_representation == 'v')
              *character_code = '\v';
            else if (*code_representation == 'b')
              *character_code = '\b';
            else if (*code_representation == 'r')
              *character_code = '\r';
            else if (*code_representation == 'f')
              *character_code = '\f';
            else if (*code_representation == '\\')
              *character_code = '\\';
            else if (*code_representation == '\'')
              *character_code = '\'';
            else if (*code_representation == '\"')
              *character_code = '\"';
            else
              assert (FALSE);
        }
      else if (isdigit (*code_representation) && *code_representation != '8'
               && *code_representation != '9')
        {
          *character_code = *code_representation - '0';
          code_representation++;
          if (!isdigit (*code_representation) || *code_representation == '8'
              || *code_representation == '9')
            code_representation--;
          else
            {
              *character_code
                = *character_code * 8 + *code_representation - '0';
              code_representation++;
              if (!isdigit (*code_representation)
                  || *code_representation == '8'
                  || *code_representation == '9')
                code_representation--;
              else
                {
                  *character_code
                    = *character_code * 8 + *code_representation - '0';
                  current_position.column_number++;
                }
            }
        }
      else if (*code_representation != '\n')
        *character_code = *code_representation;
      else
        *correct_new_line = TRUE;
    }
  return code_representation;
}


static void
skip_C_character (void)
{
  int input_char;
  int correct_new_line;
  int error_flag;

  error_flag = FALSE;
  input_char = getch (current_input_stream_state.input_file);
  /* Here `current_position' corresponds to `input_char'. */
  if (input_char == '\'')
    {
      IR_TOP_ADD_BYTE (input_char);
      error (FALSE, current_position, "invalid character constant");
      current_position.column_number++;
      error_flag = TRUE;
    }
  else
    {
      if (!skip_string_code (input_char, &correct_new_line)
          || correct_new_line)
        {
          error (FALSE, current_position, "invalid character constant");
          error_flag = TRUE;
        }
    }
  input_char = getch (current_input_stream_state.input_file);
  if (input_char != '\'')
    {
      ungetch (input_char, current_input_stream_state.input_file);
      if (!error_flag)
        error (FALSE, current_position, "invalid character constant");
    }
  else
    {
      IR_TOP_ADD_BYTE (input_char);
      current_position.column_number++;
    }
}

static int
C_character_value (const char *character_representation)
{
  int correct_new_line;
  int character_code;

  if (*character_representation != '\''
      || get_string_code (character_representation + 1,
                          &character_code, &correct_new_line) [1] != '\''
      || correct_new_line)
    character_code = -1;
  return character_code;
}

static void
skip_C_string (void)
{
  int input_char;
  int correct_new_line;
  
  for (;;)
    {
      /* Here `current_position' corresponds to next character. */
      input_char = getch (current_input_stream_state.input_file);
      if (input_char == '\"')
        {
          current_position.column_number++;
          IR_TOP_ADD_BYTE (input_char); 
          break;
        }
      if (!skip_string_code (input_char, &correct_new_line))
        {
          error (FALSE, current_position, "string end is absent");
          break;
        }
    }
}

static void
add_C_string_value (const char *string_representation,
                    int string_representation_length)
{
  int correct_new_line;
  int character_code;

  for (;;)
    {
      string_representation++;
      string_representation_length--;
      if (string_representation_length < 0
          || *string_representation == '\"')
        break;
      string_representation
        = get_string_code (string_representation,
                           &character_code, &correct_new_line);
      if (!correct_new_line)
        IR_TOP_ADD_BYTE (character_code);
    }
  IR_TOP_ADD_BYTE (0);
}

static void
process_code_insertion (int yacc_code_insertion_flag)
{
  int input_char;
  int bracket_level = 1;
  int error_flag;
  char *code_itself;
  
  current_lexema_position = current_position;
  current_position.column_number++;
  for (error_flag = FALSE; !error_flag && bracket_level != 0;)
    {
      input_char = getch (current_input_stream_state.input_file);
      IR_TOP_ADD_BYTE (input_char);
      /* `current_position' corresponds to `input_char' here */
      switch (input_char)
        {
        case '/':
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (input_char == '*')
            {
              current_position.column_number++;
              error_flag = !skip_commentary (TRUE);
            }
          else
            ungetch (input_char, current_input_stream_state.input_file);
          break;
        case '{':
          current_position.column_number++;
          if (!yacc_code_insertion_flag)
            bracket_level++;
          break;
        case '}':
          current_position.column_number++;
          if (!yacc_code_insertion_flag)
            {
              bracket_level--;
              if (bracket_level == 0)
                IR_TOP_SHORTEN (1);
            }
          break;
        case '%':
          current_position.column_number++;
          if (yacc_code_insertion_flag)
            {
              input_char = getch (current_input_stream_state.input_file);
              if (input_char == '}')
                {
                  current_position.column_number++;
                  IR_TOP_SHORTEN (1);
                  bracket_level = 0; /* To exit from the loop */
                }
              else
                ungetch (input_char, current_input_stream_state.input_file);
            }
          break;
        case '\'':
          current_position.column_number++;
          skip_C_character ();
          break;
        case '\"':
          current_position.column_number++;
          skip_C_string ();
          break;
        case '\t':
          current_position.column_number
            = ((current_position.column_number - 1) / TAB_STOP + 1)
              * TAB_STOP + 1;
          break;
        case '\n':
          current_position.column_number = 1;
          current_position.line_number++;
          break;
        case EOF:
          IR_TOP_SHORTEN (1);
          ungetch (input_char, current_input_stream_state.input_file);
          error_flag = TRUE;
          break;
        default:
          current_position.column_number++;
          break;
        }
    }
  if (error_flag)
    error (FALSE, current_lexema_position, "C code insertion end is absent");
  IR_TOP_ADD_BYTE ('\0');
  code_itself = IR_TOP_BEGIN ();
  IR_TOP_FINISH ();
  yylval.node = IR_new_code_insertion (current_lexema_position, code_itself);
}

static int
skip_blanks (int *number_of_successive_error_characters)
{
  int input_char;
  
  for (*number_of_successive_error_characters = 0;;)
    {
      input_char = getch (current_input_stream_state.input_file);
      /* `current_position' corresponds `input_char' here */
      switch (input_char)
        {
        case '\f':
        case ' ':
          current_position.column_number++;
          break;
        case '\t':
          current_position.column_number
            = ((current_position.column_number - 1) / TAB_STOP + 1)
              * TAB_STOP + 1;
          break;
        case '\n':
          current_position.column_number = 1;
          current_position.line_number++;
          break;
        case '/':
          current_lexema_position = current_position;
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (input_char != '*')
            {
              ungetch (input_char, current_input_stream_state.input_file);
              return '/';
            }
          else if (!skip_commentary (FALSE))
            error (FALSE, current_lexema_position, "commentary end is absent");
          break;
        default:
          return input_char;
        }
    }
}

int
yylex (void)
{
  int input_char;
  int number_of_successive_error_characters;
  
  for (;;)
    {
      input_char = skip_blanks (&number_of_successive_error_characters);
      /* `current_position' corresponds `input_char' here */
      switch (input_char)
        {
        case EOF:
          current_lexema_position = current_position;
          return 0;
        case ';':
          current_lexema_position = current_position;
          current_position.column_number++;
          return SEMICOLON;
        case '|':
          current_lexema_position = current_position;
          current_position.column_number++;
          return BAR;
        case '/':
          current_lexema_position = current_position;
          current_position.column_number++;
          return SLASH;
        case '*':
          current_lexema_position = current_position;
          current_position.column_number++;
          return STAR;
        case '+':
          current_lexema_position = current_position;
          current_position.column_number++;
          return PLUS;
        case '[':
          current_lexema_position = current_position;
          current_position.column_number++;
          return LEFT_SQUARE_BRACKET;
        case ']':
          current_lexema_position = current_position;
          current_position.column_number++;
          return RIGHT_SQUARE_BRACKET;
        case '<':
          current_lexema_position = current_position;
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (input_char == '-')
            {
              current_position.column_number++;
              input_char = getch (current_input_stream_state.input_file);
              if (input_char == '>')
                {
                  current_position.column_number++;
                  return RANGE_NO_LEFT_RIGHT_BOUNDS;
                }
              else
                {
                  ungetch (input_char, current_input_stream_state.input_file);
                  return RANGE_NO_LEFT_BOUND;
                }
            }
          else
            {
              ungetch (input_char, current_input_stream_state.input_file);
              return LESS;
            }
          break;
        case '>':
          current_lexema_position = current_position;
          current_position.column_number++;
          return GREATER;
        case '(':
          current_lexema_position = current_position;
          current_position.column_number++;
          return LEFT_PARENTHESIS;
        case ')':
          current_lexema_position = current_position;
          current_position.column_number++;
          return RIGHT_PARENTHESIS;
        case '@':
          current_lexema_position = current_position;
          current_position.column_number++;
          return AT;
        case '-':
          current_lexema_position = current_position;
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (input_char == '>')
            {
              current_position.column_number++;
              return RANGE_NO_RIGHT_BOUND;
            }
          else
            {
              ungetch (input_char, current_input_stream_state.input_file);
              return RANGE;
            }
          break;
        case '\'':
          {
            char *character_representation;

            current_lexema_position = current_position;
            current_position.column_number++;
            IR_TOP_ADD_BYTE (input_char); /* Add ' */
            skip_C_character ();
            IR_TOP_ADD_BYTE (0);
            character_representation = insert_string (IR_TOP_BEGIN ());
            if (character_representation == (char *) IR_TOP_BEGIN ())
              IR_TOP_FINISH ();
            else
              IR_TOP_NULLIFY ();
            yylval.node
              = IR_new_literal (current_lexema_position,
                                character_representation,
                                C_character_value (character_representation));
            if  (IR_literal_code (yylval.node) < 0)
              IR_set_literal_code (yylval.node, 0);
            return IDENTIFIER_OR_LITERAL;
          }
          break;
        case '\"':
          {
            char *string_representation;
            char *string_itself;
            int string_representation_length;

            current_lexema_position = current_position;
            current_position.column_number++;
            IR_TOP_ADD_BYTE (input_char); /* Add " */
            skip_C_string ();
            string_representation_length = IR_TOP_LENGTH ();
            IR_TOP_ADD_BYTE (0);
            string_representation = insert_string (IR_TOP_BEGIN ());
            if (string_representation == (char *) IR_TOP_BEGIN ())
              IR_TOP_FINISH ();
            else
              IR_TOP_NULLIFY ();
            add_C_string_value (string_representation,
                                string_representation_length);
            string_itself = insert_string (IR_TOP_BEGIN ());
            if (strlen (string_itself) + 1 != IR_TOP_LENGTH ())
              error (FALSE, current_lexema_position,
                     "null character in %s", string_representation);
            if (string_itself == (char *) IR_TOP_BEGIN ())
              IR_TOP_FINISH ();
            else
              IR_TOP_NULLIFY ();
            yylval.node = IR_new_string (current_lexema_position,
                                         string_representation,
                                         string_itself);
            return STRING;
          }
          break;
        case '{':
          process_code_insertion (FALSE);
          return CODE_INSERTION;
        case '%':
          current_lexema_position = current_position;
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (input_char == '%')
            {
              current_position.column_number++;
              if (current_input_stream_state.it_is_first_percents)
                {
                  current_input_stream_state.it_is_first_percents = FALSE;
                  return PERCENTS;
                }
              else
                {
                  char *additional_code_itself;

                  current_position.column_number++;
                  input_char = getch (current_input_stream_state.input_file);
                  while (input_char != EOF)
                    {
                      current_position.column_number++;
                      IR_TOP_ADD_BYTE (input_char);
                      input_char
                        = getch (current_input_stream_state.input_file);
                    }
                  ungetch (input_char, current_input_stream_state.input_file);
                  IR_TOP_ADD_BYTE ('\0');
                  additional_code_itself = IR_TOP_BEGIN ();
                  IR_TOP_FINISH ();
                  current_input_stream_state.additional_c_code_was_returned
                    = TRUE;
                  yylval.node
                    = IR_new_additional_code (current_lexema_position,
                                              additional_code_itself);
                  return ADDITIONAL_C_CODE;
                }
            }
          else if (isalpha (input_char) || input_char == '_')
            {
              int keyword;
              
              /* Identifier recognition. */
              do
                {
                  current_position.column_number++;
                  IR_TOP_ADD_BYTE (input_char);
                  input_char = getch (current_input_stream_state.input_file);
                }
              while (isalpha (input_char) || isdigit (input_char)
                     || input_char == '_');
              ungetch (input_char, current_input_stream_state.input_file);
              IR_TOP_ADD_BYTE ('\0');
              keyword = find_keyword (IR_TOP_BEGIN (), IR_TOP_LENGTH () - 1);
              if (keyword != 0)
                {
                  IR_TOP_NULLIFY ();
                  return keyword;
                }
              else
                {
                  error (FALSE, current_lexema_position,
                         "unknown keyword `%%%s'",
                         IR_TOP_BEGIN ());
                  IR_TOP_NULLIFY ();
                }
            }
          else if (input_char == '{')
            {
              process_code_insertion (TRUE);
              return YACC_CODE_INSERTION;
            }
          else
            {
              number_of_successive_error_characters++;
              if (number_of_successive_error_characters == 1)
                error (FALSE, current_lexema_position,
                       "invalid input character '%%'");
              ungetch (input_char, current_input_stream_state.input_file);
            }
          break;
        default:
          if (isalpha (input_char) || input_char == '_' || input_char == '.')
            {
              char *identifier_itself;
              int dot_presence_flag;

              current_lexema_position = current_position;
              /* Identifier recognition. */
              dot_presence_flag = FALSE;
              do
                {
                  if (input_char == '.')
                    dot_presence_flag = TRUE;
                  current_position.column_number++;
                  IR_TOP_ADD_BYTE (input_char);
                  input_char = getch (current_input_stream_state.input_file);
                }
              while (isalpha (input_char) || isdigit (input_char)
                     || input_char == '_' || input_char == '.');
              ungetch (input_char, current_input_stream_state.input_file);
              IR_TOP_ADD_BYTE ('\0');
              identifier_itself = insert_string (IR_TOP_BEGIN ());
              if (identifier_itself == (char *) IR_TOP_BEGIN ())
                IR_TOP_FINISH ();
              else
                IR_TOP_NULLIFY ();
              yylval.node
                = IR_new_identifier (current_lexema_position,
                                     identifier_itself, dot_presence_flag);
              input_char
                = skip_blanks (&number_of_successive_error_characters);
              if (input_char == ':')
                {
                  current_position.column_number++;
                  return C_IDENTIFIER;
                }
              else
                {
                  ungetch (input_char, current_input_stream_state.input_file);
                  return IDENTIFIER_OR_LITERAL;
                }
            }
          else if (isdigit (input_char))
            {
              int number_value;
              int overflow_flag;
              position_t number_position;

              number_position = current_position;
              overflow_flag = FALSE;
              number_value = 0;
              do
                {
                  /* `current_position' corresponds to `input_char' here. */
                  current_position.column_number++;
                  if (number_value > (INT_MAX - (input_char - '0')) / 10)
                    {
                      if (overflow_flag)
                        error (FALSE, number_position,
                               "number value is too big");
                      overflow_flag = TRUE;
                      number_value = INT_MAX;
                    }
                  else
                    number_value = number_value * 10 + (input_char - '0');
                  input_char = getch (current_input_stream_state.input_file);
                  /* `current_position' corresponds to `input_char' here. */
                }
              while (isdigit (input_char));
              ungetch (input_char, current_input_stream_state.input_file);
              yylval.node = IR_new_number (number_position, number_value);
              return NUMBER;
            }
          else
            {
              number_of_successive_error_characters++;
              if (number_of_successive_error_characters == 1)
                {
                  if (isprint (input_char))
                    error (FALSE, current_position,
                           "invalid input character '%c'", input_char);
                  else
                    error (FALSE, current_position, "invalid input character");
                }
              current_position.column_number++;
            }
          break;
        }
    }
}

static void
initiate_scanner (void)
{
  current_input_stream_state.input_file = NULL;
  current_input_stream_state.it_is_first_percents = TRUE;
  current_input_stream_state.additional_c_code_was_returned = FALSE;
}

static void
start_scanner_file (const char *new_file_name)
{
  current_input_stream_state.input_file = fopen (new_file_name, "rb");
  if (current_input_stream_state.input_file == NULL)
    system_error (TRUE, no_position, "fatal error -- `%s': ", new_file_name);
  start_file_position (new_file_name);
  previous_char = EMPTY_PREVIOUS_CHAR;
  current_input_stream_state.it_is_first_percents = TRUE;
  current_input_stream_state.additional_c_code_was_returned = FALSE;
}

/* The function can be called two and more times (after the last call
   of `initiate_scanner'. */
static void
finish_scanner (void)
{
  if (current_input_stream_state.input_file != NULL)
    {
      fclose (current_input_stream_state.input_file);
      current_input_stream_state.input_file = NULL;
      finish_file_position ();
    }
}



/*   This page contains abstract data `syntax_errors'.  This abstract
   data is used to error reporting.
     YACC has unsatisfactory syntactic error reporting.  Essentially
   YACC generates only one syntactic error "syntax error".  Abstract
   data `syntax_errors' for solution of this problem is suggested
   here.  This abstract data saves only one the most recent error
   message and its position.  Function `yyerror' used only by function
   `yyparse' flushes saved early error message and saves message given
   as parameter (usually this message is simply "syntax error" but may
   be "stack overflow" or others) and its position.  More detail
   diagnostic message is generated by the call of function
   `syntax_error' within action after special token `error'.  This
   function only rewrites saved early error message (not error
   position).  As consequence the message of last call `syntax_error'
   or the message of function `yyerror' (if such call of
   `syntax_error' does not exist) is fixed within one recover mode
   interval because function `yyerror' is called by `yyparse' only in
   non recover mode.
     This solution permits to create brief syntactic message which
   contain partially information about recovery location (error line
   and position is always in non-fatal errors and warnings -- see
   package for `errors').  */


/* This variable saves the most recent syntax error message or NULL (if
   such syntax error was not fixed). */

static const char *last_syntax_error_message;

/* This variable saves the first syntax error position. */

static position_t first_syntax_error_position;


static void
initiate_syntax_errors (void)
{
  last_syntax_error_message = NULL;
}


static void
flush_syntax_error (void)
{
  if (last_syntax_error_message != NULL)
    {
      error (FALSE, first_syntax_error_position,
             "%s", last_syntax_error_message);
      last_syntax_error_message = NULL;
    }
}


yyerror (const char *message)
{
  flush_syntax_error ();
  last_syntax_error_message = message;
  first_syntax_error_position = current_lexema_position;
  return 0;
}

static void
syntax_error (const char *s)
{
  last_syntax_error_message = s;
}


static void
finish_syntax_errors (void)
{
  flush_syntax_error ();
}



/* This page contains all external functions of parser. */

void
initiate_parser (void)
{
  initiate_scanner ();
  initiate_syntax_errors ();
}

void
start_parser_file (const char *file_name)
{
  start_scanner_file (file_name);
}

/* The function can be called more two times after the last call of
   `initiate_parser'. */

void
finish_parser (void)
{
  finish_scanner ();
  finish_syntax_errors ();
}
