/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 40 "./yacc.y"


#ifdef HAVE_CONFIG_H
#include "cocom-config.h"
#else /* In this case we are oriented to ANSI C */
#ifndef HAVE_ASSERT_H
#define HAVE_ASSERT_H
#endif
#endif /* #ifdef HAVE_CONFIG_H */

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include "position.h"
#include "errors.h"
#include "ird.h"
#include "common.h"
#include "tab.h"
#include "yacc.h"

#ifdef HAVE_ASSERT_H
#include <assert.h>
#else
#ifndef assert
#define assert(code) do { if (code == 0) abort ();} while (0)
#endif
#endif



/* The following variables and forward definitions of functions are
   used in actions of YACC grammar. */

/* The following variable value is begin position of the last lexema returned
   by the function `yylex'. */

static position_t current_lexema_position;

static void syntax_error (const char *s);


#line 113 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    PERCENTS = 258,                /* PERCENTS  */
    COMMA = 259,                   /* COMMA  */
    COLON = 260,                   /* COLON  */
    SEMICOLON = 261,               /* SEMICOLON  */
    LEFT_PARENTHESIS = 262,        /* LEFT_PARENTHESIS  */
    RIGHT_PARENTHESIS = 263,       /* RIGHT_PARENTHESIS  */
    LEFT_BRACKET = 264,            /* LEFT_BRACKET  */
    RIGHT_BRACKET = 265,           /* RIGHT_BRACKET  */
    LEFT_ANGLE_BRACKET = 266,      /* LEFT_ANGLE_BRACKET  */
    RIGHT_ANGLE_BRACKET = 267,     /* RIGHT_ANGLE_BRACKET  */
    PLUS = 268,                    /* PLUS  */
    BAR = 269,                     /* BAR  */
    STAR = 270,                    /* STAR  */
    LOCAL = 271,                   /* LOCAL  */
    IMPORT = 272,                  /* IMPORT  */
    EXPORT = 273,                  /* EXPORT  */
    AUTOMATON = 274,               /* AUTOMATON  */
    UNIT = 275,                    /* UNIT  */
    EXCLUSION = 276,               /* EXCLUSION  */
    NOTHING = 277,                 /* NOTHING  */
    INPUT = 278,                   /* INPUT  */
    RESULT = 279,                  /* RESULT  */
    INSTRUCTION = 280,             /* INSTRUCTION  */
    RESERVATION = 281,             /* RESERVATION  */
    IDENTIFIER = 282,              /* IDENTIFIER  */
    NUMBER = 283,                  /* NUMBER  */
    CODE_INSERTION = 284,          /* CODE_INSERTION  */
    ADDITIONAL_C_CODE = 285        /* ADDITIONAL_C_CODE  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define PERCENTS 258
#define COMMA 259
#define COLON 260
#define SEMICOLON 261
#define LEFT_PARENTHESIS 262
#define RIGHT_PARENTHESIS 263
#define LEFT_BRACKET 264
#define RIGHT_BRACKET 265
#define LEFT_ANGLE_BRACKET 266
#define RIGHT_ANGLE_BRACKET 267
#define PLUS 268
#define BAR 269
#define STAR 270
#define LOCAL 271
#define IMPORT 272
#define EXPORT 273
#define AUTOMATON 274
#define UNIT 275
#define EXCLUSION 276
#define NOTHING 277
#define INPUT 278
#define RESULT 279
#define INSTRUCTION 280
#define RESERVATION 281
#define IDENTIFIER 282
#define NUMBER 283
#define CODE_INSERTION 284
#define ADDITIONAL_C_CODE 285

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 87 "./yacc.y"

  IR_node_t node;
  position_t position;
  integer_t inumber;

#line 229 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_PERCENTS = 3,                   /* PERCENTS  */
  YYSYMBOL_COMMA = 4,                      /* COMMA  */
  YYSYMBOL_COLON = 5,                      /* COLON  */
  YYSYMBOL_SEMICOLON = 6,                  /* SEMICOLON  */
  YYSYMBOL_LEFT_PARENTHESIS = 7,           /* LEFT_PARENTHESIS  */
  YYSYMBOL_RIGHT_PARENTHESIS = 8,          /* RIGHT_PARENTHESIS  */
  YYSYMBOL_LEFT_BRACKET = 9,               /* LEFT_BRACKET  */
  YYSYMBOL_RIGHT_BRACKET = 10,             /* RIGHT_BRACKET  */
  YYSYMBOL_LEFT_ANGLE_BRACKET = 11,        /* LEFT_ANGLE_BRACKET  */
  YYSYMBOL_RIGHT_ANGLE_BRACKET = 12,       /* RIGHT_ANGLE_BRACKET  */
  YYSYMBOL_PLUS = 13,                      /* PLUS  */
  YYSYMBOL_BAR = 14,                       /* BAR  */
  YYSYMBOL_STAR = 15,                      /* STAR  */
  YYSYMBOL_LOCAL = 16,                     /* LOCAL  */
  YYSYMBOL_IMPORT = 17,                    /* IMPORT  */
  YYSYMBOL_EXPORT = 18,                    /* EXPORT  */
  YYSYMBOL_AUTOMATON = 19,                 /* AUTOMATON  */
  YYSYMBOL_UNIT = 20,                      /* UNIT  */
  YYSYMBOL_EXCLUSION = 21,                 /* EXCLUSION  */
  YYSYMBOL_NOTHING = 22,                   /* NOTHING  */
  YYSYMBOL_INPUT = 23,                     /* INPUT  */
  YYSYMBOL_RESULT = 24,                    /* RESULT  */
  YYSYMBOL_INSTRUCTION = 25,               /* INSTRUCTION  */
  YYSYMBOL_RESERVATION = 26,               /* RESERVATION  */
  YYSYMBOL_IDENTIFIER = 27,                /* IDENTIFIER  */
  YYSYMBOL_NUMBER = 28,                    /* NUMBER  */
  YYSYMBOL_CODE_INSERTION = 29,            /* CODE_INSERTION  */
  YYSYMBOL_ADDITIONAL_C_CODE = 30,         /* ADDITIONAL_C_CODE  */
  YYSYMBOL_YYACCEPT = 31,                  /* $accept  */
  YYSYMBOL_description = 32,               /* description  */
  YYSYMBOL_33_1 = 33,                      /* @1  */
  YYSYMBOL_declaration_part = 34,          /* declaration_part  */
  YYSYMBOL_declaration = 35,               /* declaration  */
  YYSYMBOL_36_2 = 36,                      /* @2  */
  YYSYMBOL_37_3 = 37,                      /* @3  */
  YYSYMBOL_38_4 = 38,                      /* @4  */
  YYSYMBOL_identifier_declaration = 39,    /* identifier_declaration  */
  YYSYMBOL_instruction_declaration = 40,   /* instruction_declaration  */
  YYSYMBOL_reservation_declaration = 41,   /* reservation_declaration  */
  YYSYMBOL_unit_declaration = 42,          /* unit_declaration  */
  YYSYMBOL_exclusion_clause = 43,          /* exclusion_clause  */
  YYSYMBOL_44_5 = 44,                      /* @5  */
  YYSYMBOL_identifier_list = 45,           /* identifier_list  */
  YYSYMBOL_optional_automaton_identifier = 46, /* optional_automaton_identifier  */
  YYSYMBOL_automaton_declaration = 47,     /* automaton_declaration  */
  YYSYMBOL_expression_definition_list = 48, /* expression_definition_list  */
  YYSYMBOL_expression_definition = 49,     /* expression_definition  */
  YYSYMBOL_instruction_or_reservation_identifier_list = 50, /* instruction_or_reservation_identifier_list  */
  YYSYMBOL_instruction_or_reservation_identifier = 51, /* instruction_or_reservation_identifier  */
  YYSYMBOL_expression = 52,                /* expression  */
  YYSYMBOL_53_6 = 53,                      /* @6  */
  YYSYMBOL_54_7 = 54,                      /* @7  */
  YYSYMBOL_55_8 = 55,                      /* @8  */
  YYSYMBOL_56_9 = 56,                      /* @9  */
  YYSYMBOL_57_10 = 57,                     /* @10  */
  YYSYMBOL_58_11 = 58,                     /* @11  */
  YYSYMBOL_59_12 = 59,                     /* @12  */
  YYSYMBOL_60_13 = 60,                     /* @13  */
  YYSYMBOL_61_14 = 61,                     /* @14  */
  YYSYMBOL_62_15 = 62,                     /* @15  */
  YYSYMBOL_input_result_number = 63,       /* input_result_number  */
  YYSYMBOL_unit_or_reservation_identifier = 64 /* unit_or_reservation_identifier  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   122

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  31
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  34
/* YYNRULES -- Number of rules.  */
#define YYNRULES  68
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  98

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   285


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   127,   127,   126,   161,   162,   176,   183,   206,   206,
     210,   210,   214,   214,   224,   225,   226,   227,   228,   235,
     241,   264,   270,   294,   299,   318,   318,   329,   334,   346,
     347,   357,   362,   385,   386,   404,   410,   423,   454,   459,
     472,   479,   478,   488,   487,   497,   496,   506,   505,   515,
     514,   524,   523,   532,   532,   537,   537,   541,   542,   542,
     547,   547,   552,   556,   560,   564,   570,   571,   574
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "PERCENTS", "COMMA",
  "COLON", "SEMICOLON", "LEFT_PARENTHESIS", "RIGHT_PARENTHESIS",
  "LEFT_BRACKET", "RIGHT_BRACKET", "LEFT_ANGLE_BRACKET",
  "RIGHT_ANGLE_BRACKET", "PLUS", "BAR", "STAR", "LOCAL", "IMPORT",
  "EXPORT", "AUTOMATON", "UNIT", "EXCLUSION", "NOTHING", "INPUT", "RESULT",
  "INSTRUCTION", "RESERVATION", "IDENTIFIER", "NUMBER", "CODE_INSERTION",
  "ADDITIONAL_C_CODE", "$accept", "description", "@1", "declaration_part",
  "declaration", "@2", "@3", "@4", "identifier_declaration",
  "instruction_declaration", "reservation_declaration", "unit_declaration",
  "exclusion_clause", "@5", "identifier_list",
  "optional_automaton_identifier", "automaton_declaration",
  "expression_definition_list", "expression_definition",
  "instruction_or_reservation_identifier_list",
  "instruction_or_reservation_identifier", "expression", "@6", "@7", "@8",
  "@9", "@10", "@11", "@12", "@13", "@14", "@15", "input_result_number",
  "unit_or_reservation_identifier", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-55)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -55,     2,    35,   -55,   -55,   -55,   -55,   -55,   -55,   -55,
       4,   -55,   -55,   -55,   -55,   -55,   -20,   -11,   -10,   -55,
      -9,   -55,    -7,     6,    10,    13,   -55,    14,   -55,   -55,
     -55,   -55,     7,   -55,   -55,   -55,    30,   -55,    -4,    -1,
     -55,   -55,   -55,     9,   -55,   -55,    14,   -55,   -55,   -55,
      16,    95,    17,   -55,    95,   -55,   -55,    18,    18,   -55,
      -3,   -55,    50,    95,   -55,   -55,   -55,   -55,   -55,   -55,
     -55,   -55,   -55,   -55,   -55,   -55,   -55,   -55,    69,    95,
      95,    95,    95,    19,    95,    95,    95,    95,   -55,    33,
      33,    33,    88,   -55,    33,    33,    33,    33
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       4,     0,     0,     1,     6,     2,     8,    10,    12,    31,
      29,    25,    19,    21,     5,     7,    14,    15,    16,    18,
      17,    33,     0,     0,     0,     0,    23,     0,    20,    22,
      24,    32,     0,     9,    11,    13,     0,    27,     0,     0,
      40,     3,    34,     0,    38,    30,     0,    28,    35,    36,
       0,     0,    26,    39,     0,    58,    63,    66,    66,    68,
       0,    62,     0,     0,    67,    65,    64,    37,    49,    51,
      53,    60,    55,    43,    47,    45,    41,    57,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    59,    50,
      52,    54,    61,    56,    44,    48,    46,    42
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -55,   -55,   -55,   -55,   -55,   -55,   -55,   -55,   -55,   -55,
     -55,   -55,   -55,   -55,     3,   -55,   -55,   -55,   -55,   -55,
      -5,   -54,   -55,   -55,   -55,   -55,   -55,   -55,   -55,   -55,
     -55,   -55,    -8,   -55
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     1,    21,     2,    14,    22,    23,    24,    15,    16,
      17,    18,    19,    27,    38,    26,    20,    32,    42,    43,
      44,    60,    87,    84,    86,    85,    79,    80,    81,    83,
      63,    82,    65,    61
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      62,    46,     3,    67,    68,    48,    69,    28,    39,    78,
      70,    71,    72,    50,    51,    25,    29,    30,    31,    73,
      74,    75,    33,    47,    76,    89,    90,    91,    92,    49,
      94,    95,    96,    97,    40,    34,     4,    41,     5,    35,
      36,    37,    45,    40,    47,    53,    64,    93,    72,    52,
      66,     6,     7,     8,     9,    10,    11,    68,    77,    69,
      12,    13,     0,    70,    71,    72,     0,     0,     0,     0,
       0,     0,    73,    74,    75,     0,    68,    76,    69,    88,
       0,     0,    70,    71,    72,     0,     0,     0,     0,     0,
       0,    73,    74,    75,     0,    68,    76,    69,     0,     0,
       0,    70,    54,    72,    55,     0,     0,     0,     0,     0,
      73,    74,    75,     0,     0,    76,     0,    56,    57,    58,
       0,     0,    59
};

static const yytype_int8 yycheck[] =
{
      54,     5,     0,     6,     7,     6,     9,    27,     1,    63,
      13,    14,    15,     4,     5,    11,    27,    27,    27,    22,
      23,    24,    29,    27,    27,    79,    80,    81,    82,    30,
      84,    85,    86,    87,    27,    29,     1,    30,     3,    29,
      27,    27,    12,    27,    27,    50,    28,    28,    15,    46,
      58,    16,    17,    18,    19,    20,    21,     7,     8,     9,
      25,    26,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    -1,     7,    27,     9,    10,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    -1,     7,    27,     9,    -1,    -1,
      -1,    13,     7,    15,     9,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    -1,    -1,    27,    -1,    22,    23,    24,
      -1,    -1,    27
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    32,    34,     0,     1,     3,    16,    17,    18,    19,
      20,    21,    25,    26,    35,    39,    40,    41,    42,    43,
      47,    33,    36,    37,    38,    11,    46,    44,    27,    27,
      27,    27,    48,    29,    29,    29,    27,    27,    45,     1,
      27,    30,    49,    50,    51,    12,     5,    27,     6,    30,
       4,     5,    45,    51,     7,     9,    22,    23,    24,    27,
      52,    64,    52,    61,    28,    63,    63,     6,     7,     9,
      13,    14,    15,    22,    23,    24,    27,     8,    52,    57,
      58,    59,    62,    60,    54,    56,    55,    53,    10,    52,
      52,    52,    52,    28,    52,    52,    52,    52
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    31,    33,    32,    34,    34,    34,    35,    36,    35,
      37,    35,    38,    35,    39,    39,    39,    39,    39,    40,
      40,    41,    41,    42,    42,    44,    43,    45,    45,    46,
      46,    47,    47,    48,    48,    48,    48,    49,    50,    50,
      51,    53,    52,    54,    52,    55,    52,    56,    52,    57,
      52,    58,    52,    59,    52,    60,    52,    52,    61,    52,
      62,    52,    52,    52,    52,    52,    63,    63,    64
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     5,     0,     2,     2,     1,     0,     3,
       0,     3,     0,     3,     1,     1,     1,     1,     1,     1,
       2,     1,     2,     2,     2,     0,     5,     1,     2,     0,
       3,     1,     2,     0,     2,     3,     3,     4,     1,     3,
       1,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     4,     3,     0,     4,
       0,     4,     1,     1,     2,     2,     0,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* @1: %empty  */
#line 127 "./yacc.y"
                {
                  (yyval.position) = current_lexema_position;
                }
#line 1352 "y.tab.c"
    break;

  case 3: /* description: declaration_part PERCENTS @1 expression_definition_list ADDITIONAL_C_CODE  */
#line 131 "./yacc.y"
                {
                  IR_node_t first_declaration;
                  IR_node_t first_expression_definition;
                  
                  /* Transform cyclic declaration list to usual list. */
                  if ((yyvsp[-4].node) != NULL)
                    {
                      first_declaration = IR_next_declaration ((yyvsp[-4].node));
                      IR_set_next_declaration ((yyvsp[-4].node), NULL);
                      (yyvsp[-4].node) = first_declaration;
                    }
                  /* Transform cyclic expression definition list to
                     usual list. */
                  if ((yyvsp[-1].node) != NULL)
                    {
                      first_expression_definition
                        = IR_next_expression_definition ((yyvsp[-1].node));
                      IR_set_next_expression_definition ((yyvsp[-1].node), NULL);
                      (yyvsp[-1].node) = first_expression_definition;
                    }
                  description
                    = IR_new_description
                      (((yyvsp[-4].node) == NULL ? (yyvsp[-2].position) : IR_position ((yyvsp[-4].node))),
                       (yyvsp[-4].node), (yyvsp[-1].node), (yyvsp[0].node));
                }
#line 1382 "y.tab.c"
    break;

  case 4: /* declaration_part: %empty  */
#line 161 "./yacc.y"
                                                    {(yyval.node) = NULL;}
#line 1388 "y.tab.c"
    break;

  case 5: /* declaration_part: declaration_part declaration  */
#line 163 "./yacc.y"
                     {
                       if ((yyvsp[-1].node) == NULL)
                         /* Make cycle. */
                         IR_set_next_declaration ((yyvsp[0].node), (yyvsp[0].node));
                       else
                         {
                           /* Add element to cyclic list */
                           IR_set_next_declaration ((yyvsp[0].node),
                                                    IR_next_declaration ((yyvsp[-1].node)));
                           IR_set_next_declaration ((yyvsp[-1].node), (yyvsp[0].node));
                         }
                       (yyval.node) = (yyvsp[0].node);
                     }
#line 1406 "y.tab.c"
    break;

  case 6: /* declaration_part: declaration_part error  */
#line 177 "./yacc.y"
                     {
                       syntax_error ("syntax error in declaration");
                       (yyval.node) = (yyvsp[-1].node);  /* Ignore error declaration. */
                     }
#line 1415 "y.tab.c"
    break;

  case 7: /* declaration: identifier_declaration  */
#line 184 "./yacc.y"
                {
                  IR_node_t first_identifier;

                  if (IR_identifier_list ((yyvsp[0].node)) != NULL)
                    {
                      /* Transform cyclic list to usual list. */
                      first_identifier
                        = IR_next_identifier (IR_identifier_list ((yyvsp[0].node)));
                      IR_set_next_identifier (IR_identifier_list ((yyvsp[0].node)), NULL);
                      IR_set_identifier_list ((yyvsp[0].node), first_identifier);
                    }
                  if (IR_IS_OF_TYPE ((yyvsp[0].node), IR_NM_exclusion_clause)
		      && IR_identifier_list_2 ((yyvsp[0].node)) != NULL)
                    {
                      /* Transform cyclic list to usual list. */
                      first_identifier
                        = IR_next_identifier (IR_identifier_list_2 ((yyvsp[0].node)));
                      IR_set_next_identifier (IR_identifier_list_2 ((yyvsp[0].node)), NULL);
                      IR_set_identifier_list_2 ((yyvsp[0].node), first_identifier);
                    }
                  (yyval.node) = (yyvsp[0].node);
                }
#line 1442 "y.tab.c"
    break;

  case 8: /* @2: %empty  */
#line 206 "./yacc.y"
                     {(yyval.position) = current_lexema_position;}
#line 1448 "y.tab.c"
    break;

  case 9: /* declaration: LOCAL @2 CODE_INSERTION  */
#line 207 "./yacc.y"
                {
                  (yyval.node) = IR_new_local_code ((yyvsp[-1].position), NULL, (yyvsp[0].node));
                }
#line 1456 "y.tab.c"
    break;

  case 10: /* @3: %empty  */
#line 210 "./yacc.y"
                      {(yyval.position) = current_lexema_position;}
#line 1462 "y.tab.c"
    break;

  case 11: /* declaration: IMPORT @3 CODE_INSERTION  */
#line 211 "./yacc.y"
                {
                  (yyval.node) = IR_new_import_code ((yyvsp[-1].position), NULL, (yyvsp[0].node));
                }
#line 1470 "y.tab.c"
    break;

  case 12: /* @4: %empty  */
#line 214 "./yacc.y"
                      {(yyval.position) = current_lexema_position;}
#line 1476 "y.tab.c"
    break;

  case 13: /* declaration: EXPORT @4 CODE_INSERTION  */
#line 215 "./yacc.y"
                {
                  (yyval.node) = IR_new_export_code ((yyvsp[-1].position), NULL, (yyvsp[0].node));
                }
#line 1484 "y.tab.c"
    break;

  case 14: /* identifier_declaration: instruction_declaration  */
#line 224 "./yacc.y"
                                                         {(yyval.node) = (yyvsp[0].node);}
#line 1490 "y.tab.c"
    break;

  case 15: /* identifier_declaration: reservation_declaration  */
#line 225 "./yacc.y"
                                                         {(yyval.node) = (yyvsp[0].node);}
#line 1496 "y.tab.c"
    break;

  case 16: /* identifier_declaration: unit_declaration  */
#line 226 "./yacc.y"
                                                         {(yyval.node) = (yyvsp[0].node);}
#line 1502 "y.tab.c"
    break;

  case 17: /* identifier_declaration: automaton_declaration  */
#line 227 "./yacc.y"
                                                         {(yyval.node) = (yyvsp[0].node);}
#line 1508 "y.tab.c"
    break;

  case 18: /* identifier_declaration: exclusion_clause  */
#line 228 "./yacc.y"
                                                         {(yyval.node) = (yyvsp[0].node);}
#line 1514 "y.tab.c"
    break;

  case 19: /* instruction_declaration: INSTRUCTION  */
#line 236 "./yacc.y"
                            {
                              (yyval.node)
                                = IR_new_instruction_declaration
                                  (current_lexema_position, NULL, NULL);
                            }
#line 1524 "y.tab.c"
    break;

  case 20: /* instruction_declaration: instruction_declaration IDENTIFIER  */
#line 242 "./yacc.y"
                            {
                              if (IR_identifier_list ((yyvsp[-1].node)) == NULL)
                                /* Make cycle */
                                IR_set_next_identifier ((yyvsp[0].node), (yyvsp[0].node));
                              else
                                {
                                  /* Add element to cyclic list */
                                  IR_set_next_identifier
                                    ((yyvsp[0].node), IR_next_identifier (IR_identifier_list
                                                             ((yyvsp[-1].node))));
                                  IR_set_next_identifier
                                    (IR_identifier_list ((yyvsp[-1].node)), (yyvsp[0].node));
                                }
                              IR_set_identifier_list ((yyvsp[-1].node), (yyvsp[0].node));
                              (yyval.node) = (yyvsp[-1].node);
                            }
#line 1545 "y.tab.c"
    break;

  case 21: /* reservation_declaration: RESERVATION  */
#line 265 "./yacc.y"
                            {
                               (yyval.node)
                                 = IR_new_reservation_declaration
                                   (current_lexema_position, NULL, NULL);
                             }
#line 1555 "y.tab.c"
    break;

  case 22: /* reservation_declaration: reservation_declaration IDENTIFIER  */
#line 271 "./yacc.y"
                            {
                               if (IR_identifier_list ((yyvsp[-1].node)) == NULL)
                                 /* Make cycle */
                                IR_set_next_identifier ((yyvsp[0].node), (yyvsp[0].node));
                               else
                                 {
                                   /* Add element to cyclic list */
                                   IR_set_next_identifier
                                     ((yyvsp[0].node),
                                      IR_next_identifier (IR_identifier_list
                                                          ((yyvsp[-1].node))));
                                   IR_set_next_identifier
                                     (IR_identifier_list ((yyvsp[-1].node)), (yyvsp[0].node));
                                 }
                               IR_set_identifier_list ((yyvsp[-1].node), (yyvsp[0].node));
                               (yyval.node) = (yyvsp[-1].node);
                             }
#line 1577 "y.tab.c"
    break;

  case 23: /* unit_declaration: UNIT optional_automaton_identifier  */
#line 295 "./yacc.y"
                     {
                       (yyval.node) = IR_new_unit_declaration (current_lexema_position,
                                                     NULL, NULL, (yyvsp[0].node));
                     }
#line 1586 "y.tab.c"
    break;

  case 24: /* unit_declaration: unit_declaration IDENTIFIER  */
#line 300 "./yacc.y"
                     {
                       if (IR_identifier_list ((yyvsp[-1].node)) == NULL)
                         /* Make cycle */
                         IR_set_next_identifier ((yyvsp[0].node), (yyvsp[0].node));
                       else
                         {
                           /* Add element to cyclic list */
                           IR_set_next_identifier
                             ((yyvsp[0].node), IR_next_identifier (IR_identifier_list
                                                      ((yyvsp[-1].node))));
                           IR_set_next_identifier
                             (IR_identifier_list ((yyvsp[-1].node)), (yyvsp[0].node));
                         }
                       IR_set_identifier_list ((yyvsp[-1].node), (yyvsp[0].node));
                       (yyval.node) = (yyvsp[-1].node);
                     }
#line 1607 "y.tab.c"
    break;

  case 25: /* @5: %empty  */
#line 318 "./yacc.y"
                             {(yyval.position) = current_lexema_position;}
#line 1613 "y.tab.c"
    break;

  case 26: /* exclusion_clause: EXCLUSION @5 identifier_list COLON identifier_list  */
#line 320 "./yacc.y"
                     {
		       (yyval.node) = IR_new_exclusion_clause ((yyvsp[-3].position),
						     NULL, (yyvsp[-2].node), (yyvsp[0].node));
		     }
#line 1622 "y.tab.c"
    break;

  case 27: /* identifier_list: IDENTIFIER  */
#line 330 "./yacc.y"
                    {
                      IR_set_next_identifier ((yyvsp[0].node), (yyvsp[0].node));
                      (yyval.node) = (yyvsp[0].node);
                    }
#line 1631 "y.tab.c"
    break;

  case 28: /* identifier_list: identifier_list IDENTIFIER  */
#line 335 "./yacc.y"
                    {
		      /* Add element to cyclic list */
		      IR_set_next_identifier ((yyvsp[0].node), IR_next_identifier ((yyvsp[-1].node)));
		      IR_set_next_identifier ((yyvsp[-1].node), (yyvsp[0].node));
		      (yyval.node) = (yyvsp[-1].node);
                    }
#line 1642 "y.tab.c"
    break;

  case 29: /* optional_automaton_identifier: %empty  */
#line 346 "./yacc.y"
                                  {(yyval.node) = NULL;}
#line 1648 "y.tab.c"
    break;

  case 30: /* optional_automaton_identifier: LEFT_ANGLE_BRACKET IDENTIFIER RIGHT_ANGLE_BRACKET  */
#line 349 "./yacc.y"
                                  {(yyval.node) = (yyvsp[-1].node);}
#line 1654 "y.tab.c"
    break;

  case 31: /* automaton_declaration: AUTOMATON  */
#line 358 "./yacc.y"
      {
        (yyval.node) = IR_new_automaton_declaration (current_lexema_position,
                                           NULL, NULL);
      }
#line 1663 "y.tab.c"
    break;

  case 32: /* automaton_declaration: automaton_declaration IDENTIFIER  */
#line 363 "./yacc.y"
      {
        if (IR_identifier_list ((yyvsp[-1].node)) == NULL)
          /* Make cycle */
          IR_set_next_identifier ((yyvsp[0].node), (yyvsp[0].node));
        else
          {
            /* Add element to cyclic list */
            IR_set_next_identifier
              ((yyvsp[0].node), IR_next_identifier (IR_identifier_list
                                       ((yyvsp[-1].node))));
            IR_set_next_identifier
              (IR_identifier_list ((yyvsp[-1].node)), (yyvsp[0].node));
          }
        IR_set_identifier_list ((yyvsp[-1].node), (yyvsp[0].node));
        (yyval.node) = (yyvsp[-1].node);
      }
#line 1684 "y.tab.c"
    break;

  case 33: /* expression_definition_list: %empty  */
#line 385 "./yacc.y"
                               {(yyval.node) = NULL; }
#line 1690 "y.tab.c"
    break;

  case 34: /* expression_definition_list: expression_definition_list expression_definition  */
#line 387 "./yacc.y"
                               {
                                 if ((yyvsp[-1].node) != NULL)
                                   {
                                     IR_node_t first_expression;

                                     /* Add cyclic list to the first
                                        cyclic list. */
                                     first_expression
                                       = IR_next_expression_definition ((yyvsp[0].node));
                                     IR_set_next_expression_definition
                                       ((yyvsp[0].node),
                                        IR_next_expression_definition ((yyvsp[-1].node)));
                                     IR_set_next_expression_definition
                                       ((yyvsp[-1].node), first_expression);
                                   }
                                 (yyval.node) = (yyvsp[0].node);
                               }
#line 1712 "y.tab.c"
    break;

  case 35: /* expression_definition_list: expression_definition_list error SEMICOLON  */
#line 405 "./yacc.y"
                               {
                                 syntax_error
                                   ("syntax error in expression definition");
                                 (yyval.node) = (yyvsp[-2].node); /* Ignore error expression. */
                               }
#line 1722 "y.tab.c"
    break;

  case 36: /* expression_definition_list: expression_definition_list error ADDITIONAL_C_CODE  */
#line 411 "./yacc.y"
                               {
                                 yychar = ADDITIONAL_C_CODE;
                                 syntax_error
                                   ("syntax error in expression definition");
                                 (yyval.node) = (yyvsp[-2].node); /* Ignore error expression. */
                               }
#line 1733 "y.tab.c"
    break;

  case 37: /* expression_definition: instruction_or_reservation_identifier_list COLON expression SEMICOLON  */
#line 425 "./yacc.y"
                          {
                            IR_node_t first_expression_definition;
                            IR_node_t current_expression_definition;

                            assert ((yyvsp[-3].node) != NULL);
                            /* Set up expression for expression definitions. */
                            first_expression_definition
                              = IR_next_expression_definition ((yyvsp[-3].node));
                            current_expression_definition
                              = first_expression_definition;
                            for (;;)
                              {
                                IR_set_expression
                                  (current_expression_definition, (yyvsp[-1].node));
                                if (current_expression_definition == (yyvsp[-3].node))
                                  break;
                                current_expression_definition
                                  = IR_next_expression_definition
                                    (current_expression_definition);
                              }
                            (yyval.node) = (yyvsp[-3].node);
                          }
#line 1760 "y.tab.c"
    break;

  case 38: /* instruction_or_reservation_identifier_list: instruction_or_reservation_identifier  */
#line 455 "./yacc.y"
       {
         IR_set_next_expression_definition ((yyvsp[0].node), (yyvsp[0].node));
         (yyval.node) = (yyvsp[0].node);
       }
#line 1769 "y.tab.c"
    break;

  case 39: /* instruction_or_reservation_identifier_list: instruction_or_reservation_identifier_list COMMA instruction_or_reservation_identifier  */
#line 461 "./yacc.y"
       {
         assert ((yyvsp[-2].node) != NULL);
         /* Add element to cyclic list */
         IR_set_next_expression_definition
           ((yyvsp[0].node), IR_next_expression_definition ((yyvsp[-2].node)));
         IR_set_next_expression_definition ((yyvsp[-2].node), (yyvsp[0].node));
         (yyval.node) = (yyvsp[0].node);
       }
#line 1782 "y.tab.c"
    break;

  case 40: /* instruction_or_reservation_identifier: IDENTIFIER  */
#line 473 "./yacc.y"
      {
        (yyval.node) = IR_new_expression_definition (current_lexema_position, (yyvsp[0].node));
      }
#line 1790 "y.tab.c"
    break;

  case 41: /* @6: %empty  */
#line 479 "./yacc.y"
                {
                  yychar = IDENTIFIER;
                  (yyval.position) = current_lexema_position;
                }
#line 1799 "y.tab.c"
    break;

  case 42: /* expression: expression IDENTIFIER @6 expression  */
#line 484 "./yacc.y"
                {
                  (yyval.node) = IR_new_new_cycle_concatenation ((yyvsp[-1].position), (yyvsp[-3].node), (yyvsp[0].node));
                }
#line 1807 "y.tab.c"
    break;

  case 43: /* @7: %empty  */
#line 488 "./yacc.y"
                {
                  yychar = NOTHING;
                  (yyval.position) = current_lexema_position;
                }
#line 1816 "y.tab.c"
    break;

  case 44: /* expression: expression NOTHING @7 expression  */
#line 493 "./yacc.y"
                {
                  (yyval.node) = IR_new_new_cycle_concatenation ((yyvsp[-1].position), (yyvsp[-3].node), (yyvsp[0].node));
                }
#line 1824 "y.tab.c"
    break;

  case 45: /* @8: %empty  */
#line 497 "./yacc.y"
                {
                  yychar = RESULT;
                  (yyval.position) = current_lexema_position;
                }
#line 1833 "y.tab.c"
    break;

  case 46: /* expression: expression RESULT @8 expression  */
#line 502 "./yacc.y"
                {
                  (yyval.node) = IR_new_new_cycle_concatenation ((yyvsp[-1].position), (yyvsp[-3].node), (yyvsp[0].node));
                }
#line 1841 "y.tab.c"
    break;

  case 47: /* @9: %empty  */
#line 506 "./yacc.y"
                {
                  yychar = INPUT;
                  (yyval.position) = current_lexema_position;
                }
#line 1850 "y.tab.c"
    break;

  case 48: /* expression: expression INPUT @9 expression  */
#line 511 "./yacc.y"
                {
                  (yyval.node) = IR_new_new_cycle_concatenation ((yyvsp[-1].position), (yyvsp[-3].node), (yyvsp[0].node));
                }
#line 1858 "y.tab.c"
    break;

  case 49: /* @10: %empty  */
#line 515 "./yacc.y"
                {
                  yychar = LEFT_PARENTHESIS;
                  (yyval.position) = current_lexema_position;
                }
#line 1867 "y.tab.c"
    break;

  case 50: /* expression: expression LEFT_PARENTHESIS @10 expression  */
#line 520 "./yacc.y"
                {
                  (yyval.node) = IR_new_new_cycle_concatenation ((yyvsp[-1].position), (yyvsp[-3].node), (yyvsp[0].node));
                }
#line 1875 "y.tab.c"
    break;

  case 51: /* @11: %empty  */
#line 524 "./yacc.y"
                {
                  yychar = LEFT_BRACKET;
                  (yyval.position) = current_lexema_position;
                }
#line 1884 "y.tab.c"
    break;

  case 52: /* expression: expression LEFT_BRACKET @11 expression  */
#line 529 "./yacc.y"
                {
                  (yyval.node) = IR_new_new_cycle_concatenation ((yyvsp[-1].position), (yyvsp[-3].node), (yyvsp[0].node));
                }
#line 1892 "y.tab.c"
    break;

  case 53: /* @12: %empty  */
#line 532 "./yacc.y"
                              {(yyval.position) = current_lexema_position;}
#line 1898 "y.tab.c"
    break;

  case 54: /* expression: expression PLUS @12 expression  */
#line 534 "./yacc.y"
                {
                  (yyval.node) = IR_new_concatenation ((yyvsp[-1].position), (yyvsp[-3].node), (yyvsp[0].node));
                }
#line 1906 "y.tab.c"
    break;

  case 55: /* @13: %empty  */
#line 537 "./yacc.y"
                             {(yyval.position) = current_lexema_position;}
#line 1912 "y.tab.c"
    break;

  case 56: /* expression: expression STAR @13 NUMBER  */
#line 538 "./yacc.y"
                {
                  (yyval.node) = IR_new_repetition ((yyvsp[-1].position), (yyvsp[-3].node), (yyvsp[0].node));
                }
#line 1920 "y.tab.c"
    break;

  case 57: /* expression: LEFT_PARENTHESIS expression RIGHT_PARENTHESIS  */
#line 541 "./yacc.y"
                                                               {(yyval.node) = (yyvsp[-1].node);}
#line 1926 "y.tab.c"
    break;

  case 58: /* @14: %empty  */
#line 542 "./yacc.y"
                          {(yyval.position) = current_lexema_position;}
#line 1932 "y.tab.c"
    break;

  case 59: /* expression: LEFT_BRACKET @14 expression RIGHT_BRACKET  */
#line 544 "./yacc.y"
                {
                  (yyval.node) = IR_new_optional_expression ((yyvsp[-2].position), (yyvsp[-1].node));
                }
#line 1940 "y.tab.c"
    break;

  case 60: /* @15: %empty  */
#line 547 "./yacc.y"
                             {(yyval.position) = current_lexema_position;}
#line 1946 "y.tab.c"
    break;

  case 61: /* expression: expression BAR @15 expression  */
#line 549 "./yacc.y"
                {
                  (yyval.node) = IR_new_alternative ((yyvsp[-1].position), (yyvsp[-3].node), (yyvsp[0].node));
                }
#line 1954 "y.tab.c"
    break;

  case 62: /* expression: unit_or_reservation_identifier  */
#line 553 "./yacc.y"
                {
                  (yyval.node) = IR_new_expression_atom (IR_position ((yyvsp[0].node)), (yyvsp[0].node));
                }
#line 1962 "y.tab.c"
    break;

  case 63: /* expression: NOTHING  */
#line 557 "./yacc.y"
                {
                  (yyval.node) = IR_new_nothing (current_lexema_position);
                }
#line 1970 "y.tab.c"
    break;

  case 64: /* expression: RESULT input_result_number  */
#line 561 "./yacc.y"
                {
                  (yyval.node) = IR_new_result (current_lexema_position, (yyvsp[0].inumber));
                }
#line 1978 "y.tab.c"
    break;

  case 65: /* expression: INPUT input_result_number  */
#line 565 "./yacc.y"
                {
                  (yyval.node) = IR_new_input (current_lexema_position, (yyvsp[0].inumber));
                }
#line 1986 "y.tab.c"
    break;

  case 66: /* input_result_number: %empty  */
#line 570 "./yacc.y"
                             {(yyval.inumber) = 0;}
#line 1992 "y.tab.c"
    break;

  case 67: /* input_result_number: NUMBER  */
#line 571 "./yacc.y"
                             {(yyval.inumber) = IR_number_value ((yyvsp[0].node));}
#line 1998 "y.tab.c"
    break;

  case 68: /* unit_or_reservation_identifier: IDENTIFIER  */
#line 574 "./yacc.y"
                                              {(yyval.node) = (yyvsp[0].node);}
#line 2004 "y.tab.c"
    break;


#line 2008 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 578 "./yacc.y"




/* This page contains abstract data `scanner'.  This abstract data
   divides input stream characters on tokens (lexemas). */

/* The following structure describes current input stream and scanner
   state. */

struct input_stream_state
{
  FILE *input_file;
  /* The following member is TRUE if the first `%%' in given input stream
     was already processed or FALSE otherwise. */
  int it_is_first_percents;
  /* The following member is TRUE if the ADDITIONAL_CODE lexema was already
     returned by the scanner or FALSE otherwise.  Remember that lexema
     ADDITIONAL_CODE is always returned by the scanner
     even if second `%%' in the input stream is absent. */
  int additional_c_code_was_returned;
};

/* The following structure contains current input stream and
   scanner state.  If the member `input_file' value is NULL
   then input stream is not defined. */

static struct input_stream_state current_input_stream_state;


/* The function returns lexical code of corresponding keyword or 0 if
   given identifier (parameter `str' is identifier (without start `%')
   string with end marker '\0'; `length' is length of identifier
   string without end marker '\0') is not keyword.  Fast search is
   implemented by minimal pruned O-trie forest.  */

static int
find_keyword (const char *str, int length)
{
  switch (length)
    {
    case 4:
      return (strcmp (str, "unit") == 0 ? UNIT : 0);
    case 5:
      return (strcmp (str, "local") == 0 ? LOCAL : 0);
    case 6:
      switch (*str)
        {
        case 'e':
          return (strcmp (str, "export") == 0 ? EXPORT : 0);
        case 'i':
          return (strcmp (str, "import") == 0 ? IMPORT : 0);
        default:
          return 0;
        }
    case 7:
      return (strcmp (str, "nothing") == 0 ? NOTHING : 0);
    case 9:
      if (*str == 'e')
	return (strcmp (str, "exclusion") == 0 ? EXCLUSION : 0);
      else
	return (strcmp (str, "automaton") == 0 ? AUTOMATON : 0);
    case 11:
      switch (*str)
        {
        case 'i':
          return (strcmp (str, "instruction") == 0 ? INSTRUCTION : 0);
        case 'r':
          return (strcmp (str, "reservation") == 0 ? RESERVATION : 0);
        default:
          return 0;
        }
    default:
      return 0;
    }
}

/* The following value is used if previous_char does not contain an
   input char */

#define EMPTY_PREVIOUS_CHAR (-2000)

/* The following variable is used for storing '\r'. */

static int previous_char;

/* The following two functions for replacing "\r\n" onto "\n". */

static int
getch (FILE *f)
{
  int c;

  if (previous_char != '\r')
    c = getc (f);
  else
    {
      c = previous_char;
      previous_char = EMPTY_PREVIOUS_CHAR;
    }
  if (c == '\r')
    {
      c = getc (f);
      if (c != '\n')
        {
          ungetc (c, f);
          c = '\r';
        }
    }
  return c;
}

static void
ungetch (int c, FILE *f)
{
  if (c != '\r')
    ungetc (c, f);
  else
    previous_char = c;
}


/* The function skips C commentary.  Parameter `store_flag' is flag of
   storing commentary characters onto top internal representation
   object.  The function returns TRUE if no error (EOF) was fixed,
   otherwise FALSE
     Current position corresponds to `*' after commentary start ('/')
   before the function call.  Current_position corresponds to first
   character after skipped commentary ('/') or EOF after the function
   call. */

static int
skip_commentary (int store_flag)
{
  int input_char;
  
  current_position.column_number++;
  if (store_flag)
    IR_TOP_ADD_BYTE ('*');
  for (;;)
    {
      input_char = getch (current_input_stream_state.input_file);
      /* Here `current_position' corresponds to `input_char'. */
      if (input_char == '*')
        {
          if (store_flag)
            IR_TOP_ADD_BYTE (input_char);
          input_char = getch (current_input_stream_state.input_file);
          current_position.column_number++;
          /* Here `current_position' corresponds to `input_char'. */
          if (input_char == '/')
            {
              if (store_flag)
                IR_TOP_ADD_BYTE (input_char);
              current_position.column_number++;
              return TRUE;
            }
          else
            {
              ungetch (input_char, current_input_stream_state.input_file);
              continue;
            }
        }
      else if (input_char == EOF)
        {
          ungetch (input_char, current_input_stream_state.input_file);
          return FALSE;
        }
      if (input_char == '\n')
        {
          current_position.column_number = 1;
          current_position.line_number++;
        }
      else if (input_char == '\t')
        current_position.column_number
          = ((current_position.column_number - 1) / TAB_STOP + 1)
            * TAB_STOP + 1;
      else
        current_position.column_number++;
      if (store_flag)
        IR_TOP_ADD_BYTE (input_char);
    }
}


/* The function skips C string code (e.g `a', `\n', or `\077').  The
   function also stores skipped characters onto top internal
   representation object.  Parameter `input_char' is the most recent
   read character.  The function returns (with the aid of parameter
   `correct_new_line') flag of that correct new line was read.  The
   function returns TRUE if no error (EOF or incorrect new line) was
   fixed, otherwise FALSE.
     The value of parameter `correct_new_line' can be used for fixing
   errors when character constant is processed.  It is supposed that
   the current character is not end marker (string or character
   constant).  Current position corresponds to parameter `input_char'
   before the function call.  Current_position corresponds to first
   character after skipped valid character code or EOF (or incorrect
   new line) after the function call. */

static int
skip_string_code (int input_char, int *correct_new_line)
{
  if (input_char == EOF || input_char == '\n')
    {
      ungetch (input_char, current_input_stream_state.input_file);
      return FALSE;
    }
  *correct_new_line = FALSE;
  IR_TOP_ADD_BYTE (input_char);
  if (input_char == '\\')
    {
      current_position.column_number++;
      input_char = getch (current_input_stream_state.input_file);
      IR_TOP_ADD_BYTE (input_char);
      if (input_char == 'n' || input_char == 't' || input_char == 'v'
          || input_char == 'b' || input_char == 'r' || input_char == 'f'
          || input_char == '\\' || input_char == '\'' || input_char == '\"')
        current_position.column_number++;
      else if (input_char == '\n')
        {
          current_position.column_number = 1;
          current_position.line_number++;
          *correct_new_line = TRUE;
        }
      else if (isdigit (input_char) && input_char != '8'
               && input_char != '9')
        {
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (!isdigit (input_char) || input_char == '8'
              || input_char == '9')
            ungetch (input_char, current_input_stream_state.input_file);
          else
            {
              current_position.column_number++;
              IR_TOP_ADD_BYTE (input_char);
              input_char = getch (current_input_stream_state.input_file);
              if (!isdigit (input_char) || input_char == '8'
                  || input_char == '9')
                ungetch (input_char, current_input_stream_state.input_file);
              else
                {
                  current_position.column_number++;
                  IR_TOP_ADD_BYTE (input_char);
                }
            }
        }
      else
        current_position.column_number++;
    }
  else if (input_char == '\t')
    current_position.column_number
      = ((current_position.column_number - 1) / TAB_STOP + 1) * TAB_STOP + 1;
  else
    current_position.column_number++;
  return TRUE;
}

/* The function skips C character constant by using function
   `skip_string_code'.  The function may fix error in the C character
   constant.  The function also stores skipped characters onto top
   internal representation object.  Current position corresponds to
   first character after '\'' (which was already read) before the
   function call.  Current_position corresponds to to first character
   after '\'' if error was not fixed after the function call. */

static void
skip_C_character (void)
{
  int input_char;
  int correct_new_line;
  int error_flag;

  error_flag = FALSE;
  input_char = getch (current_input_stream_state.input_file);
  /* Here `current_position' corresponds to `input_char'. */
  if (input_char == '\'')
    {
      IR_TOP_ADD_BYTE (input_char);
      error (FALSE, current_position, "invalid character constant");
      current_position.column_number++;
      error_flag = TRUE;
    }
  else
    {
      if (!skip_string_code (input_char, &correct_new_line)
          || correct_new_line)
        {
          error (FALSE, current_position, "invalid character constant");
          error_flag = TRUE;
        }
    }
  input_char = getch (current_input_stream_state.input_file);
  if (input_char != '\'')
    {
      ungetch (input_char, current_input_stream_state.input_file);
      if (!error_flag)
        error (FALSE, current_position, "invalid character constant");
    }
  else
    {
      IR_TOP_ADD_BYTE (input_char);
      current_position.column_number++;
    }
}

/* The function skips C string constant by using function
   `skip_string_code'.  The function may fix error in the C string
   constant.  The function also stores skipped characters onto top
   internal representation object.  Current position corresponds to
   first character after '\"' (which was already read) before the
   function call.  Current_position corresponds to to first character
   after '\"' if error was not fixed after the function call.  */

static void
skip_C_string (void)
{
  int input_char;
  int correct_new_line;
  
  for (;;)
    {
      /* Here `current_position' corresponds to next character. */
      input_char = getch (current_input_stream_state.input_file);
      if (input_char == '\"')
        {
          current_position.column_number++;
          IR_TOP_ADD_BYTE (input_char); 
          break;
        }
      if (!skip_string_code (input_char, &correct_new_line))
        {
          error (FALSE, current_position, "string end is absent");
          break;
        }
    }
}

/* This function is major scanner function.  The function recognizes
   next source lexema from the input file, returns its code, modifies
   variable current_position so that its value is equal to position of
   the current character in the current input file and sets up
   variable `current_lexema_position' so that its value is equal to
   start position of the returned lexema, creates corresponding
   internal representation node (if it is needed) and sets up yylval
   to the node.  The function skips all white spaces and commentaries
   and fixes the most of lexical errors. */

int
yylex (void)
{
  int input_char;
  int number_of_successive_error_characters;
  
  for (number_of_successive_error_characters = 0;;)
    {
      input_char = getch (current_input_stream_state.input_file);
      /* `current_position' corresponds `input_char' here */
      switch (input_char)
        {
        case '\f':
          /* flow-through */
        case ' ':
          current_position.column_number++;
          break;
        case '\t':
          current_position.column_number
            = ((current_position.column_number - 1) / TAB_STOP + 1)
              * TAB_STOP + 1;
          break;
        case '\n':
          current_position.column_number = 1;
          current_position.line_number++;
          break;
        case EOF:
          current_lexema_position = current_position;
          if (!current_input_stream_state.additional_c_code_was_returned)
            {
              char *additional_code_itself;

              ungetch (input_char, current_input_stream_state.input_file);
              current_input_stream_state.additional_c_code_was_returned = TRUE;
              IR_TOP_ADD_BYTE ('\0');
              additional_code_itself = IR_TOP_BEGIN ();
              IR_TOP_FINISH ();
              yylval.node = IR_new_additional_code (current_lexema_position,
                                                    additional_code_itself);
              return ADDITIONAL_C_CODE;
            }
          else
            return 0;
        case '/':
          current_lexema_position = current_position;
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (input_char != '*')
            {
              number_of_successive_error_characters++;
              if (number_of_successive_error_characters == 1)
                error (FALSE, current_lexema_position,
                       "invalid input character '/'");
              ungetch (input_char, current_input_stream_state.input_file);
            }
          else if (!skip_commentary (FALSE))
            error (FALSE, current_lexema_position, "commentary end is absent");
          break;
        case '(':
          current_lexema_position = current_position;
          current_position.column_number++;
          return LEFT_PARENTHESIS;
        case ')':
          current_lexema_position = current_position;
          current_position.column_number++;
          return RIGHT_PARENTHESIS;
        case '[':
          current_lexema_position = current_position;
          current_position.column_number++;
          return LEFT_BRACKET;
        case ']':
          current_lexema_position = current_position;
          current_position.column_number++;
          return RIGHT_BRACKET;
        case '<':
          current_lexema_position = current_position;
          current_position.column_number++;
          return LEFT_ANGLE_BRACKET;
        case '>':
          current_lexema_position = current_position;
          current_position.column_number++;
          return RIGHT_ANGLE_BRACKET;
        case ';':
          current_lexema_position = current_position;
          current_position.column_number++;
          return SEMICOLON;
        case ',':
          current_lexema_position = current_position;
          current_position.column_number++;
          return COMMA;
        case ':':
          current_lexema_position = current_position;
          current_position.column_number++;
          return COLON;
        case '+':
          current_lexema_position = current_position;
          current_position.column_number++;
          return PLUS;
        case '*':
          current_lexema_position = current_position;
          current_position.column_number++;
          return STAR;
        case '|':
          current_lexema_position = current_position;
          current_position.column_number++;
          return BAR;
        case '{':
          {
            int bracket_level = 1;
            int error_flag;
            char *code_itself;
            
            current_lexema_position = current_position;
            current_position.column_number++;
            for (error_flag = FALSE; !error_flag && bracket_level != 0;)
              {
                input_char = getch (current_input_stream_state.input_file);
                IR_TOP_ADD_BYTE (input_char);
                /* `current_position' corresponds to `input_char' here */
                switch (input_char)
                  {
                  case '/':
                    current_position.column_number++;
                    input_char = getch (current_input_stream_state.input_file);
                    if (input_char == '*')
                      {
                        current_position.column_number++;
                        error_flag = !skip_commentary (TRUE);
                      }
                    else
                      ungetch (input_char,
                               current_input_stream_state.input_file);
                    break;
                  case '{':
                    current_position.column_number++;
                    bracket_level++;
                    break;
                  case '}':
                    current_position.column_number++;
                    bracket_level--;
                    if (bracket_level == 0)
                      IR_TOP_SHORTEN (1);
                    break;
                  case '\'':
                    current_position.column_number++;
                    skip_C_character ();
                    break;
                  case '\"':
                    current_position.column_number++;
                    skip_C_string ();
                    break;
                  case '\t':
                    current_position.column_number
                      = ((current_position.column_number - 1) / TAB_STOP + 1)
                        * TAB_STOP + 1;
                    break;
                  case '\n':
                    current_position.column_number = 1;
                    current_position.line_number++;
                    break;
                  case EOF:
                    IR_TOP_SHORTEN (1);
                    ungetch (input_char,
                             current_input_stream_state.input_file);
                    error_flag = TRUE;
                    break;
                  default:
                    current_position.column_number++;
                    break;
                  }
              }
            if (error_flag)
              error (FALSE, current_lexema_position,
                     "C code insertion end is absent");
            IR_TOP_ADD_BYTE ('\0');
            code_itself = IR_TOP_BEGIN ();
            IR_TOP_FINISH ();
            yylval.node = IR_new_code_insertion (current_lexema_position,
                                                 code_itself);
            return CODE_INSERTION;
          }
        case '%':
          current_lexema_position = current_position;
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (input_char == '%')
            {
              current_position.column_number++;
              if (current_input_stream_state.it_is_first_percents)
                {
                  current_input_stream_state.it_is_first_percents = FALSE;
                  return PERCENTS;
                }
              else
                {
                  char *additional_code_itself;

                  current_position.column_number++;
                  input_char = getch (current_input_stream_state.input_file);
                  while (input_char != EOF)
                    {
                      current_position.column_number++;
                      IR_TOP_ADD_BYTE (input_char);
                      input_char
                        = getch (current_input_stream_state.input_file);
                    }
                  ungetch (input_char, current_input_stream_state.input_file);
                  IR_TOP_ADD_BYTE ('\0');
                  additional_code_itself = IR_TOP_BEGIN ();
                  IR_TOP_FINISH ();
                  current_input_stream_state.additional_c_code_was_returned
                    = TRUE;
                  yylval.node
                    = IR_new_additional_code (current_lexema_position,
                                              additional_code_itself);
                  return ADDITIONAL_C_CODE;
                }
            }
          else if (isalpha (input_char) || input_char == '_' )
            {
              int keyword;
              
              /* Identifier recognition. */
              do
                {
                  current_position.column_number++;
                  IR_TOP_ADD_BYTE (input_char);
                  input_char = getch (current_input_stream_state.input_file);
                }
              while (isalpha (input_char) || isdigit (input_char)
                     || input_char == '_');
              ungetch (input_char, current_input_stream_state.input_file);
              IR_TOP_ADD_BYTE ('\0');
              keyword = find_keyword (IR_TOP_BEGIN (), IR_TOP_LENGTH () - 1);
              if (keyword != 0)
                {
                  IR_TOP_NULLIFY ();
                  return keyword;
                }
              else
                {
                  error (FALSE, current_lexema_position,
                         "unknown keyword `%%%s'", IR_TOP_BEGIN ());
                  IR_TOP_NULLIFY ();
                }
            }
          else
            {
              number_of_successive_error_characters++;
              if (number_of_successive_error_characters == 1)
                error (FALSE, current_lexema_position,
                       "invalid input character '%%'");
              ungetch (input_char, current_input_stream_state.input_file);
            }
          break;
        default:
          if (isalpha (input_char) || input_char == '_' )
            {
              char *identifier_itself;

              current_lexema_position = current_position;
              /* Identifier recognition. */
              do
                {
                  current_position.column_number++;
                  IR_TOP_ADD_BYTE (input_char);
                  input_char = getch (current_input_stream_state.input_file);
                }
              while (isalpha (input_char) || isdigit (input_char)
                     || input_char == '_');
              ungetch (input_char, current_input_stream_state.input_file);
              IR_TOP_ADD_BYTE ('\0');
              identifier_itself = insert_identifier (IR_TOP_BEGIN ());
              if (identifier_itself == (char *) IR_TOP_BEGIN ())
                IR_TOP_FINISH ();
              else
                IR_TOP_NULLIFY ();
              yylval.node = IR_new_identifier (current_lexema_position,
                                               identifier_itself, NULL);
              return IDENTIFIER;
            }
          else if (isdigit (input_char))
            {
              int value;

              current_lexema_position = current_position;
              value = 0;
              /* Number recognition. */
              do
                {
                  current_position.column_number++;
                  value = value * 10 + (input_char - '0');
                  input_char = getch (current_input_stream_state.input_file);
                }
              while (isdigit (input_char));
              ungetch (input_char, current_input_stream_state.input_file);
              yylval.node = IR_new_number (current_lexema_position, value);
              return NUMBER;
            }
          else
            {
              number_of_successive_error_characters++;
              if (number_of_successive_error_characters == 1)
                {
                  if (isprint (input_char))
                    error (FALSE, current_position,
                           "invalid input character '%c'", input_char);
                  else
                    error (FALSE, current_position, "invalid input character");
                }
              current_position.column_number++;
            }
          break;
        }
    }
}

/* The function initiates current input stream and scanner state as
   undefined.  The function must be called only once before any work
   with the scanner.  */

static void
initiate_scanner (void)
{
  current_input_stream_state.input_file = NULL;
  current_input_stream_state.it_is_first_percents = TRUE;
  current_input_stream_state.additional_c_code_was_returned = FALSE;
}

/* The function opens file corresponding to new input stream, and sets
   up new current input stream and scanner state.  The function
   reports error if the new file is not opened.  */

static void
start_scanner_file (const char *new_file_name)
{
  current_input_stream_state.input_file = fopen (new_file_name, "rb");
  if (current_input_stream_state.input_file == NULL)
    system_error (TRUE, no_position, "fatal error -- `%s': ", new_file_name);
  start_file_position (new_file_name);
  previous_char = EMPTY_PREVIOUS_CHAR;
  current_input_stream_state.it_is_first_percents = TRUE;
  current_input_stream_state.additional_c_code_was_returned = FALSE;
}

/* The function closes current input file if current input stream
   state is defined.  Only call of function `initiate_scanner' or
   `finish_scanner' is possible immediately after this function call.  */

static void
finish_scanner (void)
{
  if (current_input_stream_state.input_file != NULL)
    {
      fclose (current_input_stream_state.input_file);
      current_input_stream_state.input_file = NULL;
      finish_file_position ();
    }
}



/*   This page contains abstract data `syntax_errors'.  This abstract
   data is used to error reporting.
     YACC has unsatisfactory syntactic error reporting.  Essentially
   YACC generates only one syntactic error "syntax error".  Abstract
   data `syntax_errors' for solution of this problem is suggested
   here.  This abstract data saves only one the most recent error
   message and its position.  Function `yyerror' used only by function
   `yyparse' flushes saved early error message and saves message given
   as parameter (usually this message is simply "syntax error" but may
   be "stack overflow" or others) and its position.  More detail
   diagnostic message is generated by the call of function
   `syntax_error' within action after special token `error'.  This
   function only rewrites saved early error message (not error
   position).  As consequence the message of last call `syntax_error'
   or the message of function `yyerror' (if such call of
   `syntax_error' does not exist) is fixed within one recover mode
   interval because function `yyerror' is called by `yyparse' only in
   non recover mode.
     This solution permits to create brief syntactic message which
   contain partially information about recovery location (error line
   and position is always in non-fatal errors and warnings -- see
   package for `errors').  */


/* This variable saves the most recent syntax error message or NULL (if
   such syntax error was not fixed). */

static const char *last_syntax_error_message;

/* This variable saves the first syntax error position. */

static position_t first_syntax_error_position;

/* The function initiates the abstract data as without saved syntax
   error message.  The function must be called only once before any
   work with the abstract data.  */

static void
initiate_syntax_errors (void)
{
  last_syntax_error_message = NULL;
}

/* The function flushes saved syntax error message, if any.  */

static void
flush_syntax_error (void)
{
  if (last_syntax_error_message != NULL)
    {
      error (FALSE, first_syntax_error_position,
             "%s", last_syntax_error_message);
      last_syntax_error_message = NULL;
    }
}

/* The function is called by `yyparse' on syntax error.  This function
   flushes saved syntax error message with the aid of
   `flush_syntax_error' and saves message given as parameter and
   `current_lexema position' as its position (see scanner). */

yyerror (const char *message)
{
  flush_syntax_error ();
  last_syntax_error_message = message;
  first_syntax_error_position = current_lexema_position;
  return 0;
}

/* The function rewrites saved syntax error message but does not
   change saved position.  */

static void
syntax_error (const char *s)
{
  last_syntax_error_message = s;
}

/* The function finishes work with the abstract data (flushes saved
   syntax error message with the aid of function
   `flush_syntax_error').  */

static void
finish_syntax_errors (void)
{
  flush_syntax_error ();
}



/* This page contains all external functions of parser. */

/* The function initiates all internal abstract data (the scanner and
   `syntax_errors').  The function must be called only once before any
   work with the abstract data. */

void
initiate_parser (void)
{
  initiate_scanner ();
  initiate_syntax_errors ();
}

/* The function forces to tune parser onto file with given name (calls
   function `start_scanner_file').  The function must be called only
   once after parser initiation.  */

void
start_parser_file (const char *file_name)
{
  start_scanner_file (file_name);
}

/* This function finishes all internal abstract data (the scanner and
   abstract data `syntax_errors').  Only call of function
   `initiate_parser' or `finish_parser' is possible immediately after
   this function call. */

void
finish_parser (void)
{
  finish_scanner ();
  finish_syntax_errors ();
}

/*
Local Variables:
mode:c
End:
*/
