/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 40 "./yacc.y"


#ifdef HAVE_CONFIG_H
#include "cocom-config.h"
#else /* In this case we are oriented to ANSI C */
#ifndef HAVE_ASSERT_H
#define HAVE_ASSERT_H
#endif
#endif /* #ifdef HAVE_CONFIG_H */

#include <ctype.h>
#include <stdio.h>

#include <string.h>
#include "vlobject.h"
#include "position.h"
#include "errors.h"
#include "ird.h"
#include "common.h"
#include "tab.h"
#include "yacc.h"

#ifdef HAVE_ASSERT_H
#include <assert.h>
#else
#ifndef assert
#define assert(code) do { if (code == 0) abort ();} while (0)
#endif
#endif


/* Attributes of all YACC symbols (token and nonterminals) will be
   of given type. */

#define YYSTYPE IR_node_t

/* This macro value is used for correct calculation of current position in
   file when TAB character is processed. */

#define TAB_STOP 8

/* The following variables and forward definitions of functions are
   used in actions of YACC grammar. */

/* The following variable value is begin position of the last lexema returned
   by the function `yylex'. */

static position_t current_lexema_position;

/* The following variable value is flag of that the last list of
   immediate super types is list of basic immediate super types
   (i.e. this list does not start with comma -- see syntax). */

static int current_basic_super_types_flag;

static int file_has_been_already_processed (const char *new_file_name);

static void start_scanner_file (const char *new_file_name,
                                position_t error_position);

static void finish_scanner_file (void);

static void add_lexema_to_input_file (int lexema_code);

static void syntax_error (const char *s);

static void append_additional_code (IR_node_t additional_code);

static void append_type_list (IR_node_t type_list);

static void append_double_declaration (IR_node_t double_declaration);

static IR_node_t merge_and_set_field_declaration_part_and_class_double_fields
  (IR_node_t class_fields, IR_node_t skeleton_fields, IR_node_t other_fields);

static void process_node_type_list
  (IR_node_t last_node_type, int abstract_flag,
   IR_node_t first_super_type_list_element,
   IR_node_t last_super_type_list_element, int basic_super_types_flag,
   IR_node_t field_list);

static const char *full_extended_file_name  (const char *extend_identifier);

static void finish_parser_file (void);


#line 158 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    PERCENTS = 258,                /* PERCENTS  */
    COMMA = 259,                   /* COMMA  */
    COLON = 260,                   /* COLON  */
    DOUBLE_COLON = 261,            /* DOUBLE_COLON  */
    SEMICOLON = 262,               /* SEMICOLON  */
    EXTENSION = 263,               /* EXTENSION  */
    END_OF_BASIC_FILE = 264,       /* END_OF_BASIC_FILE  */
    DOUBLE = 265,                  /* DOUBLE  */
    EXTEND = 266,                  /* EXTEND  */
    LOCAL = 267,                   /* LOCAL  */
    IMPORT = 268,                  /* IMPORT  */
    EXPORT = 269,                  /* EXPORT  */
    TYPE = 270,                    /* TYPE  */
    ROOT = 271,                    /* ROOT  */
    ABSTRACT = 272,                /* ABSTRACT  */
    CLASS = 273,                   /* CLASS  */
    SKELETON = 274,                /* SKELETON  */
    OTHER = 275,                   /* OTHER  */
    IDENTIFIER = 276,              /* IDENTIFIER  */
    CODE_INSERTION = 277,          /* CODE_INSERTION  */
    EXPRESSION = 278,              /* EXPRESSION  */
    ADDITIONAL_C_CODE = 279        /* ADDITIONAL_C_CODE  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define PERCENTS 258
#define COMMA 259
#define COLON 260
#define DOUBLE_COLON 261
#define SEMICOLON 262
#define EXTENSION 263
#define END_OF_BASIC_FILE 264
#define DOUBLE 265
#define EXTEND 266
#define LOCAL 267
#define IMPORT 268
#define EXPORT 269
#define TYPE 270
#define ROOT 271
#define ABSTRACT 272
#define CLASS 273
#define SKELETON 274
#define OTHER 275
#define IDENTIFIER 276
#define CODE_INSERTION 277
#define EXPRESSION 278
#define ADDITIONAL_C_CODE 279

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_PERCENTS = 3,                   /* PERCENTS  */
  YYSYMBOL_COMMA = 4,                      /* COMMA  */
  YYSYMBOL_COLON = 5,                      /* COLON  */
  YYSYMBOL_DOUBLE_COLON = 6,               /* DOUBLE_COLON  */
  YYSYMBOL_SEMICOLON = 7,                  /* SEMICOLON  */
  YYSYMBOL_EXTENSION = 8,                  /* EXTENSION  */
  YYSYMBOL_END_OF_BASIC_FILE = 9,          /* END_OF_BASIC_FILE  */
  YYSYMBOL_DOUBLE = 10,                    /* DOUBLE  */
  YYSYMBOL_EXTEND = 11,                    /* EXTEND  */
  YYSYMBOL_LOCAL = 12,                     /* LOCAL  */
  YYSYMBOL_IMPORT = 13,                    /* IMPORT  */
  YYSYMBOL_EXPORT = 14,                    /* EXPORT  */
  YYSYMBOL_TYPE = 15,                      /* TYPE  */
  YYSYMBOL_ROOT = 16,                      /* ROOT  */
  YYSYMBOL_ABSTRACT = 17,                  /* ABSTRACT  */
  YYSYMBOL_CLASS = 18,                     /* CLASS  */
  YYSYMBOL_SKELETON = 19,                  /* SKELETON  */
  YYSYMBOL_OTHER = 20,                     /* OTHER  */
  YYSYMBOL_IDENTIFIER = 21,                /* IDENTIFIER  */
  YYSYMBOL_CODE_INSERTION = 22,            /* CODE_INSERTION  */
  YYSYMBOL_EXPRESSION = 23,                /* EXPRESSION  */
  YYSYMBOL_ADDITIONAL_C_CODE = 24,         /* ADDITIONAL_C_CODE  */
  YYSYMBOL_YYACCEPT = 25,                  /* $accept  */
  YYSYMBOL_description = 26,               /* description  */
  YYSYMBOL_27_1 = 27,                      /* $@1  */
  YYSYMBOL_basic_description_part = 28,    /* basic_description_part  */
  YYSYMBOL_29_2 = 29,                      /* $@2  */
  YYSYMBOL_30_3 = 30,                      /* @3  */
  YYSYMBOL_declaration_part = 31,          /* declaration_part  */
  YYSYMBOL_extend_identifier_list = 32,    /* extend_identifier_list  */
  YYSYMBOL_extend_identifier = 33,         /* extend_identifier  */
  YYSYMBOL_34_4 = 34,                      /* @4  */
  YYSYMBOL_predefined_types_declaration = 35, /* predefined_types_declaration  */
  YYSYMBOL_double_nodes_declaration = 36,  /* double_nodes_declaration  */
  YYSYMBOL_code_insertion = 37,            /* code_insertion  */
  YYSYMBOL_node_type_definition_list = 38, /* node_type_definition_list  */
  YYSYMBOL_node_type_definition = 39,      /* node_type_definition  */
  YYSYMBOL_abstract_node_flag = 40,        /* abstract_node_flag  */
  YYSYMBOL_node_type_identifier_list = 41, /* node_type_identifier_list  */
  YYSYMBOL_node_type_identifier = 42,      /* node_type_identifier  */
  YYSYMBOL_optional_immediate_super_type_list = 43, /* optional_immediate_super_type_list  */
  YYSYMBOL_immediate_super_type_list = 44, /* immediate_super_type_list  */
  YYSYMBOL_any_node_type_name = 45,        /* any_node_type_name  */
  YYSYMBOL_class_field_definition_part = 46, /* class_field_definition_part  */
  YYSYMBOL_skeleton_field_definition_part = 47, /* skeleton_field_definition_part  */
  YYSYMBOL_other_field_definition_part = 48, /* other_field_definition_part  */
  YYSYMBOL_field_definition_list = 49,     /* field_definition_list  */
  YYSYMBOL_constraint_or_action = 50,      /* constraint_or_action  */
  YYSYMBOL_field_definition = 51,          /* field_definition  */
  YYSYMBOL_optional_double = 52,           /* optional_double  */
  YYSYMBOL_constraint = 53,                /* constraint  */
  YYSYMBOL_action = 54,                    /* action  */
  YYSYMBOL_field_identifier_list = 55,     /* field_identifier_list  */
  YYSYMBOL_field_identifier = 56           /* field_identifier  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   98

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  25
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  32
/* YYNRULES -- Number of rules.  */
#define YYNRULES  65
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  84

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   279


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   171,   171,   171,   217,   218,   222,   218,   249,   250,
     251,   252,   253,   267,   273,   274,   281,   280,   309,   310,
     320,   329,   330,   338,   347,   353,   359,   371,   372,   376,
     383,   384,   411,   412,   419,   424,   437,   454,   458,   470,
     479,   488,   503,   511,   518,   519,   526,   527,   534,   535,
     541,   542,   552,   563,   572,   573,   579,   599,   600,   605,
     615,   626,   631,   642,   659,   674
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "PERCENTS", "COMMA",
  "COLON", "DOUBLE_COLON", "SEMICOLON", "EXTENSION", "END_OF_BASIC_FILE",
  "DOUBLE", "EXTEND", "LOCAL", "IMPORT", "EXPORT", "TYPE", "ROOT",
  "ABSTRACT", "CLASS", "SKELETON", "OTHER", "IDENTIFIER", "CODE_INSERTION",
  "EXPRESSION", "ADDITIONAL_C_CODE", "$accept", "description", "$@1",
  "basic_description_part", "$@2", "@3", "declaration_part",
  "extend_identifier_list", "extend_identifier", "@4",
  "predefined_types_declaration", "double_nodes_declaration",
  "code_insertion", "node_type_definition_list", "node_type_definition",
  "abstract_node_flag", "node_type_identifier_list",
  "node_type_identifier", "optional_immediate_super_type_list",
  "immediate_super_type_list", "any_node_type_name",
  "class_field_definition_part", "skeleton_field_definition_part",
  "other_field_definition_part", "field_definition_list",
  "constraint_or_action", "field_definition", "optional_double",
  "constraint", "action", "field_identifier_list", "field_identifier", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-56)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-50)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -56,     4,   -56,   -56,    82,   -56,    34,   -56,   -56,    -8,
      14,    16,    18,   -56,    67,    51,   -56,   -56,   -56,    26,
     -56,    24,   -56,    -8,   -56,   -56,   -56,   -56,   -56,   -56,
     -56,   -56,   -56,   -56,    -6,   -56,   -56,    -1,   -56,    45,
     -56,   -56,    24,    21,    38,    53,   -56,    61,   -56,    -4,
     -56,   -56,    40,    -4,   -56,   -56,     0,   -56,    54,   -56,
     -56,   -56,   -56,   -56,   -56,   -56,   -56,   -56,   -56,   -56,
      39,   -56,     7,   -56,   -56,    62,    52,    65,    25,   -56,
     -56,   -56,    -4,   -56
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     8,     1,     0,    13,     0,    64,    21,     0,
       0,     0,     0,    18,     0,     0,    12,    28,    33,     0,
      27,     0,    16,    10,    14,    24,    25,    26,    20,    19,
      23,    42,    43,    22,    30,     3,    36,    37,    34,     4,
      15,    29,     0,     0,    44,    38,    17,     0,    35,     0,
      39,    50,    46,     0,     6,    40,     0,    50,    48,    41,
       2,    53,    65,    63,    60,    59,    52,    51,    54,    55,
       0,    61,     0,    50,    31,     0,     0,    57,     0,     7,
      62,    58,     0,    56
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -56,    27,   -56,   -56,   -56,   -56,   -56,   -56,    63,   -56,
     -56,   -56,   -56,   -56,    50,   -56,   -56,    47,   -56,   -56,
     -43,   -56,   -56,   -56,   -55,   -56,   -56,   -56,   -56,   -56,
     -56,    22
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     1,     2,    46,    47,    60,     4,    23,    24,    39,
      14,    15,    16,    19,    20,    21,    37,    38,    44,    45,
      33,    52,    58,    74,    56,    66,    67,    82,    68,    69,
      70,    71
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      50,    61,    72,    42,     3,    43,    55,   -45,    61,    62,
      59,    18,    31,    22,   -47,   -32,    62,    32,    78,   -45,
     -45,    63,    64,    65,   -45,    49,    61,   -47,    63,    64,
      65,   -47,   -49,    34,    62,    17,    25,    31,    26,    83,
      27,   -30,    32,    76,    77,    36,    63,    64,    65,   -49,
      35,    18,    30,    -5,    -9,   -32,    51,    53,   -30,    57,
      -9,    -9,    -9,    -9,    -9,    -9,    -9,    31,    28,    54,
     -11,    79,    32,    63,    73,    81,   -11,   -11,   -11,   -11,
     -11,   -11,   -11,     5,    41,     6,    40,    75,    29,    48,
       0,     7,     8,     9,    10,    11,    12,    13,    80
};

static const yytype_int8 yycheck[] =
{
      43,     1,    57,     4,     0,     6,    49,     7,     1,     9,
      53,    17,    16,    21,     7,    21,     9,    21,    73,    19,
      20,    21,    22,    23,    24,     4,     1,    20,    21,    22,
      23,    24,     7,     7,     9,     1,    22,    16,    22,    82,
      22,     7,    21,     4,     5,    21,    21,    22,    23,    24,
      24,    17,     1,     8,     3,    21,    18,     4,    24,    19,
       9,    10,    11,    12,    13,    14,    15,    16,     1,     8,
       3,     9,    21,    21,    20,    10,     9,    10,    11,    12,
      13,    14,    15,     1,    34,     3,    23,    60,    21,    42,
      -1,     9,    10,    11,    12,    13,    14,    15,    76
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    26,    27,     0,    31,     1,     3,     9,    10,    11,
      12,    13,    14,    15,    35,    36,    37,     1,    17,    38,
      39,    40,    21,    32,    33,    22,    22,    22,     1,    21,
       1,    16,    21,    45,     7,    24,    21,    41,    42,    34,
      33,    39,     4,     6,    43,    44,    28,    29,    42,     4,
      45,    18,    46,     4,     8,    45,    49,    19,    47,    45,
      30,     1,     9,    21,    22,    23,    50,    51,    53,    54,
      55,    56,    49,    20,    48,    26,     4,     5,    49,     9,
      56,    10,    52,    45
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    25,    27,    26,    28,    29,    30,    28,    31,    31,
      31,    31,    31,    31,    32,    32,    34,    33,    35,    35,
      35,    36,    36,    36,    37,    37,    37,    38,    38,    38,
      39,    39,    40,    40,    41,    41,    42,    43,    43,    44,
      44,    44,    45,    45,    46,    46,    47,    47,    48,    48,
      49,    49,    49,    49,    50,    50,    51,    52,    52,    53,
      54,    55,    55,    56,    31,    49
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     5,     0,     0,     0,     5,     0,     2,
       3,     2,     2,     2,     1,     2,     0,     3,     1,     2,
       2,     1,     2,     2,     2,     2,     2,     1,     1,     3,
       0,     6,     0,     1,     1,     3,     1,     0,     1,     2,
       3,     3,     1,     1,     0,     2,     0,     2,     0,     2,
       0,     2,     2,     2,     1,     1,     4,     0,     1,     1,
       1,     1,     3,     1,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 171 "./yacc.y"
                 {
                   IR_node_t description_part;

                   /* Create new description part. */
                   description_part = IR_create_node (IR_NM_description_part);
                   IR_set_position (description_part, current_position);
                   IR_set_description_part_level (description_part, 0);
                   IR_set_first_basic_description_part (description_part,
                                                        NULL);
                   IR_set_next_basic_description_part (description_part,
                                                       NULL);
                   IR_set_last_code_insertion (description_part, NULL);
                   IR_set_last_double_declaration (description_part, NULL);
                   IR_set_last_type (description_part, NULL);
                   IR_set_last_additional_code (description_part, NULL);
                   if (current_description_part != NULL)
                     {
                       IR_node_t last_basic_description_part;
                       IR_node_t current_part;
                       
                       last_basic_description_part = NULL;
                       for (current_part
                            = IR_first_basic_description_part
                            (current_description_part);
                            current_part != NULL;
                            current_part
                            = IR_next_basic_description_part (current_part))
                         last_basic_description_part = current_part;
                       if (last_basic_description_part == NULL)
                         IR_set_first_basic_description_part
                           (current_description_part, description_part);
                       else
                         IR_set_next_basic_description_part
                           (last_basic_description_part, description_part);
                     }
                   current_description_part = description_part;
                 }
#line 1390 "y.tab.c"
    break;

  case 3: /* description: $@1 declaration_part PERCENTS node_type_definition_list ADDITIONAL_C_CODE  */
#line 210 "./yacc.y"
                 {append_additional_code (yyvsp[0]);}
#line 1396 "y.tab.c"
    break;

  case 5: /* $@2: %empty  */
#line 218 "./yacc.y"
                          {
                            yyerrok;
                          }
#line 1404 "y.tab.c"
    break;

  case 6: /* @3: %empty  */
#line 222 "./yacc.y"
                          {
                            const char *file_name;
                            
                            file_name
                              = full_extended_file_name (IR_identifier_itself
                                                         (yyvsp[-2]));
                            start_parser_file (file_name, IR_position (yyvsp[-2]));
                            yyval = current_description_part;
                          }
#line 1418 "y.tab.c"
    break;

  case 7: /* basic_description_part: $@2 EXTENSION @3 description END_OF_BASIC_FILE  */
#line 232 "./yacc.y"
                          {
                            yyerrok;
                            finish_parser_file ();
                            IR_set_description_part_level
                              (yyvsp[-2],
                               IR_description_part_level
                               (current_description_part) + 1);
                            current_description_part = yyvsp[-2];
                          }
#line 1432 "y.tab.c"
    break;

  case 12: /* declaration_part: declaration_part code_insertion  */
#line 254 "./yacc.y"
           {
             if (IR_last_code_insertion (current_description_part) != NULL)
               {
                 IR_set_next_code_insertion
                   (yyvsp[0], IR_next_code_insertion (IR_last_code_insertion
                                                (current_description_part)));
                 IR_set_next_code_insertion
                   (IR_last_code_insertion (current_description_part), yyvsp[0]);
               }
             else
               IR_set_next_code_insertion (yyvsp[0], yyvsp[0]);
             IR_set_last_code_insertion (current_description_part, yyvsp[0]);
           }
#line 1450 "y.tab.c"
    break;

  case 13: /* declaration_part: declaration_part error  */
#line 268 "./yacc.y"
           {syntax_error ("syntax error in declaration");}
#line 1456 "y.tab.c"
    break;

  case 16: /* @4: %empty  */
#line 281 "./yacc.y"
        {
          /* The attribute of this action (`$$') is used in rule with
             nonterminal `basic_description_part' in the left hand
             side.  The value of the attribute is node representing
             identifier in construction `%extend ...'  in current
             source file. */
          const char *file_name;

          yyval = yyvsp[0];
          file_name = full_extended_file_name (IR_identifier_itself (yyvsp[0]));
          if (!file_has_been_already_processed (file_name))
            /* It is first construction `%extend ...' with given
               identifier -- start parsing new description part. */
            add_lexema_to_input_file (EXTENSION);
          else if (v_flag)
            warning
              (IR_position (yyvsp[0]),
               "warning -- repeated extension of description `%s' is ignored",
               IR_identifier_itself (yyvsp[0]));
        }
#line 1481 "y.tab.c"
    break;

  case 18: /* predefined_types_declaration: TYPE  */
#line 309 "./yacc.y"
              {yyerrok;}
#line 1487 "y.tab.c"
    break;

  case 19: /* predefined_types_declaration: predefined_types_declaration IDENTIFIER  */
#line 311 "./yacc.y"
          {
            yyval = IR_create_node (IR_NM_predefined_type);
            IR_set_position (yyval, IR_position (yyvsp[0]));
            IR_set_type_identifier (yyval, yyvsp[0]);
            IR_set_next_type (yyval, yyval);
            /* Append cyclic list of one node to the list of current
               description part. */
            append_type_list (yyval);
          }
#line 1501 "y.tab.c"
    break;

  case 20: /* predefined_types_declaration: predefined_types_declaration error  */
#line 321 "./yacc.y"
          {syntax_error ("syntax error in predefined type declaration");}
#line 1507 "y.tab.c"
    break;

  case 21: /* double_nodes_declaration: DOUBLE  */
#line 329 "./yacc.y"
                {yyerrok;}
#line 1513 "y.tab.c"
    break;

  case 22: /* double_nodes_declaration: double_nodes_declaration any_node_type_name  */
#line 331 "./yacc.y"
          {
            yyval = IR_create_node (IR_NM_double_declaration);
            IR_set_position (yyval, IR_position (yyvsp[0]));
            IR_set_double_declaration_identifier (yyval, yyvsp[0]);
            /* Append node to the list of current description part. */
            append_double_declaration (yyval);
          }
#line 1525 "y.tab.c"
    break;

  case 23: /* double_nodes_declaration: double_nodes_declaration error  */
#line 339 "./yacc.y"
          {
            syntax_error ("syntax error in double node type declaration");
          }
#line 1533 "y.tab.c"
    break;

  case 24: /* code_insertion: LOCAL CODE_INSERTION  */
#line 348 "./yacc.y"
                   {
                     yyval = IR_create_node (IR_NM_local_code);
                     IR_set_position (yyval, IR_position (yyvsp[0]));
                     IR_set_code_itself (yyval, yyvsp[0]);
                   }
#line 1543 "y.tab.c"
    break;

  case 25: /* code_insertion: IMPORT CODE_INSERTION  */
#line 354 "./yacc.y"
                   {
                     yyval = IR_create_node (IR_NM_import_code);
                     IR_set_position (yyval, IR_position (yyvsp[0]));
                     IR_set_code_itself (yyval, yyvsp[0]);
                   }
#line 1553 "y.tab.c"
    break;

  case 26: /* code_insertion: EXPORT CODE_INSERTION  */
#line 360 "./yacc.y"
                   {
                     yyval = IR_create_node (IR_NM_export_code);
                     IR_set_position (yyval, IR_position (yyvsp[0]));
                     IR_set_code_itself (yyval, yyvsp[0]);
                   }
#line 1563 "y.tab.c"
    break;

  case 28: /* node_type_definition_list: error  */
#line 373 "./yacc.y"
          {
            syntax_error ("syntax error in node type definition");
          }
#line 1571 "y.tab.c"
    break;

  case 31: /* node_type_definition: abstract_node_flag node_type_identifier_list optional_immediate_super_type_list class_field_definition_part skeleton_field_definition_part other_field_definition_part  */
#line 387 "./yacc.y"
       {
         IR_node_t last_field;
         IR_node_t last_super_type_list_element;

         last_field
           = merge_and_set_field_declaration_part_and_class_double_fields
             (yyvsp[-2], yyvsp[-1], yyvsp[0]);
         last_super_type_list_element = yyvsp[-3];
         if (yyvsp[-3] != NULL)
           {
             /* Make uncyclic list. */
             yyvsp[-3] = IR_next_super_type_list_element (yyvsp[-3]);
             IR_set_next_super_type_list_element (last_super_type_list_element,
                                                  NULL);
           }
         process_node_type_list
           (yyvsp[-4], yyvsp[-5] != NULL, yyvsp[-3], last_super_type_list_element,
            current_basic_super_types_flag, last_field);
       }
#line 1595 "y.tab.c"
    break;

  case 32: /* abstract_node_flag: %empty  */
#line 411 "./yacc.y"
                               {yyval = NULL;}
#line 1601 "y.tab.c"
    break;

  case 33: /* abstract_node_flag: ABSTRACT  */
#line 412 "./yacc.y"
                               {yyval = root_identifier;}
#line 1607 "y.tab.c"
    break;

  case 34: /* node_type_identifier_list: node_type_identifier  */
#line 420 "./yacc.y"
                              {  
                                IR_set_next_type (yyvsp[0], yyvsp[0]);
                                yyval = yyvsp[0];
                              }
#line 1616 "y.tab.c"
    break;

  case 35: /* node_type_identifier_list: node_type_identifier_list COMMA node_type_identifier  */
#line 426 "./yacc.y"
                              {  
                                assert (yyvsp[-2] != NULL);
                                IR_set_next_type (yyvsp[0], IR_next_type (yyvsp[-2]));
                                IR_set_next_type (yyvsp[-2], yyvsp[0]);
                                yyval = yyvsp[0];
                              }
#line 1627 "y.tab.c"
    break;

  case 36: /* node_type_identifier: IDENTIFIER  */
#line 438 "./yacc.y"
                         {
                           yyval = IR_create_node (IR_NM_node_type);
                           IR_set_position (yyval, IR_position (yyvsp[0]));
                           IR_set_type_identifier (yyval, yyvsp[0]);
                           IR_set_double_node_flag (yyval, FALSE);
                           IR_set_last_field (yyval, NULL);
                         }
#line 1639 "y.tab.c"
    break;

  case 37: /* optional_immediate_super_type_list: %empty  */
#line 454 "./yacc.y"
      {
        current_basic_super_types_flag = FALSE;
        yyval = NULL;
      }
#line 1648 "y.tab.c"
    break;

  case 38: /* optional_immediate_super_type_list: immediate_super_type_list  */
#line 459 "./yacc.y"
      {
        yyval = yyvsp[0];
      }
#line 1656 "y.tab.c"
    break;

  case 39: /* immediate_super_type_list: DOUBLE_COLON any_node_type_name  */
#line 471 "./yacc.y"
         {
           current_basic_super_types_flag = TRUE;
           yyval = IR_create_node (IR_NM_super_type_list_element);
           IR_set_position (yyval, IR_position (yyvsp[0]));
           IR_set_immediate_super_type_identifier (yyval, yyvsp[0]);
           /* Create cyclic list. */
           IR_set_next_super_type_list_element (yyval, yyval);
         }
#line 1669 "y.tab.c"
    break;

  case 40: /* immediate_super_type_list: DOUBLE_COLON COMMA any_node_type_name  */
#line 480 "./yacc.y"
         {
           current_basic_super_types_flag = FALSE;
           yyval = IR_create_node (IR_NM_super_type_list_element);
           IR_set_position (yyval, IR_position (yyvsp[0]));
           IR_set_immediate_super_type_identifier (yyval, yyvsp[0]);
           /* Create cyclic list. */
           IR_set_next_super_type_list_element (yyval, yyval);
         }
#line 1682 "y.tab.c"
    break;

  case 41: /* immediate_super_type_list: immediate_super_type_list COMMA any_node_type_name  */
#line 489 "./yacc.y"
         {
           assert (yyvsp[-2] != NULL);
           yyval = IR_create_node (IR_NM_super_type_list_element);
           IR_set_position (yyval, IR_position (yyvsp[0]));
           IR_set_immediate_super_type_identifier (yyval, yyvsp[0]);
           /* Add new element to the cyclic list. */
           IR_set_next_super_type_list_element
             (yyval, IR_next_super_type_list_element (yyvsp[-2]));
           IR_set_next_super_type_list_element (yyvsp[-2], yyval);
         }
#line 1697 "y.tab.c"
    break;

  case 42: /* any_node_type_name: ROOT  */
#line 504 "./yacc.y"
                       {
                         /* Copy is needed because any identifier node
                            representing identifier occurrence (see
                            commentaries for node `identifier'). */
                         yyval = IR_copy_node (root_identifier);
                         IR_set_position (yyval, current_lexema_position);
                       }
#line 1709 "y.tab.c"
    break;

  case 43: /* any_node_type_name: IDENTIFIER  */
#line 511 "./yacc.y"
                                  {yyval = yyvsp[0];}
#line 1715 "y.tab.c"
    break;

  case 44: /* class_field_definition_part: %empty  */
#line 518 "./yacc.y"
                                                           {yyval = NULL;}
#line 1721 "y.tab.c"
    break;

  case 45: /* class_field_definition_part: CLASS field_definition_list  */
#line 519 "./yacc.y"
                                                           {yyval = yyvsp[0];}
#line 1727 "y.tab.c"
    break;

  case 46: /* skeleton_field_definition_part: %empty  */
#line 526 "./yacc.y"
                                                                {yyval = NULL;}
#line 1733 "y.tab.c"
    break;

  case 47: /* skeleton_field_definition_part: SKELETON field_definition_list  */
#line 527 "./yacc.y"
                                                                {yyval = yyvsp[0];}
#line 1739 "y.tab.c"
    break;

  case 48: /* other_field_definition_part: %empty  */
#line 534 "./yacc.y"
                                                           {yyval = NULL;}
#line 1745 "y.tab.c"
    break;

  case 49: /* other_field_definition_part: OTHER field_definition_list  */
#line 535 "./yacc.y"
                                                           {yyval = yyvsp[0];}
#line 1751 "y.tab.c"
    break;

  case 50: /* field_definition_list: %empty  */
#line 541 "./yacc.y"
                                                                {yyval = NULL;}
#line 1757 "y.tab.c"
    break;

  case 51: /* field_definition_list: field_definition_list field_definition  */
#line 543 "./yacc.y"
                          {
                            if (yyvsp[-1] != NULL)
                              {
                                yyval = IR_next_field (yyvsp[0]);
                                IR_set_next_field (yyvsp[0], IR_next_field (yyvsp[-1]));
                                IR_set_next_field (yyvsp[-1], yyval);
                              }
                            yyval = yyvsp[0];
                          }
#line 1771 "y.tab.c"
    break;

  case 52: /* field_definition_list: field_definition_list constraint_or_action  */
#line 553 "./yacc.y"
                          {  
                            if (yyvsp[-1] != NULL)
                              {
                                IR_set_next_field (yyvsp[0], IR_next_field (yyvsp[-1]));
                                IR_set_next_field (yyvsp[-1], yyvsp[0]);
                              }
                            else
                              IR_set_next_field (yyvsp[0], yyvsp[0]);
                            yyval = yyvsp[0];
                          }
#line 1786 "y.tab.c"
    break;

  case 53: /* field_definition_list: field_definition_list error  */
#line 564 "./yacc.y"
                           {
                             syntax_error ("syntax error in field definition");
                             yyval = yyvsp[-1];
                           }
#line 1795 "y.tab.c"
    break;

  case 54: /* constraint_or_action: constraint  */
#line 572 "./yacc.y"
                                   {yyval = yyvsp[0];}
#line 1801 "y.tab.c"
    break;

  case 55: /* constraint_or_action: action  */
#line 573 "./yacc.y"
                                   {yyval = yyvsp[0];}
#line 1807 "y.tab.c"
    break;

  case 56: /* field_definition: field_identifier_list COLON optional_double any_node_type_name  */
#line 581 "./yacc.y"
                     {
                       yyval = yyvsp[-3];
                       assert (yyvsp[-3] != NULL);
                       /* Set up `double_field_flag' for all fields
                          of the list. */
                       do
                         {
                           IR_set_double_field_flag (yyvsp[-3], yyvsp[-1] != NULL);
                           IR_set_field_type_identifier (yyvsp[-3], yyvsp[0]);
                           yyvsp[-3] = IR_next_field (yyvsp[-3]);
                         }
                       while (yyvsp[-3] != yyval);
                     }
#line 1825 "y.tab.c"
    break;

  case 57: /* optional_double: %empty  */
#line 599 "./yacc.y"
                           {yyval = NULL;}
#line 1831 "y.tab.c"
    break;

  case 58: /* optional_double: DOUBLE  */
#line 600 "./yacc.y"
                           {yyval = root_identifier;}
#line 1837 "y.tab.c"
    break;

  case 59: /* constraint: EXPRESSION  */
#line 606 "./yacc.y"
               {
                 yyval = IR_create_node (IR_NM_constraint);
                 IR_set_position (yyval, IR_position (yyvsp[0]));
                 IR_set_constraint_code (yyval, yyvsp[0]);
               }
#line 1847 "y.tab.c"
    break;

  case 60: /* action: CODE_INSERTION  */
#line 616 "./yacc.y"
           {
             yyval = IR_create_node (IR_NM_action);
             IR_set_position (yyval, IR_position (yyvsp[0]));
             IR_set_action_code (yyval, yyvsp[0]);
           }
#line 1857 "y.tab.c"
    break;

  case 61: /* field_identifier_list: field_identifier  */
#line 627 "./yacc.y"
                          {
                            IR_set_next_field (yyvsp[0], yyvsp[0]);
                            yyval = yyvsp[0];
                          }
#line 1866 "y.tab.c"
    break;

  case 62: /* field_identifier_list: field_identifier_list COMMA field_identifier  */
#line 632 "./yacc.y"
                          {  
                            assert (yyvsp[-2] != NULL);
                            IR_set_next_field (yyvsp[0], IR_next_field (yyvsp[-2]));
                            IR_set_next_field (yyvsp[-2], yyvsp[0]);
                            yyval = yyvsp[0];
                          }
#line 1877 "y.tab.c"
    break;

  case 63: /* field_identifier: IDENTIFIER  */
#line 643 "./yacc.y"
                     {
                       yyval = IR_create_node (IR_NM_field);
                       IR_set_position (yyval, IR_position (yyvsp[0]));
                       IR_set_field_identifier (yyval, yyvsp[0]);
                     }
#line 1887 "y.tab.c"
    break;

  case 64: /* declaration_part: declaration_part END_OF_BASIC_FILE  */
#line 660 "./yacc.y"
                     {
#ifndef YYRECOVERING
#define YYRECOVERING() (!!yyerrflag)
#endif
                       yychar = END_OF_BASIC_FILE;
                       if (!YYRECOVERING ())
                         yyerror ("error in description part");
                       else
                         syntax_error ("error in description part");
                     }
#line 1902 "y.tab.c"
    break;

  case 65: /* field_definition_list: field_definition_list END_OF_BASIC_FILE  */
#line 675 "./yacc.y"
                          {
                            yychar = END_OF_BASIC_FILE;
#ifndef YYRECOVERING
#define YYRECOVERING() (!!yyerrflag)
#endif
                            if (!YYRECOVERING ())
                              yyerror ("error in description part");
                            else
                              syntax_error ("error in description part");
                          }
#line 1917 "y.tab.c"
    break;


#line 1921 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 687 "./yacc.y"




/* This page contains functions used only in actions of YACC grammar. */

/* The following function appends given additional code to the cyclic
   list of all additional codes of current description part (it can be
   the only one in given description part). */

static void
append_additional_code (IR_node_t additional_code)
{
  if (IR_last_additional_code (current_description_part) != NULL)
    {
      IR_set_next_additional_code
        (additional_code,
         IR_next_additional_code (IR_last_additional_code
                                  (current_description_part)));
      IR_set_next_additional_code
        (IR_last_additional_code (current_description_part), additional_code);
    }
  else
    IR_set_next_additional_code (additional_code, additional_code);
  IR_set_last_additional_code (current_description_part, additional_code);
}

/* The following function appends cyclic list of node types or
   predefined types to the cyclic list of node types and predefined
   types of current description part. */

static void
append_type_list (IR_node_t last_type)
{
  IR_node_t first_appended_type;

  if (IR_last_type (current_description_part) != NULL)
    {
      first_appended_type = IR_next_type (last_type);
      IR_set_next_type
        (last_type, IR_next_type (IR_last_type (current_description_part)));
      IR_set_next_type (IR_last_type (current_description_part),
                        first_appended_type);
    }
  IR_set_last_type (current_description_part, last_type);
}

/* The function appends given double declaration to the cyclic list of
   all double declarations of current description part. */

static void
append_double_declaration (IR_node_t double_declaration)
{
  if (IR_last_double_declaration (current_description_part) != NULL)
    {
      IR_set_next_double_declaration
        (double_declaration,
         IR_next_double_declaration (IR_last_double_declaration
                                     (current_description_part)));
      IR_set_next_double_declaration (IR_last_double_declaration
                                      (current_description_part),
                                      double_declaration);
    }
  else
    IR_set_next_double_declaration (double_declaration, double_declaration);
  IR_set_last_double_declaration (current_description_part,
                                  double_declaration);
}

/* The following function sets up field `declaration_part' for all
   nodes representing fields in given cyclic list.  The function also
   checks up that class fields are not double fields (see commentaries
   for `double_field_flag').  If the condition is violated then error
   is fixed and corresponding `double_field_flag' is set up to FALSE. */

static void
set_field_declaration_part_and_class_double_fields
  (IR_node_t last_field, declaration_part_t declaration_part)
{
  IR_node_t current_field;

  current_field = last_field;
  if (current_field != NULL)
    do
      {
        IR_set_declaration_part (current_field, declaration_part);
        if (IR_NODE_MODE (current_field) == IR_NM_field
            && IR_double_field_flag (current_field)
            && declaration_part == DP_CLASS)
          {
            error (FALSE, IR_position (current_field),
                   "class field `%s' is double",
                   IR_identifier_itself (IR_field_identifier (current_field)));
            IR_set_double_field_flag (current_field, FALSE);
          }
        current_field = IR_next_field (current_field);
      }
    while (current_field != last_field);
}

/* The following function calls function
   `set_field_declaration_part_and_class_double_fields' for each list
   of three lists (of class fields, skeleton fields, and other
   fields).  After that the function merges these lists.  The function
   returns node (may be NULL) representing last field of the result
   list. */

static IR_node_t
merge_and_set_field_declaration_part_and_class_double_fields
  (IR_node_t class_fields, IR_node_t skeleton_fields, IR_node_t other_fields)
{
  IR_node_t first_field;
  IR_node_t last_field;

  set_field_declaration_part_and_class_double_fields (other_fields, DP_OTHER);
  set_field_declaration_part_and_class_double_fields (class_fields, DP_CLASS);
  set_field_declaration_part_and_class_double_fields (skeleton_fields,
                                                      DP_SKELETON);
  last_field = class_fields;
  if (last_field == NULL)
    last_field = skeleton_fields;
  else if (skeleton_fields != NULL)
    {
      first_field = IR_next_field (skeleton_fields);
      IR_set_next_field (skeleton_fields, IR_next_field (last_field));
      IR_set_next_field (last_field, first_field);
    }
  if (last_field == NULL)
    last_field = other_fields;
  else if (other_fields != NULL)
    {
      first_field = IR_next_field (other_fields);
      IR_set_next_field (other_fields, IR_next_field (last_field));
      IR_set_next_field (last_field, first_field);
    }
  return last_field;
}

/* The following function makes copy of given cyclic field (and action
   and constraints) list.  The function returns node (may be NULL)
   representing last field (or action or constraints) of the result
   (new) list. */

static IR_node_t
copy_field_list (IR_node_t field_list)
{
  IR_node_t current_field;
  IR_node_t current_new_field;
  IR_node_t new_field;
  IR_node_t result;

  if (field_list == NULL)
    return NULL;
  current_new_field = result = IR_copy_node (field_list);
  IR_set_next_field (result, result);
  for (current_field = field_list;;)
    {
      current_field = IR_next_field (current_field);
      if (current_field == field_list)
        break;
      new_field  = IR_copy_node (current_field);
      IR_set_next_field (new_field, IR_next_field (current_new_field));
      IR_set_next_field (current_new_field, new_field);
      current_new_field = new_field;
    }
  return result;
}

/* The following function sets up fields `abstract_flag',
   `first_super_type_list_element', `last_super_type_list_element',
   and `last_field' for all nodes representing node types in given
   cyclic list.  If the node type list contains more one node type the
   copy of fields (and action and constraints) is made for each non
   last node type of the list.  After that function `append_type_list'
   is called for given node type list. */

static void
process_node_type_list
  (IR_node_t last_node_type, int abstract_flag,
   IR_node_t first_super_type_list_element,
   IR_node_t last_super_type_list_element, int basic_super_types_flag,
   IR_node_t last_field)
{
  IR_node_t current_node_type;

  current_node_type = last_node_type;
  if (current_node_type != NULL)
    do
      {
        assert (IR_NODE_MODE (current_node_type) == IR_NM_node_type);
        IR_set_abstract_flag (current_node_type, abstract_flag);
        IR_set_first_super_type_list_element (current_node_type,
                                              first_super_type_list_element);
        IR_set_last_super_type_list_element (current_node_type,
                                             last_super_type_list_element);
        IR_set_basic_super_types_flag (current_node_type,
                                       basic_super_types_flag);
        IR_set_last_field (current_node_type,
                           (current_node_type == last_node_type
                            ? last_field : copy_field_list (last_field)));
        current_node_type = IR_next_type (current_node_type);
      }
  while (current_node_type != last_node_type);
  append_type_list (last_node_type);
}



/* This page contains abstract data `input_stream_stack'.  This
   abstract data opens and closes included files saves and restores
   scanner states corresponding to processed files. */


/* The following structure describes current input stream and scanner
   state and is used for saving and restoring input stream and scanner
   state to process included files. */

struct input_stream_state
{
  /* The following member is defined only for `current_input_stream_state'. */
  FILE *input_file;
  /* File name of given input stream. */
  const char *input_file_name;
  /* Current position in file corresponding to given input stream.
     The following member is defined only for structures in the input
     stream stack. */
  long input_file_position;
  /* The following member contains parameter value of the function
     `add_lexema_to_input_file' after immediately call of this function or
     -1 otherwise. */
  int uninput_lexema_code;
  /* The following member is TRUE if the first `%%' in given input stream
     was already processed or FALSE otherwise. */
  int it_is_first_percents;
  /* The following member is TRUE if the ADDITIONAL_CODE lexema was already
     returned by the scanner or FALSE otherwise.  Remember that lexema
     ADDITIONAL_CODE is always returned by the scanner
     even if second `%%' in the input stream is absent. */
  int additional_c_code_was_returned;
};

/* The following structure contains all current input stream and
   scanner state.  If the member `input_file' value is NULL
   then input stream is not defined. */

static struct input_stream_state current_input_stream_state;

/* All input stream stack is implemented by variable length object.
   See package `vl-object'. */

static vlo_t input_stream_stack;

/* The following function creates empty input stream stack and
   initiates current input stream and scanner state as undefined.  The
   function must be called only once before any work with the input
   stream stack. */

static void
initiate_input_stream_stack (void)
{
  VLO_CREATE (input_stream_stack, 0);
  current_input_stream_state.input_file = NULL;
  current_input_stream_state.uninput_lexema_code = (-1);
  current_input_stream_state.it_is_first_percents = TRUE;
  current_input_stream_state.additional_c_code_was_returned = FALSE;
}

/* The following function deletes the input stream stack and closes
   current input file if current input stream state is defined.  Only
   call of function `initiate_input_stream_stack' is possible
   immediately after this function call. */

static void
finish_input_stream_stack (void)
{
  VLO_DELETE (input_stream_stack);
  if (current_input_stream_state.input_file != NULL)
    fclose (current_input_stream_state.input_file);
}

/* The following function returns height of input stream stack,
   i.e. current file inclusion level. */

static int
input_stream_stack_height (void)
{
  return VLO_LENGTH (input_stream_stack) / sizeof (struct input_stream_state);
}

/* The following value is used if previous_char does not contain an
   input char */

#define EMPTY_PREVIOUS_CHAR (-2000)

/* The following variable is used for storing '\r'. */

static int previous_char;

/* The following function saves current input stream and scanner state
   (if it is defined) in the stack, closes file corresponding to
   current input stream, opens file corresponding to new input stream,
   and sets up new current input stream and scanner state.  The
   function also checks up absence of loop of file inclusions.  The
   function reports errors if the loop exists or new file is not
   opened. */

static void
push_current_input_stream (const char *new_file_name,
                           position_t error_position)
{
  int i;

  if (current_input_stream_state.input_file != NULL)
    {
      current_input_stream_state.input_file_position
        = ftell (current_input_stream_state.input_file);
      fclose (current_input_stream_state.input_file);
      current_input_stream_state.input_file = NULL;
      VLO_ADD_MEMORY (input_stream_stack, &current_input_stream_state,
                      sizeof (struct input_stream_state));
      for (i = 0; i < input_stream_stack_height (); i++)
        if (strcmp
            (((struct input_stream_state *) VLO_BEGIN (input_stream_stack))
             [i].input_file_name, new_file_name) == 0)
          error (TRUE, error_position,
                 "fatal error -- cycle on inclusion of file `%s'", 
                  new_file_name);
    }
  current_input_stream_state.input_file_name = new_file_name;
  current_input_stream_state.input_file = fopen (new_file_name, "rb");
  previous_char = EMPTY_PREVIOUS_CHAR;
  if (current_input_stream_state.input_file == NULL)
    system_error (TRUE, error_position, "fatal error -- `%s': ", 
                  current_input_stream_state.input_file_name);
  start_file_position (current_input_stream_state.input_file_name);
  current_input_stream_state.uninput_lexema_code = (-1);
  current_input_stream_state.it_is_first_percents = TRUE;
  current_input_stream_state.additional_c_code_was_returned = FALSE;
}

/* The following function closes file corresponding to current input
   stream (it must be defined), reopens file corresponding to previous
   input stream and restores previous input stream and scanner state.
   The function can fix error if the file is not reopened. */

static void
pop_input_stream_stack (void)
{
  assert (current_input_stream_state.input_file != NULL);
  fclose (current_input_stream_state.input_file);
  current_input_stream_state.input_file = NULL;
  if (input_stream_stack_height () != 0)
    {
      current_input_stream_state
	= (((struct input_stream_state *) VLO_BEGIN (input_stream_stack))
	   [input_stream_stack_height () - 1]);
      VLO_SHORTEN (input_stream_stack, sizeof (struct input_stream_state));
      current_input_stream_state.input_file
	= fopen (current_input_stream_state.input_file_name, "rb");
      if (current_input_stream_state.input_file == NULL
	  || fseek (current_input_stream_state.input_file,
		    current_input_stream_state.input_file_position, 0) != 0)
	system_error (TRUE, no_position,
		      "fatal error -- repeated opening file `%s': ", 
		      current_input_stream_state.input_file_name);
      finish_file_position ();
    }
}

/* The following field returns directory name of given file name. */

static const char *
file_name_directory (const char *file_name)
{
  const char *last_slash;
  const char *current_char_ptr;
  const char *result;

  assert (file_name != NULL);
  for (current_char_ptr = file_name, last_slash = NULL;
       *current_char_ptr != '\0'; current_char_ptr++)
    if (*current_char_ptr == '/')
      last_slash = current_char_ptr;
  if (last_slash == NULL)
    return ""; /* current directory */
  else
    {
      IR_TOP_ADD_MEMORY (file_name, last_slash - file_name + 1);
      IR_TOP_ADD_BYTE ('\0');
      result = IR_TOP_BEGIN ();
      IR_TOP_FINISH ();
      return result;
    }
}

/* The following field returns full name of file with given directory
   name, file name itself, and suffix. */

static const char *
file_path_name (const char *directory_name, const char *file_name,
                const char *file_suffix)
{
  const char *result;

  assert (directory_name != NULL);
  IR_TOP_ADD_STRING (directory_name);
  if (strlen (directory_name) != 0
      && directory_name [strlen (directory_name) - 1] != '/')
    IR_TOP_ADD_STRING ("/");
  IR_TOP_ADD_STRING (file_name);
  IR_TOP_ADD_STRING (file_suffix);
  result = IR_TOP_BEGIN ();
  IR_TOP_FINISH ();
  return result;
}

/* The following function returns full file name of extended
   specification with given identifier.  To make this functions
   searches for files in current directory (i.e. directory in which
   source file with the corresponding extend-clause is placed) and in
   directories given in the command line of the SPRUT.  If the extended
   specification file is not found the function returns the extended
   specification file name in the current directory. */

static const char *
full_extended_file_name (const char *extend_identifier)
{
  const char *current_directory_name;
  const char *real_file_name;
  const char *file_name;
  const char **extended_specification_directory_ptr;
  FILE *current_file;

  current_directory_name
    = file_name_directory (current_input_stream_state.input_file_name);
  real_file_name = file_path_name (current_directory_name,
                                   extend_identifier,
                                   STANDARD_INPUT_FILE_SUFFIX);
  current_file = fopen (real_file_name, "rb");
  if (current_file == NULL)
    for (extended_specification_directory_ptr
         = extended_specification_directories;
         *extended_specification_directory_ptr != NULL;
         extended_specification_directory_ptr++)
      {
        file_name = file_path_name (*extended_specification_directory_ptr,
                                    extend_identifier,
                                    STANDARD_INPUT_FILE_SUFFIX);
        current_file = fopen (file_name, "rb");
        if (current_file != NULL)
          {
            real_file_name = file_name;
            break;
          }
      }
  if (current_file != NULL && fclose (current_file) == EOF)
    system_error (TRUE, no_position, "fatal error -- `%s': ", real_file_name);
  return real_file_name;
}



/*   This page contains abstract data `scanner'.  This abstract data
   divides input stream characters on tokens (lexemas).

     There is requirement of back control (from parser to scanner).
   This back control is needed to switch to processing new file after
   recognizing identifier in construction `%extend ...'.  After
   recognizing the first identifier the parser is to tell scanner that
   the next lexema must be EXTENSION.  After getting such lexema the
   parser is switched correctly onto processing new file.
    
     When EOF is read the scanner returns 0 only when input stream
   stack is empty, otherwise returns lexema END_OF_BASIC_FILE.  */

/* The following function returns lexical code of corresponding
   keyword or 0 if given identifier is not keyword.  Fast search is
   implemented by minimal pruned O-trie forest. */

static int
find_keyword (const char *str, int length)
{
  switch (length)
    {
    case 4:
      switch (*str)
        {
        case 'r':
          return (strcmp (str, "root") == 0 ? ROOT : 0);
        case 't':
          return (strcmp (str, "type") == 0 ? TYPE : 0);
        default:
          return 0;
        }
    case 5:
      switch (*str)
        {
        case 'c':
          return (strcmp (str, "class") == 0 ? CLASS : 0);
        case 'l':
          return (strcmp (str, "local") == 0 ? LOCAL : 0);
        case 'o':
          return (strcmp (str, "other") == 0 ? OTHER : 0);
        default:
          return 0;
        }
    case 6:
      switch (str[2])
        {
        case 'u':
          return (strcmp (str, "double") == 0 ? DOUBLE : 0);
        case 't':
          return (strcmp (str, "extend") == 0 ? EXTEND : 0);
        case 'p':
          if (*str == 'e')
            return (strcmp (str, "export") == 0 ? EXPORT : 0);
          else
            return (strcmp (str, "import") == 0 ? IMPORT : 0);
        default:
          return 0;
        }
    case 8:
      switch (*str)
        {
        case 'a':
          return (strcmp (str, "abstract") == 0 ? ABSTRACT : 0);
        case 's':
          return (strcmp (str, "skeleton") == 0 ? SKELETON : 0);
        default:
          return 0;
        }
    default:
      return 0;
    }
}

/* The following two functions for replacing "\r\n" onto "\n". */

static int
getch (FILE *f)
{
  int c;

  if (previous_char != '\r')
    c = getc (f);
  else
    {
      c = previous_char;
      previous_char = EMPTY_PREVIOUS_CHAR;
    }
  if (c == '\r')
    {
      c = getc (f);
      if (c != '\n')
        {
          ungetc (c, f);
          c = '\r';
        }
    }
  return c;
}

static void
ungetch (int c, FILE *f)
{
  if (c != '\r')
    ungetc (c, f);
  else
    previous_char = c;
}

/* The following function skips C commentary.  The function returns
   TRUE if no error (EOF) was fixed, otherwise FALSE.  Current
   position corresponds to `*' after commentary start ('/') before the
   function call.  Current_position corresponds to first character
   after skipped commentary ('/') or EOF after the function call. */

static int
skip_commentary (int store_flag)
{
  int input_char;
  
  current_position.column_number++;
  if (store_flag)
    IR_TOP_ADD_BYTE ('*');
  for (;;)
    {
      input_char = getch (current_input_stream_state.input_file);
      /* Here `current_position' corresponds to `input_char'. */
      if (input_char == '*')
        {
          if (store_flag)
            IR_TOP_ADD_BYTE (input_char);
          input_char = getch (current_input_stream_state.input_file);
          current_position.column_number++;
          /* Here `current_position' corresponds to `input_char'. */
          if (input_char == '/')
            {
              if (store_flag)
                IR_TOP_ADD_BYTE (input_char);
              current_position.column_number++;
              return TRUE;
            }
          else
            {
              ungetch (input_char, current_input_stream_state.input_file);
              continue;
            }
        }
      else if (input_char == EOF)
        {
          ungetch (input_char, current_input_stream_state.input_file);
          return FALSE;
        }
      if (input_char == '\n')
        {
          current_position.column_number = 1;
          current_position.line_number++;
        }
      else if (input_char == '\t')
        current_position.column_number
          = ((current_position.column_number - 1) / TAB_STOP + 1)
            * TAB_STOP + 1;
      else
        current_position.column_number++;
      if (store_flag)
        IR_TOP_ADD_BYTE (input_char);
    }
}

/* The following function skips C string code (e.g `a', `\n', or
   `\077').  The function also stores skipped characters onto top
   internal representation object.  The function returns TRUE if no
   error (EOF or incorrect new line) was fixed, otherwise FALSE. The
   value of parameter `correct_new_line' can be used for fixing errors
   when character constant is processed.  It is supposed that the
   current character is not end marker (string or character constant).
   Current position corresponds to parameter `input_char' before the
   function call.  Current_position corresponds to first character
   after skipped valid character code or EOF (or incorrect new line)
   after the function call. */

static int
skip_string_code (int input_char, int *correct_new_line)
{
  if (input_char == EOF || input_char == '\n')
    {
      ungetch (input_char, current_input_stream_state.input_file);
      return FALSE;
    }
  *correct_new_line = FALSE;
  IR_TOP_ADD_BYTE (input_char);
  if (input_char == '\\')
    {
      current_position.column_number++;
      input_char = getch (current_input_stream_state.input_file);
      IR_TOP_ADD_BYTE (input_char);
      if (input_char == 'n' || input_char == 't' || input_char == 'v'
          || input_char == 'b' || input_char == 'r' || input_char == 'f'
          || input_char == '\\' || input_char == '\'' || input_char == '\"')
        current_position.column_number++;
      else if (input_char == '\n')
        {
          current_position.column_number = 1;
          current_position.line_number++;
          *correct_new_line = TRUE;
        }
      else if (isdigit (input_char) && input_char != '8'
               && input_char != '9')
        {
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (!isdigit (input_char) || input_char == '8'
              || input_char == '9')
            ungetch (input_char, current_input_stream_state.input_file);
          else
            {
              current_position.column_number++;
              IR_TOP_ADD_BYTE (input_char);
              input_char = getch (current_input_stream_state.input_file);
              if (!isdigit (input_char) || input_char == '8'
                  || input_char == '9')
                ungetch (input_char, current_input_stream_state.input_file);
              else
                {
                  current_position.column_number++;
                  IR_TOP_ADD_BYTE (input_char);
                }
            }
        }
      else
        current_position.column_number++;
    }
  else if (input_char == '\t')
    current_position.column_number
      = ((current_position.column_number - 1) / TAB_STOP + 1) * TAB_STOP + 1;
  else
    current_position.column_number++;
  return TRUE;
}

/* The following function skips C character constant by using function
   `skip_string_code'.  The function may fix error in the C character
   constant.  The function also stores skipped characters onto top
   internal representation object.  Current position corresponds to
   first character after '\'' (which was already read) before the
   function call.  Current_position corresponds to to first character
   after '\'' if error was not fixed after the function call. */

static void
skip_C_character (void)
{
  int input_char;
  int correct_new_line;
  int error_flag;

  error_flag = FALSE;
  input_char = getch (current_input_stream_state.input_file);
  /* Here `current_position' corresponds to `input_char'. */
  if (input_char == '\'')
    {
      IR_TOP_ADD_BYTE (input_char);
      error (FALSE, current_position, "invalid character constant");
      current_position.column_number++;
      error_flag = TRUE;
    }
  else
    {
      if (!skip_string_code (input_char, &correct_new_line)
          || correct_new_line)
        {
          error (FALSE, current_position, "invalid character constant");
          error_flag = TRUE;
        }
    }
  input_char = getch (current_input_stream_state.input_file);
  if (input_char != '\'')
    {
      ungetch (input_char, current_input_stream_state.input_file);
      if (!error_flag)
        error (FALSE, current_position, "invalid character constant");
    }
  else
    {
      IR_TOP_ADD_BYTE (input_char);
      current_position.column_number++;
    }
}

/* The following function skips C string constant by using function
   `skip_string_code'.  The function may fix error in the C string
   constant.  The function also stores skipped characters onto top
   internal representation object.  Current position corresponds to
   first character after '\"' (which was already read) before the
   function call.  Current_position corresponds to to first character
   after '\"' if error was not fixed after the function call. */

static void
skip_C_string (void)
{
  int input_char;
  int correct_new_line;
  
  for (;;)
    {
      /* Here `current_position' corresponds to next character. */
      input_char = getch (current_input_stream_state.input_file);
      if (input_char == '\"')
        {
          current_position.column_number++;
          IR_TOP_ADD_BYTE (input_char); 
          break;
        }
      if (!skip_string_code (input_char, &correct_new_line))
        {
          error (FALSE, current_position, "string end is absent");
          break;
        }
    }
}

/* This function is major scanner function.  The function recognizes
   next source lexema from the input file, returns its code, modifies
   variable current_position so that its value is equal to position of
   the current character in the current input file and sets up
   variable `current_lexema_position' so that its value is equal to
   start position of the returned lexema, creates corresponding
   internal representation node (if it is needed) and sets up yylval
   to the node.  The function skips all white spaces and commentaries
   and fixes the most of lexical errors.  The function returns read
   token code.  If member `uninput_lexema_code' of
   `current_input_stream_state' is not negative the function returns
   the member value instead of code of lexema in input file.  When EOF
   is read the scanner returns ADDITIONAL_CODE if
   `additional_c_code_was_returned' of `current_input_stream_state' is
   FALSE, otherwise 0 only when input stream stack is empty, otherwise
   returns lexema END_OF_BASIC_FILE. */

int
yylex (void)
{
  int input_char;
  int number_of_successive_error_characters;
  
  if (current_input_stream_state.uninput_lexema_code >= 0)
    {
      int result;
      
      current_lexema_position = current_position;
      result = current_input_stream_state.uninput_lexema_code;
      current_input_stream_state.uninput_lexema_code = (-1);
      return result;
    }
  for (number_of_successive_error_characters = 0;;)
    {
      input_char = getch (current_input_stream_state.input_file);
      /* `current_position' corresponds `input_char' here */
      switch (input_char)
        {
        case '\f':
          /* flow-through */
        case ' ':
          current_position.column_number++;
          break;
        case '\t':
          current_position.column_number
            = ((current_position.column_number - 1) / TAB_STOP + 1)
              * TAB_STOP + 1;
          break;
        case '\n':
          current_position.column_number = 1;
          current_position.line_number++;
          break;
        case EOF:
          current_lexema_position = current_position;
          if (!current_input_stream_state.additional_c_code_was_returned)
            {
              ungetch (input_char, current_input_stream_state.input_file);
              current_input_stream_state.additional_c_code_was_returned = TRUE;
              yylval = IR_create_node (IR_NM_additional_code);
              IR_set_position (yylval, current_lexema_position);
              IR_TOP_ADD_BYTE ('\0');
              IR_set_additional_code_itself (yylval, IR_TOP_BEGIN ());
              IR_TOP_FINISH ();
              return ADDITIONAL_C_CODE;
            }
          else
            return (input_stream_stack_height () == 0 ? 0 : END_OF_BASIC_FILE);
        case '/':
          current_lexema_position = current_position;
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (input_char != '*')
            {
              number_of_successive_error_characters++;
              if (number_of_successive_error_characters == 1)
                error (FALSE, current_lexema_position,
                       "invalid input character '/'");
              ungetch (input_char, current_input_stream_state.input_file);
            }
          else if (!skip_commentary (FALSE))
            error (FALSE, current_lexema_position, "commentary end is absent");
          break;
        case ',':
          current_lexema_position = current_position;
          current_position.column_number++;
          return COMMA;
        case ';':
          current_lexema_position = current_position;
          current_position.column_number++;
          return SEMICOLON;
        case ':':
          current_lexema_position = current_position;
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (input_char == ':')
            {
              current_position.column_number++;
              return DOUBLE_COLON;
            }
          else
            {
              ungetch (input_char, current_input_stream_state.input_file);
              return COLON;
            }
        case '[':
          /* flow-through */
        case '{':
          {
            int start_char = input_char;
            int bracket_level = 1;
            int error_flag;
            char *code_itself;
            
            current_lexema_position = current_position;
            current_position.column_number++;
            for (error_flag = FALSE; !error_flag && bracket_level != 0;)
              {
                input_char = getch (current_input_stream_state.input_file);
                IR_TOP_ADD_BYTE (input_char);
                /* `current_position' corresponds to `input_char' here */
                switch (input_char)
                  {
                  case '/':
                    current_position.column_number++;
                    input_char = getch (current_input_stream_state.input_file);
                    if (input_char == '*')
                      {
                        current_position.column_number++;
                        error_flag = !skip_commentary (TRUE);
                      }
                    else
                      ungetch (input_char,
                               current_input_stream_state.input_file);
                    break;
                  case '[':
                    /* flow-through */
                  case '{':
                    current_position.column_number++;
                    if (start_char == input_char)
                      bracket_level++;
                    break;
                  case ']':
                    /* flow-through */
                  case '}':
                    current_position.column_number++;
                    if ((start_char == '{' && input_char == '}')
                        || (start_char == '[' && input_char == ']'))
                      bracket_level--;
                    if (bracket_level == 0)
                      IR_TOP_SHORTEN (1);
                    break;
                  case '\'':
                    current_position.column_number++;
                    skip_C_character ();
                    break;
                  case '\"':
                    current_position.column_number++;
                    skip_C_string ();
                    break;
                  case '\t':
                    current_position.column_number
                      = ((current_position.column_number - 1) / TAB_STOP + 1)
                        * TAB_STOP + 1;
                    break;
                  case '\n':
                    current_position.column_number = 1;
                    current_position.line_number++;
                    break;
                  case EOF:
                    IR_TOP_SHORTEN (1);
                    ungetch (input_char,
                             current_input_stream_state.input_file);
                    error_flag = TRUE;
                    break;
                  default:
                    current_position.column_number++;
                    break;
                  }
              }
            if (error_flag)
              error (FALSE, current_lexema_position,
                     (start_char == '[' ? "constraint end is absent"
                      : "C code insertion end is absent"));
            IR_TOP_ADD_BYTE ('\0');
            code_itself = IR_TOP_BEGIN ();
            IR_TOP_FINISH ();
            yylval = IR_create_node (start_char == '[' ? IR_NM_expression
                                  : IR_NM_code_insertion);
            IR_set_position (yylval, current_lexema_position);
            if (start_char == '[')
              IR_set_expression_itself (yylval, code_itself);
            else
              IR_set_code_insertion_itself (yylval, code_itself);
            return (start_char == '[' ? EXPRESSION : CODE_INSERTION);
          }
        case '%':
          current_lexema_position = current_position;
          current_position.column_number++;
          input_char = getch (current_input_stream_state.input_file);
          if (input_char == '%')
            {
              current_position.column_number++;
              if (current_input_stream_state.it_is_first_percents)
                {
                  current_input_stream_state.it_is_first_percents = FALSE;
                  return PERCENTS;
                }
              else
                {
                  char *additional_code_itself;

                  current_position.column_number++;
                  input_char = getch (current_input_stream_state.input_file);
                  while (input_char != EOF)
                    {
                      current_position.column_number++;
                      IR_TOP_ADD_BYTE (input_char);
                      input_char
                        = getch (current_input_stream_state.input_file);
                    }
                  ungetch (input_char, current_input_stream_state.input_file);
                  IR_TOP_ADD_BYTE ('\0');
                  additional_code_itself = IR_TOP_BEGIN ();
                  IR_TOP_FINISH ();
                  current_input_stream_state.additional_c_code_was_returned
                    = TRUE;
                  yylval = IR_create_node (IR_NM_additional_code);
                  IR_set_position (yylval, current_lexema_position);
                  IR_set_additional_code_itself (yylval,
                                                 additional_code_itself);
                  return ADDITIONAL_C_CODE;
                }
            }
          else if (isalpha (input_char) || input_char == '_' )
            {
              int keyword;
              
              /* Identifier recognition. */
              do
                {
                  current_position.column_number++;
                  IR_TOP_ADD_BYTE (input_char);
                  input_char = getch (current_input_stream_state.input_file);
                }
              while (isalpha (input_char) || isdigit (input_char)
                     || input_char == '_');
              ungetch (input_char, current_input_stream_state.input_file);
              IR_TOP_ADD_BYTE ('\0');
              keyword = find_keyword (IR_TOP_BEGIN (), IR_TOP_LENGTH () - 1);
              if (keyword != 0)
                {
                  IR_TOP_NULLIFY ();
                  return keyword;
                }
              else
                {
                  error (FALSE, current_lexema_position,
                         "unknown keyword `%%%s'",
                         IR_TOP_BEGIN ());
                  IR_TOP_NULLIFY ();
                }
            }
          else
            {
              number_of_successive_error_characters++;
              if (number_of_successive_error_characters == 1)
                error (FALSE, current_lexema_position,
                       "invalid input character '%%'");
              ungetch (input_char, current_input_stream_state.input_file);
            }
          break;
        default:
          if (isalpha (input_char) || input_char == '_' )
            {
              char *identifier_itself;

              current_lexema_position = current_position;
              /* Identifier recognition. */
              do
                {
                  current_position.column_number++;
                  IR_TOP_ADD_BYTE (input_char);
                  input_char = getch (current_input_stream_state.input_file);
                }
              while (isalpha (input_char) || isdigit (input_char)
                     || input_char == '_');
              ungetch (input_char, current_input_stream_state.input_file);
              IR_TOP_ADD_BYTE ('\0');
              identifier_itself = insert_identifier (IR_TOP_BEGIN ());
              if (identifier_itself == (char *) IR_TOP_BEGIN ())
                IR_TOP_FINISH ();
              else
                IR_TOP_NULLIFY ();
              yylval = IR_create_node (IR_NM_identifier);
              IR_set_position (yylval, current_lexema_position);
              IR_set_identifier_itself (yylval, identifier_itself);
              return IDENTIFIER;
            }
          else
            {
              number_of_successive_error_characters++;
              if (number_of_successive_error_characters == 1)
                {
                  if (isprint (input_char))
                    error (FALSE, current_position,
                           "invalid input character '%c'", input_char);
                  else
                    error (FALSE, current_position, "invalid input character");
                }
              current_position.column_number++;
            }
          break;
        }
    }
}

/* The following variable contains pointers to names of files whose
   scanning already finished. */

static vlo_t scanned_file_names;

/* The following function initiates internal state of the scanner
   (more accurately initiates internal state of abstract data
   `input_stream_stack').  The function must be called only once
   before any work with the scanner. */

static void
initiate_scanner (void)
{
  VLO_CREATE (scanned_file_names, 30);
  initiate_input_stream_stack ();
}

/* The following function returns TRUE if file with given name is
   already processed.  The function returns TRUE if file with given
   name is already processed, FALSE otherwise. */

static int
file_has_been_already_processed (const char *new_file_name)
{
  int i;

  for (i = 0; i < VLO_LENGTH (scanned_file_names) / sizeof (char *); i++)
    if (strcmp (((char **) VLO_BEGIN (scanned_file_names)) [i],
                new_file_name) == 0)
      return TRUE;
  return FALSE;
}

/* The following function is called to tune the scanner on input
   stream from given file.  The function is needed for nested
   procession of included files. The function saves scanner state
   concerning current input stream with the aid of abstract data
   `input_stream_stack'.  Previous scanner state is restored after
   processing end of file in current input stream (see parser and also
   function `yylex'). */

static void
start_scanner_file (const char *new_file_name, position_t error_position)
{
  push_current_input_stream (new_file_name, error_position);
}

/* The following function restores scanner state concerning previous
   input stream with the aid of abstract data `input_stream_stack'. */

static void
finish_scanner_file (void)
{
  if (!file_has_been_already_processed (current_input_stream_state
                                        .input_file_name))
    VLO_ADD_MEMORY (scanned_file_names,
                    &current_input_stream_state.input_file_name,
                    sizeof (char *));
  pop_input_stream_stack ();
}

/* The following function is called from the parser and points out
   that lexema given as parameter will be returned by following
   function `yylex' call. */

static void
add_lexema_to_input_file (int lexema_code)
{
  assert (lexema_code >= 0);
  current_input_stream_state.uninput_lexema_code = lexema_code;
}

/* The function frees all memory allocated during the scanner work
   (more accurately frees memory allocated by abstract data
   `input_stream_stack').  Only call of function `initiate_scanner' is
   possible immediately after this function call. */

static void
finish_scanner (void)
{
  VLO_DELETE (scanned_file_names);
  finish_input_stream_stack ();
}



/*   This page contains abstract data `syntax_errors'.  This abstract
   data is used to error reporting.
     YACC has unsatisfactory syntactic error reporting.  Essentially
   YACC generates only one syntactic error "syntax error".  Abstract
   data `syntax_errors' for solution of this problem is suggested
   here.  This abstract data saves only one the most recent error
   message and its position.  Function `yyerror' used only by function
   `yyparse' flushes saved early error message and saves message given
   as parameter (usually this message is simply "syntax error" but may
   be "stack overflow" or others) and its position.  More detail
   diagnostic message is generated by the call of function
   `syntax_error' within action after special token `error'.  This
   function only rewrites saved early error message (not error
   position).  As consequence the message of last call `syntax_error'
   or the message of function `yyerror' (if such call of
   `syntax_error' does not exist) is fixed within one recover mode
   interval because function `yyerror' is called by `yyparse' only in
   non recover mode.
     This solution permits to create brief syntactic message which
   contain partially information about recovery location (error line
   and position is always in non-fatal errors and warnings -- see
   package for `errors').  */


/* This variable saves the most recent syntax error message or NULL (if
   such syntax error was not fixed). */

static const char *last_syntax_error_message;

/* This variable saves the first syntax error position. */

static position_t first_syntax_error_position;

/* The following function initiates the abstract data as without saved
   syntax error message.  The function must be called only once before
   any work with the abstract data. */

static void
initiate_syntax_errors (void)
{
  last_syntax_error_message = NULL;
}

/* The following function flushes saved syntax error message, if
   any. */

static void
flush_syntax_error (void)
{
  if (last_syntax_error_message != NULL)
    {
      error (FALSE, first_syntax_error_position,
             "%s", last_syntax_error_message);
      last_syntax_error_message = NULL;
    }
}

/* The following function is called by `yyparse' on syntax error.
   This function flushes saved syntax error message with the aid of
   `flush_syntax_error' and saves message given as parameter and
   `current_lexema position' as its position (see scanner). */

yyerror (const char *message)
{
  flush_syntax_error ();
  last_syntax_error_message = message;
  first_syntax_error_position = current_lexema_position;
  return 0;
}

/* The following function rewrites saved syntax error message but does
   not change saved position. */

static void
syntax_error (const char *s)
{
  last_syntax_error_message = s;
}

/* The following function finishes work with the abstract data
   (flushes saved syntax error message with the aid of function
   `flush_syntax_error'). */

static void
finish_syntax_errors (void)
{
  flush_syntax_error ();
}



/* This page contains all external functions of parser. */

/* The following function initiates all internal abstract data (the
   scanner and `syntax_errors').  The function must be called only
   once before any work with the abstract data. */

void
initiate_parser (void)
{
  initiate_scanner ();
  initiate_syntax_errors ();
}

/* The following function forces to tune parser onto new file (calls
   functions `flush_syntax_error' from abstract data `syntax_errors'
   and `start_scanner_file'). */

void
start_parser_file (const char *new_file_name, position_t error_position)
{
  flush_syntax_error ();
  start_scanner_file (new_file_name, error_position);
}

/* This function is called after processing lexema END_OF_BASIC_FILE
   (see above).  The function calls functions `flush_syntax_error' and
   `finish_scanner_file'. */

static void
finish_parser_file (void)
{
  flush_syntax_error ();
  finish_scanner_file ();
}

/* This function finishes all internal abstract data (the scanner and
   abstract data `syntax_errors').  Only call of function
   `initiate_parser' is possible immediately after this function
   call. */

void
finish_parser (void)
{
  finish_scanner ();
  finish_syntax_errors ();
}

/*
Local Variables:
mode:c
End:
*/
